  '----------------
  sub partno(sys n)
  '================
    if picklevel then glLoadName n
  end sub

  '--------------------
  sub orthopersp(sys p)
  '====================
  '
  double m,n
  n=orthosize
  m=n*aspect
  '
  if p then
    glOrtho  -m, m, -n, n, 1.0, 100.0 'left right bottom top near far
  else
    'gluPerspective 45.0, aspect, 1, 100.0 'viewAngle,aspect,near,far
    single xmin, xmax, ymin, ymax
    single znear=1,zfar=100.0,fovy=45.0
    ymax = zNear * tan(fovy *pi /360.0)
    ymin = -ymax
    xmin = ymin * aspect
    xmax = ymax * aspect
    glFrustum xmin, xmax, ymin, ymax, zNear, zFar
  end if
  end sub
  '
  '-----------------------
  sub SetProjection(sys p)
  '=======================
  '
  glMatrixMode GL_PROJECTION
  glLoadIdentity
  orthopersp(p)
  glMatrixMode GL_MODELVIEW
  glLoadIdentity
  end sub

  '---------------------
  sub StandardMaterial()
  '=====================
  local as single,
  
  surface_ambient(4)  => (MaterialAmbient),
  surface_diffuse(4)  => (MaterialDiffuse),
  surface_specular(4) => (MaterialSpecular),
  surface_shininess=MaterialShininess
  '
  'Set model color (used for orthogonal views, lighting disabled)
  '---------------
  '
  glColor4fv surface_diffuse

  'Set model material (used for perspective view, lighting enabled)
  '------------------
  '
  glMaterialfv GL_FRONT, GL_AMBIENT,   surface_ambient
  glMaterialfv GL_FRONT, GL_DIFFUSE,   surface_diffuse
  glMaterialfv GL_FRONT, GL_SPECULAR,  surface_specular
  glMaterialf  GL_FRONT, GL_SHININESS, surface_shininess
  end sub
  '
  '
  '--------------------------
  sub SetMaterial(single* ma)
  '==========================
  glMaterialfv GL_FRONT, GL_AMBIENT,   ma[1]
  glMaterialfv GL_FRONT, GL_DIFFUSE,   ma[5]
  glMaterialfv GL_FRONT, GL_SPECULAR,  ma[9]
  glMaterialf  GL_FRONT, GL_SHININESS, ma[13]
  end sub



  '---------------
  sub RenderView()
  '===============

  glPushMatrix

  glscalef sca_a, sca_a, sca_a
  
  glTranslatef tra_x, tra_y, tra_z
 
  glRotatef rot_x, 1.0, 0.0, 0.0
  glRotatef rot_y, 0.0, 1.0, 0.0
  glRotatef rot_z, 0.0, 0.0, 1.0
  
  StandardMaterial()

  Scenes 'MACRO

  glPopMatrix

  '
  end sub



  '--------------------
  sub PickPrep() as sys
  '====================
  '
  glInitNames()
  glSelectBuffer (SelectBufSize, selectBuf)
  '
  glRenderMode(GL_SELECT)
  '
  glPushName(-1) 'an arbitrary value
  '
  glMatrixMode(GL_PROJECTION)
  glLoadIdentity()
  gluPickMatrix( mposx, mposy, 2.0, 2.0, @viewport) 'pixel selection zone
  orthopersp projmode
  glMatrixMode(GL_MODELVIEW)
  glpushmatrix
  end sub



  '---------------------------
  function PickResult() as sys
  '===========================
  '
  SelObject=0
  glPopName()
  hits=glRenderMode(GL_RENDER)
  '
  '--------------------
  'nearest named object
  '--------------------
  '
  sys v=0x7fffffff, w=-1, i=1, c=hits*4
  '
  while i<c
   '
   if nearest then
     if SelectBuf(i+1)<=v then
       v=SelectBuf(i+1)
       w=SelectBuf(i+3) 'resolve by depth order
     end if
   else
     if SelectBuf(i+3)>w then
       w=SelectBuf(i+3) 'resolve by name order
     end if
   end if
   '
   i+=SelectBuf(i)+3
   '
  wend
  '
  if w>=0 then SelObject=w
  '
  SetProjection projmode
  glPopMatrix
  '
  return w
  '
  end function



  '--------------------------------------
  sub SelectPixelFormat(sys hdc, *choice)
  '======================================

  'setup pixel format

  PIXELFORMATDESCRIPTOR pfd
  sys n
  '
  pfd.nSize           = sizeof PIXELFORMATDESCRIPTOR 'Size of UDT structure
  pfd.nVersion        = 1                            'Version. Always set to 1.
  pfd.dwFlags         = PFD_DRAW_TO_WINDOW or _      'Support Window
                        PFD_SUPPORT_OPENGL or _      'Support OpenGL
                        PFD_DOUBLEBUFFER             'Support Double Buffering
  pfd.iPixelType      = PFD_TYPE_RGBA                'Red, Green, Blue, & Alpha Mode
  pfd.cColorBits      = 32                           '32-Bit Color Mode
' pfd.cRedBits        = NULL                         'Ignore Color and Shift Bits...
' pfd.cRedShift       = NULL                         '...
' pfd.cGreenBits      = NULL                         '...
' pfd.cGreenShift     = NULL                         '...
' pfd.cBlueBits       = NULL                         '...
' pfd.cBlueShift      = NULL                         '...
' pfd.cAlphaBits      = NULL                         'No Alpha Buffer
' pfd.cAlphaShift     = NULL                         'Ignore Shift Bit.
' pfd.cAccumBits      = NULL                         'No Accumulation Buffer
' pfd.cAccumRedBits   = NULL                         'Ignore Accumulation Bits...
' pfd.cAccumGreenBits = NULL                         '...
' pfd.cAccumBlueBits  = NULL                         '...
' pfd.cAccumAlphaBits = NULL                         '... Good Cereal! ;)
  pfd.cDepthBits      = 16                           ' bits z-buffer depth 8 16 24
  pfd.cStencilBits    = 1                            'Stencil Buffer
  pfd.cAuxBuffers     = NULL                         'No Auxiliary Buffer
  pfd.iLayerType      = PFD_MAIN_PLANE               'Main Drawing Plane
' pfd.bReserved       = NULL                         'Reserved
' pfd.dwLayerMask     = NULL                         'Ignore Layer Masks...
' pfd.dwVisibleMask   = NULL                         '...
' pfd.dwDamageMask    = NULL                         '...
  '
  n = ChoosePixelFormat hDC, @pfd 'First without multisampling
  '
  SetPixelFormat hDC, n, @pfd
  '
  '
  end sub


  '-------------------------------
  sub BuildFont (sys hWnd,hDC,hRC)
  '===============================
  sys    glFontHandle
  LOGFONT glFont
  '
  glFont.lfHeight         = 1                             'Height Of Font
  glFont.lfWeight         = FW_BOLD                       'Font Weight
  glFont.lfCharSet        = ANSI_CHARSET                  'Character Set Identifier
  glFont.lfOutPrecision   = OUT_TT_PRECIS                 'Output Precision
  glFont.lfClipPrecision  = CLIP_DEFAULT_PRECIS           'Clipping Precision
  glFont.lfQuality        = ANTIALIASED_QUALITY           'Output Quality
  glFont.lfPitchAndFamily = FF_DONTCARE or DEFAULT_PITCH  'Family And Pitch
  '
  'copy0 & glFont.lfFaceName, "Lucida Console" ' "Consolas" ' "Courier New"    'Font Name
  sys p
  p=@ glFont.lfFaceName
  zstring z at  p '& glFont.lfFaceName itr
  z="Lucida Console"
  '

  glFontHandle = CreateFontIndirect(@glFont)
  glFontHandle = SelectObject(hDC, glFontHandle)
  '
  wglUseFontOutlinesA (hDC, 0, 255, 1000, 0.0, 0.2, WGL_FONT_POLYGONS, @gmf)
  '
  DeleteObject(glFontHandle)

  end sub


  '--------------------------------
  sub ViewFromHere(double *x,*y,*z)
  '================================
  ppx=mposx
  ppy=mposy
  '
  'glMatrixMode GL_MODELVIEW
  glGetIntegerv(GL_VIEWPORT, viewport)
  glLoadIdentity
  gluLookAt _
  x,    y,   z,    'Eye Position
  0.0,  0.0, 0.0,  'Target View-point
  0.0,  1.0, 0.0   'Up-vector
  '
  'gltranslatef 0,0,-z

  '
  if objectr then
    if picklevel then
      PickPrep
      RenderView
      PickResult
    end if
    RenderView()
  end if
  '
  end sub

  ' DrawBorder() - Draw a 2D border (used for orthogonal views)
  '
  '---------------------------------------------------
  sub DrawBorder( byval gscale as single, st as long )
  '===================================================
  dim as single x,y
  glPushMatrix

  'Setup modelview matrix (flat XY view)
  '
  'glLoadIdentity
  gluLookAt _  
  0.0, 0.0, 1.0, 
  0.0, 0.0, 0.0,
  0.0, 1.0, 0.0
  'We don't want to update the Z-buffer
  '
  glDepthMask GL_FALSE

  'Set color
  '---------
  glDisable GL_LIGHTING
  glColor3f 0.7, 0.7, 0.4
  glBegin GL_LINES

  dim h as long
  h=st*0.5
  x = gscale * h
  y = gscale * h
    
  'Horizontal lines
  '----------------
  
  glVertex3f -x, -y, 0.0
  glVertex3f  x, -y, 0.0
  glVertex3f -x,  y, 0.0
  glVertex3f  x,  y, 0.0

  'Vertical lines
  
  glVertex3f -x, -y, 0.0
  glVertex3f -x,  y, 0.0
  glVertex3f  x, -y, 0.0
  glVertex3f  x,  y, 0.0

  glEnd

  'Enable Z-buffer writing again
  '
  glDepthMask GL_TRUE

  glPopMatrix
  
  end sub



  ' DrawGrid() - Draw a 2D grid (used for orthogonal views)

  '----------------------------------------
  sub DrawGrid( single gscale, long gsteps)
  '========================================

  dim as long i
  dim as single x,y

  glPushMatrix

  'Set background color
  '
  glClearColor 0.15, 0.15, 0.3, 0.0
  glClear GL_COLOR_BUFFER_BIT

  'Setup modelview matrix (flat XY view)
  '
  glLoadIdentity
  gluLookAt _
  0.0, 0.0, 1.0, 
  0.0, 0.0, 0.0,
  0.0, 1.0, 0.0
  '
  'We don't want to update the Z-buffer
  '
  glDepthMask GL_FALSE

  'Set grid color
    
  glDisable GL_LIGHTING
  glColor3f 0.0, 0.5, 0.5

  glBegin GL_LINES

  sys g,h

  g=gsteps
  h=g*0.5
    
  '' Horizontal lines
  
  x = gscale * h
  y = (-gscale) * h
  '
  for i = 0 to g
    glVertex3f -x, y, 0.0
    glVertex3f x, y, 0.0
    y+=gscale
  next

  '' Vertical lines
  
  x = -gscale * h
  y = gscale * h
  '
  for i = 0 to g
    glVertex3f x, -y, 0.0
    glVertex3f x, y, 0.0
    x+=gscale
  next

  glEnd

  'Enable Z-buffer writing again
  '
  glDepthMask GL_TRUE

  glPopMatrix
  
  end sub

