/*  Console for OxygenBasic  by Peter Wirbelauer  14/11/2011  */

% FOREGROUND_BLUE      = 1   
% FOREGROUND_GREEN     = 2  
% FOREGROUND_RED       = 4  

% BACKGROUND_BLUE      = 16
% BACKGROUND_GREEN     = 32 
% BACKGROUND_RED       = 64

% BACKGROUND_INTENSITY = 128
% FOREGROUND_INTENSITY = 8

% BACKGROUND_SEARCH    = 32
% FOREGROUND_SEARCH    = 16

% STD_OUTPUT_HANDLE    =-11
% STD_INPUT_HANDLE     =-10
% STD_ERROR_HANDLE     =-12

% ENABLE_LINE_INPUT    = 2
% ENABLE_ECHO_INPUT    = 4
% ENABLE_MOUSE_INPUT   = 16
% ENABLE_WINDOW_INPUT  = 8

% ENABLE_PROCESSED_INPUT  = 1
% ENABLE_PROCESSED_OUTPUT = 1
% ENABLE_WRAP_AT_EOL_OUTPUT = 2
% CONSOLE_TEXTMODE_BUFFER   = 1

% INVALID_HANDLE_VALUE =-1
% CTRL_BREAK_EVENT     = 1
% CTRL_C_EVENT         = 0

% GENERIC_READ     = 0x80000000
% GENERIC_WRITE    = 0x40000000
% FILE_SHARE_READ  = 1
% FILE_SHARE_WRITE = 2

% MOUSE_MOVED      = 1
% DOUBLE_CLICK     = 2
% MOUSE_WHEELED    = 4  'Horizontal
% MOUSE_HWHEELED   = 8  'vertical

% FROM_LEFT_1ST_BUTTON_PRESSED = 1
% RIGHTMOST_BUTTON_PRESSED     = 2
% FROM_LEFT_2ND_BUTTON_PRESSED = 4
% FROM_LEFT_3RD_BUTTON_PRESSED = 8
% FROM_LEFT_4TH_BUTTON_PRESSED = 16

% WINDOW_BUFFER_SIZE_EVENT = 4
% MOUSE_EVENT   = 2
% KEY_EVENT     = 1

% FF_DECORATIVE = 80
% FF_DONTCARE   = 0
% FF_MODERN     = 48
% FF_ROMAN      = 16
% FF_SCRIPT     = 64
% FF_SWISS      = 32
% LF_FACESIZE   = 32

% CRLF = Chr(10)+Chr(13)

/* FOREGROUND  COLOUR  */
% FG_BLACK   = 0
% FG_DBLUE   = 1  
% FG_DGREEN  = 2
% FG_DCYAN   = 3
% FG_DRED    = 4
% FG_DLILAC  = 5
% FG_DYELLOW = 6
% FG_DWHITE  = 7

% FG_BLUE   = 9  
% FG_GREEN  =10
% FG_CYAN   =11
% FG_RED    =12
% FG_LILAC  =13
% FG_YELLOW =14
% FG_WHITE  =15

/*  BACKGROUND COLOUR  */
% BG_BLACK   = 0 
% BG_DBLUE   =16  
% BG_DGREEN  =32
% BG_DCYAN   =48
% BG_DRED    =64
% BG_DLILAC  =80
% BG_DYELLOW =96
% BG_DWHITE  =112

% BG_BLUE   =144   
% BG_GREEN  =160 
% BG_CYAN   =176 
% BG_RED    =192 
% BG_LILAC  =208 
% BG_YELLOW =224 
% BG_WHITE  =240 

% RIGHT_ALT_PRESSED  = 1
% LEFT_ALT_PRESSED   = 2
% RIGHT_CTRL_PRESSED = 4
% LEFT_CTRL_PRESSED  = 8
% SHIFT_PRESSED      = 16
% NUMLOCK_ON         = 32
% SCROLLLOCK_ON      = 64
% CAPSLOCK_ON        = 128
% ENHANCED_KEY       = 256

Type SECURITY_ATTRIBUTES
  nLength              As Long
  lpSecurityDescriptor As Long
  bInheritHandle       As Long
End Type

Type COORD
  short x 
  short y 
End Type

Type SMALL_RECT
  short Left 
  short Top
  short Right  
  short Bottom 
End Type

Type CONSOLE_CURSOR_INFO
  sys wSize  
  Bool Visible 
End Type

Type CONSOLE_SCREEN_BUFFER_INFO
  COORD dwSize            
  COORD dwCursorPosition    
  word  wAttributes         
  SMALL_RECT srWindow            
  COORD dwMaximumWindowSize 
End Type

Type WINDOW_BUFFER_SIZE_RECORD
  COORD dwSize 
End Type

Type MENU_EVENT_RECORD
  uint dwCommandId 
End Type

Type FOCUS_EVENT_RECORD
  Bool bSetFocus 
End Type

Type MOUSE_EVENT_RECORD
  COORD dwMousePosition
  DWORD dwButtonState
  DWORD dwControlKeyState
  DWORD dwEventFlags
End Type

Type KEY_EVENT_RECORD
  BOOL bKeyDown
  WORD wRepeatCount
  WORD wVirtualKeyCode
  WORD wVirtualScanCode
align 4
	union uChar
  {
	WCHAR UnicodeChar
	CHAR AsciiChar
  }
	DWORD dwControlKeyState
End Type

Type INPUT_RECORD
	WORD EventType
	union Event
  {
	KEY_EVENT_RECORD KeyEvent
	MOUSE_EVENT_RECORD MouseEvent
	WINDOW_BUFFER_SIZE_RECORD WindowBufferSizeEvent
	MENU_EVENT_RECORD MenuEvent
	FOCUS_EVENT_RECORD FocusEvent
  }
End Type

Type CONSOLE_FONT_INFOEX 
  uLong cbSize     
  Dword nFont    
  COORD dwFontSize 
  Long  FontFamily 
  Long  FontWeight 
  wchar FaceName[LF_FACESIZE] 
End Type 

Type CONSOLE_FONT_INFO 
  Dword nFont     
  COORD dwFontSize 
End Type

Declare Function AllocConsole                  Lib "kernel32.dll" () As Long
Declare Function FreeConsole                   Lib "kernel32.dll" () As Long
Declare Function CloseHandle                   Lib "kernel32.dll" (ByVal hObject As Long) As Long
Declare Function GetStdHandle                  Lib "kernel32.dll" (ByVal nStdHandle As Long) As Long
Declare Function WriteConsole                  Lib "kernel32.dll" Alias "WriteConsoleA" (ByVal hConsoleOutput As Long, lpBuffer As Any, ByVal nNumberOfCharsToWrite As Long, lpNumberOfCharsWritten As Long, lpReserved As Any) As Long
Declare Function ReadConsole                   Lib "kernel32.dll" Alias "ReadConsoleA" (ByVal hConsoleInput As Long, ByVal lpBuffer As String, ByVal nNumberOfCharsToRead As Long, lpNumberOfCharsRead As Long, lpReserved As Any) As Long
Declare Function SetConsoleTextAttribute       Lib "kernel32.dll" (ByVal hConsoleOutput As Long, ByVal wAttributes As Long) As Long
Declare Function SetConsoleTitle               Lib "kernel32.dll" Alias "SetConsoleTitleA" (ByVal lpConsoleTitle As String) As Long
Declare Function SetConsoleCursorPosition      Lib "kernel32.dll" (ByVal hConsoleOutput As Long, ByRef dwCursorPosition As COORD) As Long
Declare Function GetConsoleMode                Lib "kernel32.dll" (ByVal hConsoleHandle As Long, ByRef lpMode As Long) As Long
Declare Function SetConsoleMode                Lib "kernel32.dll" (ByVal hConsoleHandle As Long, ByVal dwMode As Long) As Long
Declare Function GenerateConsoleCtrlEvent      Lib "kernel32.dll" (ByVal dwCtrlEvent As Long, ByVal dwProcessGroupId As Long) As Long
Declare Function CreateConsoleScreenBuffer     Lib "kernel32.dll" (ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwFlags As Long, ByRef lpScreenBufferData As Any) As Long
Declare Function SetConsoleActiveScreenBuffer  Lib "kernel32.dll" (ByVal hConsoleOutput As Long) As Long
Declare Function ReadConsoleInput              Lib "kernel32.dll" Alias "ReadConsoleInputA" (ByVal hConsoleInput As Long, ByRef lpBuffer As INPUT_RECORD, ByVal nLength As Long, ByRef lpNumberOfEventsRead As Long) As Long
Declare Function WriteConsoleInput             Lib "kernel32.dll" Alias "WriteConsoleInputA" (ByVal hConsoleInput As Long, ByRef lpBuffer As INPUT_RECORD, ByVal nLength As Long, ByRef lpNumberOfEventsWritten As Long) As Long
Declare Function FillConsoleOutputAttribute    Lib "kernel32.dll" (ByVal hConsoleOutput As Long, ByVal wAttribute As Long, ByVal nLength As Long, ByRef dwWriteCoord As COORD, ByRef lpNumberOfAttrsWritten As Long) As Long
Declare Function FillConsoleOutputCharacter    Lib "kernel32.dll" Alias "FillConsoleOutputCharacterA" (ByVal hConsoleOutput As Long, ByVal cCharacter As Byte, ByVal nLength As Long, ByRef dwWriteCoord As COORD, ByRef lpNumberOfCharsWritten As Long) As Long
Declare Function SetConsoleCursorInfo          Lib "kernel32.dll" (ByVal hConsoleOutput As Long, ByRef lpConsoleCursorInfo As CONSOLE_CURSOR_INFO) As Long
Declare Function GetConsoleCursorInfo          Lib "kernel32.dll" (ByVal hConsoleOutput As Long, ByRef lpConsoleCursorInfo As CONSOLE_CURSOR_INFO) As Long
Declare Function SetConsoleWindowInfo          Lib "kernel32.dll" (ByVal hConsoleOutput As Long, ByVal bAbsolute As Long, ByRef lpConsoleWindow As SMALL_RECT) As Long
Declare Function GetConsoleScreenBufferInfo    Lib "kernel32.dll" (ByVal hConsoleOutput As Long, ByRef lpConsoleScreenBufferInfo As CONSOLE_SCREEN_BUFFER_INFO) As Long
Declare Function SetConsoleScreenBufferSize    Lib "kernel32.dll" (ByVal hConsoleOutput As Long, ByRef dwSize As COORD) As Long
Declare Function GetLargestConsoleWindowSize   Lib "kernel32.dll" (ByVal hConsoleOutput As Long) As COORD
Declare Function SetCurrentConsoleFontEx       Lib "Kernel32.dll" (ByVal hConsoleOutput As Long, ByVal bMaximumWindow As Bool, ByRef lpConsoleCurrentFontEx As CONSOLE_FONT_INFOEX) As Long 
Declare Function GetCurrentConsoleFontEx       Lib "Kernel32.dll" (ByVal hConsoleOutput As Long, ByVal bMaximumWindow As Bool, ByRef lpConsoleCurrentFontEx As CONSOLE_FONT_INFOEX) As Long 
Declare Function GetConsoleFontSize            Lib "Kernel32.dll" (ByVal hConsoleOutput As Long, ByVal nFont As Long) As COORD
Declare Function GetCurrentConsoleFont         Lib "Kernel32.dll" (ByVal hConsoleOutput As Long, ByVal bMaximumWindow As Bool, ByRef lpConsoleCurrentFont As CONSOLE_FONT_INFO) As Long 
Declare Function PeekConsoleInput              Lib "kernel32.dll" Alias "PeekConsoleInputA" (ByVal hConsoleInput As Long, ByRef lpBuffer As INPUT_RECORD, ByVal nLength As Long, ByRef lpNumberOfEventsRead As Long) As Long
Declare Function FlushConsoleInputBuffer       Lib "kernel32.dll" (ByVal hConsoleInput As Long) As Long
Declare Function GetNumberOfConsoleInputEvents Lib "kernel32.dll" (ByVal hConsoleInput As Long, ByRef lpNumberOfEvents As Long) As Long

Declare Function GetAsyncKeyState Lib "user32.dll"   (ByVal vKey As Long) As Integer
Declare Function GetKeyState      Lib "user32.dll"   (ByVal nVirtKey As Long) As Integer
Declare Function FormatMessage    Lib "kernel32.dll" Alias "FormatMessageA" (ByVal dwFlags As Long, ByRef lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, ByRef Arguments As Long) As Long
Declare Function GetLastError     Lib "kernel32.dll" () As Long
Declare Function timeGetTime      Lib "winmm.dll"    () As Long
Declare Sub      Sleep            Lib "kernel32.dll" (ByVal dwMilliseconds As Long)
Declare Sub      ExitProcess      Lib "kernel32.dll" (ByVal uExitCode As Long)

Dim Cord     As COORD
Dim sRect    As SMALL_RECT 
Dim CurInfo  As CONSOLE_CURSOR_INFO
Dim ScrInfo  As CONSOLE_SCREEN_BUFFER_INFO
Dim Wbsr     As WINDOW_BUFFER_SIZE_RECORD
Dim FontInfo As CONSOLE_FONT_INFO

sys hOut, hIn, CtrlKey, Seed, MouseButton  
short TextWidth,TextHeight,FontWidth,FontHeight,ScreenWidth,ScreenHeight,ScanKey
short xMouse, yMouse
bool KeyDown, char CharKey
 
Function CapsLock() as sys
    Return GetKeyState(20) & 1   
End Function

Function EscKey() As sys
    Return GetAsyncKeyState(27)
End Function

Function WaitKey(sys wKey) as sys
    While GetAsyncKeyState(wKey)=0
    Wend
    While GetAsyncKeyState(wKey)<0
    Wend
    Return 1
End Function    
 
Function Key(sys cKey) As sys
    Return GetAsyncKeyState(cKey)
End Function

Sub CursorPos(word x, y)
    Cord.x = x
    Cord.y = y
    push cord 
    push hOut
    call SetConsoleCursorPosition
End Sub

Sub Text(string txt, word x,y, color)
    SetConsoleTextAttribute hOut,color
    CursorPos x,y
    WriteConsole hOut, *txt, Len(txt),0,0
End Sub

Sub Say(string txt, word color)
    SetConsoleTextAttribute hOut,color
    WriteConsole hOut, *txt, Len(txt),0,0
End Sub    
    
Sub SetConsole(string title) 
    AllocConsole()
    hOut= GetStdHandle(STD_OUTPUT_HANDLE)
    hIn = GetStdHandle(STD_INPUT_HANDLE) 
    SetConsoleTitle Title    
    fdwMode=SetConsoleMode hOut,ENABLE_MOUSE_INPUT | ENABLE_WINDOW_INPUT
    SetConsoleMode(hIn, fdwMode)
    GetConsoleScreenBufferInfo hOut, ScrInfo
    ScreenWidth = ScrInfo.dwSize.x
    ScreenHeight= ScrInfo.dwSize.y
    Seed = timeGetTime  
End Sub

Sub CloseConsole()
    CloseHandle hOut
    CloseHandle hIn
    FreeConsole
End Sub

Sub Cls(word color)
    GetConsoleScreenBufferInfo  hOut, ScrInfo
    Length= ScrInfo.dwSize.x * ScrInfo.dwSize.y
    cord.x=0: cord.y=0
    push  0
    push  cord
    push  Length 
    push  color
    push  hOut
    call  FillConsoleOutputAttribute 
    push  0
    push  cord
    push  Length
    push  32
    push  hOut
    call FillConsoleOutputCharacter   
End Sub

Sub CursorSize(sys size)
    GetConsoleCursorInfo hOut,CurInfo
    curInfo.wSize = size
    SetConsoleCursorInfo hOut, curInfo
End Sub

Sub CursorVisible(bool visible)
    GetConsoleCursorInfo hOut,CurInfo
    CurInfo.Visible = visible 
    SetConsoleCursorInfo hOut,CurInfo
End Sub

Sub SetConsoleFont(word width, height) 
    Dim FontEx as CONSOLE_FONT_INFOEX
    GetCurrentConsoleFont hOut, 0, FontInfo
    FontEx.cbSize       = SizeOf (CONSOLE_FONT_INFOEX) 
    FontEx.dwFontSize.x = width
    FontEx.dwFontSize.y = height
    FontEx.FontWeight   = 0
    FontEx.nFont        = FontInfo.nFont
    FontEx.FontFamily   = FF_DONTCARE
    FontEx.FaceName     = "ROMAN" 
    SetCurrentConsoleFontEx hOut, 0, FontEx
    FontWidth = FontEx.dwFontSize.x 
    FontHeight= FontEx.dwFontSize.y
End Sub

Sub SetConsoleSize(short width, height)
    Dim smRec as SMALL_RECT
    Dim koord as COORD
    smRec.Left   =0
    smRec.Top    =0
    smRec.Right  = width -1
    smRec.Bottom = height-1
    SetConsoleWindowInfo hOut, 1, smRec
    koord.x = width
    koord.y = height
    SetConsoleScreenBufferSize hOut, koord
    TextWidth = Width
    TextHeight= height
End Sub 

Function Rand(sys z1, z2) As sys
     sys    rnd 
     mov    eax,z2
     sub    eax,z1
     inc    eax
     imul   edx,Seed,0x8088405
     inc    edx
     mov    Seed,edx
     mul    edx
     add    edx,z1
     mov    rnd,edx
     Return rnd
End Function 

Sub Point(string txt, word x,y,c)
    Text txt,x,y,c
End Sub

Sub Ellipse(string txt,word mx, my, a, b, color)
    sys x, mx1 ,mx2, my1, my2
    sys aq, bq, idx, idy, r, rx, ry
    Text txt, mx + a, my, color
    Text txt, mx - a, my, color
    mx1 = mx - a: my1 = my
    mx2 = mx + a: my2 = my
    aq  = a*a: bq = b*b      
    idx = aq*2: idy = bq*2               
    r = a*bq: rx = r*2                
    ry =0: x = a                      
    While x >0
      iF r >0
         my1 +=1: my2 -=1: ry += idx 
         r -= ry             
      End iF
      iF r <=0
        x -=1: mx1 +=1: mx2 -=1
        rx -= idy: r += rx
      End iF
      Text txt,mx1, my1, color
      Text txt,mx1, my2, color
      Text txt,mx2, my1, color
      Text txt,mx2, my2, color
    Wend  
End Sub 

Sub Line(string txt, word x1, y1, x2, y2, col)
    sys i,deltaX,deltaY,pixel,d,dinc1,dinc2 
    sys x,xinc1,xinc2,y,yinc1,yinc2 
    deltaX = Abs (x2-x1): deltaY = Abs (y2-y1)
    iF deltaX >= deltaY
       pixel = deltaX +1
       d = (2* deltaY) - deltaX
       dinc1 = deltaY *2
       dinc2 = (deltaY - deltaX) *2
       xinc1 = 1
       xinc2 = 1
       yinc1 = 0
       yinc2 = 1
    Else
       pixel = deltaY +1
       d = (2 * deltaX)-deltaY
       dinc1 = deltaX *2                
       dinc2 = (deltaX-deltaY) *2      
       xinc1 = 0
       xinc2 = 1
       yinc1 = 1
       yinc2 = 1
    End iF
    iF x1 > x2 
       xinc1 = - xinc1
       xinc2 = - xinc2
    End iF
    iF y1 > y2 
       yinc1 = - yinc1
       yinc2 = - yinc2
    End iF
    x = x1
    y = y1
    For i =1 To pixel 
       Text txt, x, y, col
       iF d < 0 
          d = d + dinc1
          x = x + xinc1
          y = y + yinc1
       Else
          d = d + dinc2
          x = x + xinc2
          y = y + yinc2
       End iF
    Next
End Sub    