
'-------------------------------------
function charwidth(a as sys) as string
'=====================================
  if cpuw=4 then
    function="mov dl,"+str(a)+cr
  else
    function="mov r10,"+str(a)+cr
  end if
end function

'-------------
sub regnames()
'=============
  if cpuw=4 then
    '
    qeax="eax" : peax="[eax]" : pusheax="push eax"+cr : popeax="pop eax"+cr
    qecx="ecx" : pecx="[ecx]"
    qedx="edx"
    qebx="ebx"
    qesp="esp" : pesp="[esp]"
    qebp="ebp"
    qesi="esi"
    qedi="edi" : pedi="[edi]"
    ledi="lea edi,"
    spw1="esp,4"
    spw2="esp,8"
    'CPU
    regn(3)=qesi : regn(4)=qedi
    'FLOATS MUST BE PASSED BYREF
    '
    'REGISTER PARAM MACROS FOR CPU CALLING
    '-------------------------------------
    '
    rgp(0)="mov eax,"
    rgp(1)="mov ecx,"
    rgp(2)="mov edx,"
    rgp(3)="mov esi,"
    rgp(4)="mov edi,"
    rgp(8)="movups xmm0,"
    rgp(9)="movups xmm1,"
    rgp(10)="movups xmm2,"
    rgp(11)="movups xmm3,"
    '
  else 'cpuw=8 'MS
    '
    qeax="rax" : peax="[rax]" : pusheax="push rax"+cr : popeax="pop rax"+cr
    qecx="rcx" : pecx="[rcx]"
    qedx="rdx"
    qebx="rbx"
    qesp="rsp" : pesp="[rsp]"
    qebp="rbp"
    qesi="rsi"
    qedi="rdi" : pedi="[rdi]"
    ledi="lea rdi,"
    spw1="rsp,8"
    spw2="rsp,16"
    'CPU
    regn(3)="r8" : regn(4)="r9"
    'FLOATS
    regn(8)="xmm0" : regn(9)="xmm1" : regn(10)="xmm2" : regn(11)="xmm3"
    '
    'REGISTER PARAM MACROS FOR MS64
    '------------------------------
    '
    rgp(0)="mov rax,"
    rgp(1)="mov rcx,"
    rgp(2)="mov rdx,"
    rgp(3)="mov r8,"
    rgp(4)="mov r9,"
    rgp(8)="movups xmm0,"
    rgp(9)="movups xmm1,"
    rgp(10)="movups xmm2,"
    rgp(11)="movups xmm3,"
    '
  end if
  '
  regn(0)=qeax : regn(1)=qecx : regn(2)=qedx
  '
  'O2 LIBRARY / GLOBAL / STATIC REGISTER
  '
  regss=qebx : regsl=qebp : regs=regss
  '
end sub


'---------------------------
sub cpus(byref wr as string)
'===========================
  dim as sys a
  a=wval(wr)
  if a then
    pem=a
    if a=64 then cpuw=8 else cpuw=4
    regnames() 'SET 32/64 BIT REG NAMES
  end if
end sub


'--------------------------------------------
function leaedi(byref wr as string) as string
'============================================
  if wr<>pedi then function=ledi+wr+cr
end function


'--------------------------------------
function rtl(byval p as sys) as string
'======================================
  function="call "+memreg(qebx,p)
end function

'--------------------------------------------
sub indir(byref wr as string, byval n as sys)
'============================================
  '
  if n then wpfx+="mov "+qedi+cm+wr+cr
  if n>1 then wpfx+=repeat("mov "+qedi+cm+pedi+cr,n-1)
  '
end sub


'-----------------------------------------------------------
function memregsl(byval d as sys, byval pn as sys) as string
'===========================================================
  '
  'FOR 64 BIT MODE ONLY
  'SPILL REG PARAMS INTO STACK MEMORY
  '
  dim as sys i,a,e,f,g
  dim as string w1,w2,w3
  e=pn
  if e>4 then e=4
  w1+=cr
  for i=1 to e
    if isfloat(typl(i)) then
      g=i : i=e
      w1+="_sp -16"+cr 'RESERVE TRANSFER SPACE
    end if
  next
  for i=1 to e
    a=typl(i) : f=i
    '
    'SPILL FLOAT INTO CPU REG
    '
    if isfloat(a) then
      w3="movups [rsp],"+regn(f+7)+cr
      if (a and 31)=8 then mid(w3,6)="d" 'double
      w1+=w3+"mov "+regn(f)+cm+"[rsp]"+cr
    end if
    '
    'SPILL REG INTO SHADOW SLOT
    '
    w1+="mov "+memreg(qebp,d)+cm+regn(f)+cr
    '
    d+=8
  next
  if g then
    w1+="_sp 16"+cr 'RELEASE TRANSFER SPACE
  end if
  function=w1
end function


'--------------------------------
function preserveregs() as string
'================================
  if cpuw=4 then
    function="push ebx"+cr+"push esi"+cr+"push edi"+cr+"call _mem"+cr
  else
    function="push rbx"+cr+"push rsi"+cr+"push rdi"+cr+"push r15"+cr+"lea rip rbx,bssdata"+cr
  end if
end function


'--------------------------------------------------------------------
function makelocalspace(byval pn as sys, byval leaf as sys) as string
'====================================================================
  dim as sys a
  dim as string w1
  if cpuw=4 then
    w1="push ebp"+cr+"mov ebp,esp"
  else
    '
    w1="push rbp"+cr+"mov rbp,rsp"
    '
    if leaf=0 then
      '
      'STORE REG PARAMS ONTO STACK
      '
      'but only necessary for external procs
      '
      a=16
      '
      if atf(funi) then
        a=48
        w1+=memregsl(a,pn) 'SPILL REG PARAMS
      end if
      '
    else
      lcl(funi)=0 'ASSUME NO LOCALS
    end if
  end if
  '
  '
  'patch in reserved local space later
  '-----------------------------------
  '
  if cpuw=4 then
    function=w1+cr+"sub "+qesp+cm+"64"+space(8)
  else
    function=w1+cr+"_sp -64"+space(8)
  end if
  '
end function


'--------------------------------
function restorestack() as string
'================================
  '
  if cpuw=4 then
    function="mov esp,ebp"+cr+"pop ebp"+cr
  else
    function="mov rsp,rbp"+cr+"pop rbp"+cr
  end if
  '
end function


'-------------------------------
function restoreregs() as string
'===============================
  if cpuw=4 then
    function="pop edi"+cr+"pop esi"+cr+"pop ebx"+cr
  else
    function="pop r15"+cr+"pop rdi"+cr+"pop rsi"+cr+"pop rbx"+cr
  end if
end function




'=======================
' IDENTIFY x86 REGISTERS
'=======================


'DETECT XMMX OR MMX REGISTER

'----------------------------------------------------------
function xmmxid( byval w as string, byref ds as sys) as sys
'==========================================================
  '
  'XMM MM MMX
  '
  dim as sys a=asc(w),b=1,e=len(w)
  ds=0 : rexi=0 : function=-1
  if (a<97)or(e>5)or(e<3) then exit function
  if a=&h78 then ds=1 : b+=1
  if (asc(w,b)<>&h6d)or(asc(w,b+1)<>&h6d) then exit function
  a=asc(w,e)-48
  if (a>=0)and(a<10) then
    if asc(w,e-1)=49 then a+=10
    if (a>=0)and(a<16) then
      if a>=8 then rexi=1
      function=a
    end if

  end if
  '
end function

'--------------------------------------------------------
function regid(byref wr as string, byref l as sys) as sys
'========================================================
  dim as sys a,b,v=-1
  dim as string s
  l=0 : a=lookupm(wr) : rexi=0
  if a then
    if maco(a,0)=-10 then
      s=macso(a,1)
      b=valchahex(s,3)
      if b=9 then rexi=1 : b=1
      if b=1 then l=valchahex(s,1) : v=valchahex(s,2)
      if l=15 then l=16
    end if
  end if
  function=v
end function


'DETECT CONTROL,DEBUG AND SEGMENT REGISTERS
'
'---------------------------------------------------------
function sregid(byref w as string, byref ds as sys) as sys
'=========================================================
  '
  dim as sys a,b,rg
  dim as string s
  ds=0 : rg=-1 : rexi=0 : a=lookupm(w)
  if a=0 then goto xsreg
  if maco(a,0)<>-10 then goto xsreg
  s=macso(a,1)
  b=valchahex(s,3) : if b>4 then rg=valchahex(s,2) : ds=b+124
  xsreg:
  function=rg
  '
end function


'---------------------------------------------------------------------------
sub VTEntry(byref buil as string, wn as string, ws as string,byval w as sys)
'===========================================================================
  if cpuw=4 then
    buil+="o2 e8 00 00 00 00 58 05 gl "+wn+ws+" 83 c0 06 "+cr+_
    "mov [ecx+"+str(w)+"],eax 'METHOD PTR"+cr 'table build (fwd ref )
  else
    buil+="lea rip rax,"+wn+ws+cr+"mov [rcx+"+str(w)+"],rax 'METHOD PTR"+cr
  end if
end sub



'------------------------------------------------------------------------------------------------------
function addtablesection(byref wr as string, byval w as sys, byval a as sys, byval ao as sys) as string
'======================================================================================================
  '
  dim as sys k
  dim as string w1
  k=lookupm(wr+"_table") : w1=macso(k,1)
  if cpuw=4 then
    function="'ADD TABLE SECTION:"+cr+_
    "lea edx,"+memreg(regss,ao+w)+cr+"lea edi,"+w1+cr+"mov ecx,"+str(maco(a,4))+cr+_
    "("+cr+"mov eax,[edi]"+cr+"mov [edx],eax"+cr+"add edi,4"+cr+"add edx,4"+cr+"dec ecx"+cr+"ja repeat"+cr+")"+cr
  else
    function="'ADD TABLE SECTION:"+cr+_
    "lea rdx,"+memreg(regss,ao+w)+cr+"lea rdi,"+w1+cr+"mov rcx,"+str(maco(a,4))+cr+_
    "("+cr+"mov rax,[rdi]"+cr+"mov [rdx],rax"+cr+"add rdi,8"+cr+"add rdx,8"+cr+"dec rcx"+cr+"ja repeat"+cr+")"+cr
  end if
  '
end function



'------------------------------------------------
sub decidecop(byref op as sys, byval tp as sys)
'================================================
  '
  '
  'COMPAT INC FF C0 : NOT 40
  ' sig/cpu  sig  usig/fpu
  '-------------------
  ' op=&h14  z   z  =
  ' op=&h15  nz  nz <>
  ' op=&h1c  l   b  <
  ' op=&h1d  ge  ae >=
  ' op=&h1e  le  be <=
  ' op=&h1f  g   a  >
  '-------------------
  '
  '
  'ALTER OP FOR FPU AND UNSIGNED CPU TYPES
  '
  '-------------------unsigned integer or any float
  ' op=&h12  b   <
  ' op=&h13  ae  >=
  ' op=&h16  be  <=
  ' op=&h17  a   >
  '-------------------signed equiv
  ' op=&h1c  l   b  <
  ' op=&h1d  ge  ae >=
  ' op=&h1e  le  be <=
  ' op=&h1f  g   a  >
  '-------------------patch
  '
  if tp>=&h20 then
    '
    asm
    xor eax,eax
    mov ecx,[op] 'byref
    mov al,[ecx] 'op
      cmp al,&h1c
      jnz encoc1
      mov al,&h12
      jmp encoc
      '
      encoc1:
      cmp al,&h1d
      jnz encoc2
      mov al,&h13
      jmp encoc
      '
      encoc2:
      cmp al,&h1e
      jnz encoc3
      mov al,&h16
      jmp encoc
      '
      encoc3:
      cmp al,&h1f
      jnz encoc4
      mov al,&h17
      jmp encoc
      '
      encoc4:
    encoc:
    mov [ecx],eax
    end asm
    '
    '
  end if
end sub


'------------------------------------------------------------
function comparet(byref op as sys, byval tp as sys) as string
'============================================================
  '
  '
  'AFTER COMPARISONS: eg: wi="cmp "+pesp+",eax"
  '
  ' mov eax,-1
  ' jcond fwd nok
  ' inc eax
  ' .nok
  '
  dim as sys a,b
  dim as string w1
  '
  decidecop(op,tp)
  if cpuw=4 then
    w1="o2 b8 nl-1 75 02 ff c0 "+cr ' eg: true if equal
    a=13
  else
    w1="o2 48 c7 c0 nl-1 75 03 48 ff c0 "+cr ' eg: true if equal
    a=19
  end if
  if op<>&h15 then mid(w1,a)=hex(op-&h10)
  '
  function=w1
end function


'---------------------------------------------------------------------------------------------------------
sub atadd(byref s as string, byref i as sys, byref wsig as string, byref w1 as string, byref w4 as string)
'=========================================================================================================
  if ascw<>91 then
    if (ascn=43)or(ascn=45) then
      inserts(s,w1,i) : dv=metaval(s,i,w1) 'ABSOLUTE VECTOR FIXED AT COMPILE TIME
    end if
    w1="["+w1+"]"
  end if
  '
  'ABSOLUTE ADDRESS MACRO
  '----------------------
  '
  'for runtime library: [ebx+nnnn]
  '
  'PROVIDE ADDRESS FOR HOST VARIABLE
  '
  w1=cr+"mov "+w1+cm+qeax+cr+eq+cr
  '
  if cpuw=4 then
    w4=sq+"call fwd here : .here : pop eax : sub eax,here : add eax,"+wsig+w1
    'w4=sq+"o2 e8 hl0 58 05 gl "+wsig+" 83 c0 06 "+w1
  else
    w4=sq+"lea rip rax,"+wsig+w1
  end if
  '
end sub



'-----------------------------------------------------------------
function stackspace(byval a as sys, byval noinit as sys) as string
'=================================================================
  '
  'min cpuw bytes : steps of cpuw ' 4 or 8 bytes
  '
  dim as sys b,c,i
  dim as string w1
  '
  if a<=0 then exit function
  '
  '
  'ROUND UP TO MAINTAIN STACK ALIGNMENT
  '------------------------------------
  '
  roundup(a,cpuw)
  '
  mlcl(funi)+=a
  '
  '
  if noinit then exit function
  '
  if cpuw=4 then
    '
    w1=ledi+"[ebp"+str(aoff)+"]"+cr+"xor eax,eax"+cr
    '
    if a<=4 then
      function=w1+"mov [edi],eax"+cr
    elseif a<=8 then
      function=w1+"mov [edi],eax"+cr+"mov [edi+4],eax"+cr
    elseif a<=12 then
      function=w1+"mov [edi],eax"+cr+"mov [edi+4],eax"+cr+"mov [edi+8],eax"+cr
    else
      function=w1+"mov ecx,"+str(a-4)+cr+_
      "("+cr+"mov [edi+ecx],eax"+cr+"sub ecx,4"+cr+"jge repeat"+cr+")"+cr
    end if
    '
  else
    '
    w1="lea rdi,[rbp"+str(aoff)+"]"+cr+"xor rax,rax"+cr
    '
    if a<=32 then
      for i=0 to a-1 step 8
        w1+="mov "+memreg(qedi,i)+cm+qeax+cr
      next
      function=w1
    else
      function=w1+"mov r10,"+str(a-8)+cr+_
      "("+cr+"mov [rdi+r10],rax"+cr+"sub r10,8"+cr+"jge repeat"+cr+")"+cr
    end if
    '
  end if
end function


'---------------------------------------------
function stodata(byref wr as string) as string
'=============================================
  dim as sys a,b,q,le
  dim as string w1,w2,co
  if nsto then exit function
  'datc+=1
  q=isq(ascw)
  le=len(wr)
  if q then
    le-=2
    wr+=" hl0"
  end if
  if cpuw=8 then w2=" 48" 'pointer returned in 64 bit rax instead of 32 bit eax
  '
  if dep then
    function="o2 "+sp+"e8 hl0 58 e9 gf _e_"+cr+_
    "hl"+hex(le)+cr+wr+cr+"._e_"+cr+w2+" 83 c0 0a"+ep
  else
    datc+=1
    w1=hex(datc)
    ape(dats,dati," gd "+w1+hexl(le)+" "+wr+cr) 'add to data
    function="o2"+w2+" 8D 83 gc "+w1+cr 
    'eventually mov eax/rax,[ebx/rbx-????]
  end if
end function








'
' ######## TRAN  #########
' #      #=======#       #
' ########       #########
'                #       #
'                #########
'                #       #
'                #########
'                #       #
'                #########
'                #       #
'                #########
'                #       #
'                #########
'
'
'---------------------------------------------------------------------------
function ins(byval op as sys, byval tp as sys, byref wk as string) as string
'===========================================================================
  '
  dim as sys a,b,c,l,m,v,w,boo
  dim as any ptr p
  dim as string w1,w2,w3,wr,wi,rg,rg2,wp,wv,f,wq
  wv=wk
  if op=0 then op=1
  if (op=-1)or(tp>=512) then exit function
  c=asc(wv)
  '
  'if tp=0 then tp=cpuw
  '
  '------------
  'HIGHER TYPES
  '============
  '
  'higher ops are not processed here
  '
  '
  '
  'TYPE EXCLUDING LENGTH BITS
  '--------------------------
  '
  b=tp and &h1e0
  '
  'TYPE LENGTH
  '-----------
  '
  l=tp and 31
  'if l=0 then l=cpuw
  '
  '
  'IMPLICIT OPERAND SIZE
  '---------------------
  '
  '
  if tp=&h6a then l=12 : wr="eword" 'STACK SPACE FOR FPU EXTENDED TYPE
  '
  '
  '
  '=========
  'CPU TYPES
  '=========
  '
  '
  if b<&h40 then
    '
    if c=127 then wv=pesp
    '
    '----------------------
    'QUAD(64mode) LONG SHORT & BYTE
    '----------------------
    '
    if l=0 then l=cpuw
    '
    '
    if l<4 then if (op>=4)and(op<=6) then l=4
    '
    if l=1 then
      rg=" al" : rg2="cl"
    elseif l=2 then
      rg=" ax" : rg2="cx"
    elseif l=4 then
      rg="eax" : rg2="ecx"
    elseif l=8 then
      rg="rax" : rg2="rcx"
    end if
    '
    if c=129 then wv=rg2
    '
    'NUMBERS
    '-------
    '
    if isn(c) then
      '
      'itr short & byte
      '
      if op=4 then 
        wi="push "+wv : goto xop
      end if
      '
      if op=42 then
        wi="imul "+rg+cm : goto xopv
      end if
      '
      if (op=47)or(op=92) then
        '
        'SIGN EXTEND INTO EDX FIRST
        '
        wi="cwd : mov "+rg2+cm+wv+cr+"idiv "+rg2 : goto xop
      end if
      '
      'ITR unsigned ops
    end if
    '
    if wv="" then
      if (op=4)or(op=6) then
        rg=qeax
      end if
      wv=rg
    end if
    '
    select case op
    case 01 : wi="mov "      : goto xopv        ' load
    case 02 : wi="mov "      : goto xopr        ' store
    case 03 : wi="cmp "      : goto xopv        ' compare
    case 04 : wi="push "+wv  : goto xop 'push
    case 05 : wi="add "+spw1 : goto xop 'dump
    case 06 : wi="pop "+rg   :  goto xop 'pop
    case 08 : wi="add "      : goto xopr        ' +=
    case 09 : wi="sub "      : goto xopr        ' -=
    '
    case 10 : wi="xchg " : wv=pesp : goto xopv  ' stack accum swap
    case 11 : wi="not "+wv   : goto xop         ' not
    case 12 : wi="inc "+wv   : goto xop         ' inc var
    case 13 : wi="dec "+wv   : goto xop         ' dec var
    case 32
              wr=identypes(l)
              wi="cmp "+wr+wv+",0" : goto xop   ' cmp 0
    case 33 : wi="and "      : goto xopv        ' and
    case 34 : wi="or  "      : goto xopv        ' or
    case 35 : wi="xor "      : goto xopv        ' xor
    case 43 : wi="add "      : goto xopv        ' add
    case 45 : wi="sub "      : goto xopv        ' subtract
    '
    'only here for cpu types
    '
    case 65 : wi="and "      : goto xopr        ' and=
    case 66 : wi="or  "      : goto xopr        ' or=
    case 67 : wi="xor "      : goto xopr        ' xor=
    '
    case 71 : wi="and "      : goto boolev      ' logical and
    case 72 : wi="or  "      : goto boolev      ' logical or
    case 73 : wi="xor "      : goto boolev      ' logical xor
    case 74 : wi="shl "      : goto xopv        ' logical shift left
    case 75 : wi="shr "      : goto xopv        ' logical shift right
    case 92 : op=47                             ' integer divide
    end select
    '
    if (op=14)or(op=15) then
      if b<&h20 then f="i" : if op=15 then f="cwd : "+f
      if op=14 then wi=f+"mul "+wv+cr+"xchg " ' *=
      if op=15 then wi="xchg "+rg+cm+wv+cr+f+"div "+wv+cr+"xchg " ' /=
      goto xopv
    end if
    '
    if (op=42)or(op=47) then
      if b<&h20 then f="i" : if op=47 then f="cwd : "+f
      wr=identypes(l)
      if op=42 then wi=f+"mul "+wr+wv : goto xop
      if op=47 then wi=f+"div "+wr+wv : goto xop
    end if
    '
    if (op>=&h10)and(op<&h20) then
      wi="cmp "+pesp+cm+rg+cr+"pop "+qeax
      goto boole
    end if
    ' itr ^ 94
    goto xop
    '
    '----
    xopv:
    '----
    '
    wi+=rg+cm+wv : goto xop
   
    '----
    xopr:
    '----
    '
    wi+=wv+cm+rg : goto xop
    '
    '------
    boolev:
    '------

    wi+=rg+cm+wv : op=&h15 : goto boole
    '

  end if 'CPU INTEGERS
  '
  '
  '
  '=========
  'FPU TYPES
  '=========
  '
  m=0
  rg=qeax : rg2=qecx
  if b=&h40 then f="fi" : m=1 'INTEGER
  if b=&h60 then f="f"  : m=2 'FLOAT
  wr=identypes(l)
  '
  if m then
    '
    if l<cpuw then
      l=cpuw
    elseif l=10 then
      l=cpuw+8
    end if
    '
    'toto logical
    'downgrade acc : load saveint and/or/xor eax,[esp]
    '
    if isn(c) then
      '
      'NUMBERS FOR FPU
      '
      if dv=0 then wp="fldz" : goto fln
      if dv=1 then wp="fld1" : goto fln
      if dv=2 then wp="fld1  : fadd st0,st0" : goto fln
      if dv=4 then wp="fld1  : fadd st0,st0 : fadd st0,st0" : goto fln
      '
      a=dtf
      '
      if a=0 then
        'ite test for sci notation
      end if
      '
      if a=0 then
        if (abs(dv)<=&h7fffffff) then
          wp="push "+str(dv)+cr+"fild dword "+pesp+cr+"add "+spw1 : goto fln
        end if
      end if
      '
      'SPLIT INTO 2 PARTS
      '
      'double precision floating point
      '
      if a then 
        asm
        lea eax,[dv]
        mov ecx,[eax]
        mov [v],ecx
        mov ecx,[eax+4]
        mov [w],ecx
        end asm
        w1="fld"
      else
        w=dwu : v=dwl
        w1="fild"
      end if
      '
      if cpuw=4 then
        wp="push "+str(w)+cr+"push "+str(v)+cr+w1+" qword "+pesp+cr+"add "+spw2 'quad
      else
        wp="sub "+spw2+cr+"mov dword [rsp+4],"+str(w)+cr+_
        "mov dword [rsp],"+str(v)+cr+_
        w1+" qword [rsp]"+cr+"add "+spw2 'quad
      end if
      '
      '---
      fln:
      '---
      '
      c=128 'SET FLAG FOR NUMBERS
      '
      xfln:
      '
    end if
    '
    if c>=127 then f="f" 'TREAT AS FLOAT
    '
    'itr convert fpu for logical ops
    '
    if len(wv) then
      if c<>128 then wp=f+"ld "+wr+wv 'NON-NUMBERS
      wq=f+"stp "+wr+wv
    else
      wp=""
      wq=""
    end if
    '
    a=0
    '
    select case op
    '-------------
    '
    case 1
      '
      'LOAD
      '
      if c=129 then exit function 'NO FURTHER ACTION
      wi=wp
      goto xop
    case 2
      '
      'STORE
      '
      wi=wq : goto xop
      '
    case 03 : wi=wp+cr+"fxch : fcomi st1 : fxch"+cr+"fstp st0"+cr : goto xop
    case 04
      if len(wp) then
        if l=cpuw then
          if c<>128 then wi="push "+wv : goto xop 'not numbers
        end if
        wp+=cr
      end if
      wi="sub "+qesp+cm+str(l)+cr+wp+f+"stp "+wr+pesp
      goto xop
    case 05 : wi="add "+qesp+cm+str(l) : goto xop
    case 06 : wi=f+"ld "+wr+pesp+cr+"add "+qesp+cm+str(l) : goto xop
    '
    case 10 : wi=f+"ld "+wr+pesp+cr+"fxch"+cr+f+"stp "+wr+" "+pesp : goto xop ' xchg with stack
    case 11
      if wv=pesp then a=1 : wi=wp+cr else a=0 : wi=""
      wi+="fld1 : faddp st1,st0 : fchs"
      if a then wi+=cr+wq
      goto xop        'NOT (by 2s complement)
    '
    case 12 : wi=wp+cr+"fld1"+cr+"faddp st1"+cr+wq : goto xop 'inc
    case 13 : wi=wp+cr+"fld1"+cr+"fsubp st1"+cr+wq : goto xop 'dec
    '
    '
    '
    'BITWISE
    '
    case 33 : a=1 : w1="and"
    case 34 : a=1 : w1="or"
    case 35 : a=1 : w1="xor"
    '
    end select
    '---------
    '
    if a then
      '
      w3=wp+cr ' number literals
      '
      wi="sub "+qesp+cm+"16 : fistp qword ["+qesp+"+8]"+cr+_        'STACK FPU ACCUM
      wp+cr+"fistp qword "+pesp+cr+_                                'LOAD AND STACK VARIABLE
      "mov "+rg+cm+pesp+cr+w1+" ["+qesp+"+8]"+cm+rg+cr+_           'DO CPU OPERATION LOWER
      "mov "+rg+cm+"["+qesp+"+4] : "+w1+" ["+qesp+"+12]"+cm+rg+cr+_ 'DO CPU OPERATION UPPER
      "fild qword ["+qesp+"+8] : add "+qesp+",16"                   'RESTORE FPU ACCUM
      if a=2 then wi+=cr+wq                                         'CAN SAVE RESULT TO VARIABLE
      goto xop
    end if
    '
    'ARITHMETIC
    '
    if tp=&h48 then
      '
      'QUAD OPERANDS
      '
      wi="fild qword "+wv+cr
      select case op
      case 42 : wi+="fmulp st1" : goto xop
      case 43 : wi+="faddp st1" : goto xop
      case 45 : wi+="fsubp st1" : goto xop
      case 47 : wi+="fdivp st1" : goto xop
      case 92
        '
        'INTEGER DIVISION
        '
        wi+="sub "+spw1+" : fstcw "+pesp+" : fstcw ["+qesp+"+2] : or "+pesp+",0xc00 : fldcw "+pesp+cr+_
        "fdivp st1,st0 : frndint : fldcw ["+qesp+"+2] : add "+spw1
        goto xop
      end select
    end if
    '
    '
    'ALL OTHER OPERANDS
    '
    select case op
    case 42 : wi=f+"mul"
    case 43 : wi=f+"add"
    case 45 : wi=f+"sub"
    case 47 : wi="fdiv" : if (c<127)or(c>129) then c=128 'always use float div
    case 92
      '
      'INTEGER DIVISION '\'
      if c=129 then wi="" else wi=wp+cr 'PRE-LOADED ON STACK OR NOT
      wi+="fdivp st1,st0"+cr
      '
      'TRUNCATE FRACTION
      '
      wi="sub "+spw1+" : fstcw "+pesp+_
      " : fstcw ["+qesp+"+2] : or "+_
      pesp+",0xc00 : fldcw "+pesp+cr+_
      wi+"frndint : fldcw ["+qesp+"+2] : add "+spw1
      goto xop
    '
    '
    case &h20
      wi="fldz"+cr+wp+cr+"fcomip st1"+cr+"fstp st0" : goto xop 'FOR TRUE/FALSE COMPARE
    '
    case 94
      wi=wp+cr+powers : goto xop '^ POWER
    end select
    '
    if (op>=&h10)and(op<&h20) then
      wp=f+"ld "+wr+pesp
      wi=wp+cr+"fcomip st1"+cr+"fstp st0"
      wq="add "+qesp+cm+str(l)+cr
      goto boole
    end if
    '
    'USUAL COMPLETION OF OPERATION
    '-----------------------------
    '
    if len(wi) then
      if tp=&h6a then c=128 'PRE LOAD EXTENDED VARIABLE
      if (c>=127)and(c<=129) then
        if c=128 then wi=wp+cr+wi 'NUMBERS OR EXTENDED TYPES
        wi+="p st1,st0"
        goto xop
      end if
      wi+=" "+wr+wv
      goto xop
    end if
    '
    'itr shift left 74
    'itr shift right 75
    '
  end if
  '
  '
  '========
  ' STRINGS
  '========
  '
  if (tp>&ha0)and(tp<&h100) then
    '
    rg=qeax : rg2=qecx
    '
    'LOADING AND APPENDING
    '=====================
    '
    if op=33 then op=43 'INTERPRET & AS CONCAT
    '
    if (op<2)or(op=43) then
      '
      jn=nst+1
      a=tp and 31 : b=tp-a
      w1=charwidth(a)
      '
      select case b
      case &ha0 : a=zadcatla 'zstr
      case &hc0 : a=sadcatla 'bstr byval
      case &he0 : a=badcatla 'bstr byref
      end select
      '
      w1+=rtl(a)
      '
      if (b<&hc0)and(wv<>rg) then
        w2="lea " 
      else
        w2="mov "
      end if
      '
      if op<02 then
        dcs(funi)=1
        if wv="" then wi=rtl(catbufprpa)+cr+w1 : goto xop   'get
        wi=w2+rg+cm+wv+cr+rtl(catbufprpa)+cr+w1 : goto xop 'get
      end if
      '
      if op=43 then
        if wv="" then wi=w1 : goto xop ' add
        wi=w2+rg+cm+wv+cr+w1 : goto xop
      end if
      '
    end if
    '
    'ASSIGNING
    '=========
    '
    if op=2 then
      '
      w1=""
      jn=0
      '
      'INDIRECT BSTR BYREF
      '-------------------
      '
      if tp>&he0 then
        '
        'check string is listed delete then assign new
        '
        w2=mid(wv,3,3) : a=asstrga
        if w2="bp-" then a=asstrla 'ASSIGN LOCAL
        wi=w1+"lea "+rg2+cm+wv+cr+rtl(a)
        goto xop
        '
      end if
      '
      'BSTR BYVAL
      '----------
      '
      if tp>&hc0 then
        '
        'destroy old bstr before assign
        '
        if cpuw=4 then
          wi="push "
        else
          wi="mov rcx,"
        end if
        wi=w1+pusheax+wi+wv+cr+rtl(16)+cr+popeax+"mov "+wv+cm+rg
        if cpuw=8 then
          wi="_sp -8"+cr+wi+cr+"_sp 8"
        end if
        goto xop 'FREEMEM
      end if
      '
      '
      'DIRECT ZSTRING ETC
      '--------------------------
      '
      '
      a=tp and 31
      wi="lea "+rg+cm+wv+cr+charwidth(a)+rtl(joinsa)
      goto xop
      '
    end if 'op=2
    '
    '
    'JOINING
    '=======
    '
    'used for joining unassigned strings (params)
    '
    if op=96 then
      jn=0
      a=tp and 31
      wi=charwidth(a)+"xor "+rg+cm+rg+cr+rtl(joinsa)
      goto xop
    end if
    '
    '
    'COMPARING
    '=========
    '
    a=0
    if op=3 then a=1
    if (op>=&h10)and(op<=&h20) then a=1 'compare [esp] with rg
    if a then
      if cpuw=4 then
        if op<&h20  then
          w1=pusheax
        else
          w1="push "+wv+cr+"push 0"+cr
        end if
      else
        if op<&h20  then
          w1="mov rcx,rax"+cr+w1+"pop rdx"+cr
        else
          w1="mov rdx,"+wv+cr+"mov rcx,0"+cr
        end if
      end if
      a=tp and &h7fffffe0
      if a=&ha0  then w2=rtl(compza) 'ZSTR
      if a=&hc0 then w2=rtl(compsa)  'BSTR
      if a<>&he0 then if op=3 then w1="xchg "+rg+cm+wv+cr+w1
      '
      'DYNAMIC STRING
      '
      if tp=&he1 then
        if op=&h20 then w2=rtl(compisa)
        if op=03   then w2=rtl(comprisa)
      end if
      if (op=3)or(op=&h20) then wi=pusheax+w1+w2+cr+"pop "+qeax
      wi=w1+w2
      if op=&h20 then goto xop else goto boole
    end if
    '
    'OTHER
    '=====
    '
    if op=04 then
      wi="push "+rg   ' push
    elseif op=05 then
      wi="add "+spw1  ' dump
    elseif op=06 then
       wi="pop "+rg   ' pop
    end if
    goto xop
    '
  end if 'STRINGS
  '
  goto xop
  '
  '
  '
  '
  '
  '==============
  boole: 'LOGICAL
  '==============
  '
  '
  function=wi+cr+comparet(op,tp)+cr+wq+cr
  exit function
  
  '
  '------------------------------
  xop: 'RESOLVED OPERATOR OPERAND
  '==============================
  '
  'if (parx=0)or(op>1) then
  '  '
  '  'allow load or push 
  '  '
  '  if (op<>4)and(op<>6) then
  '    if wi="" then
  '      ert=16
  '      ers="unidentified operation ("+str(op)+") for this type ("+str(tp)+")"
  '    end if
  '  end if
  'end if
  '
  function=wi+cr
  '
end function


'----------------------------------------------------------
function retvalue(byval n as sys, byval a as sys) as string
'==========================================================
  dim as sys b
  dim as string w1
  '
  if (n=11)or(n=13) then b=lookupm("_return")
  if b=0 then exit function 'SUB N=12 OR OPERATION
  w1=macso(b,1)
  if w1=qeax then exit function
  '
  'ENCODE FOR RETURNING DIFFERENT TYPES
  '
  if a<&h80 then
    '
    if cpuw=8 then
      if a>=&h60 then
        'itr any type conversion?
        a and=31
        w1="movups xmm0,"+w1+cr 
        if a>=8 then mid(w1,6)="d" 'double
        function=w1 : exit function
      end if
    end if
    if a=&h40 then a=&h68 'fpu type assumes double type here
    w1=ins(1,a,w1) 'RETURN INTEGERS AND FLOATS
    '
  elseif a=&hc1 then
    w1="mov "+qedi+cm+w1+cr+rtl(trbstra)+cr  'RETURN STRINGS
  else
    w1="mov "+qeax+cm+w1+cr 'DEFAULT RETURN FOR HIGHER TYPES / POINTERS
  end if
  '
  function=w1
  '
end function



'---------------------------------------------
function commutec(byval typc as sys) as string
'=============================================
  '
  if (op=45)or(op=47)or(op=92) then
    function="'COMMUTE:"+cr+ins(10,typc,"") : exit function
  end if
  '
end function



' 
'                       #      #########
'  ########    CONVERT   ##    #       #
'  #      #  ################  #       #
'  ########              ##    #       #
'                       #      #########
' 


'------------------------
function tmpv() as string
'========================
  '
  'itr primitives and pointers only
  '
  'local temp storage
  dim as sys a
  dim as string w1
  a=16
  '
  if asce<0 then tmpst-=a : aoff-=a 
  function=memreg(regs,aoff)
  if asce>0 then tmpst+=a : aoff+=a
  if lclv=0 then aoffs=aoff 
  '
end function


'--------------------------------------------------------------------------------
function cpufpu(byval pp as sys, byref typb as sys, byref wr as string) as string
'================================================================================
  '
  dim as sys b,tb
  dim as string w1,wp
  if asc(wr)=91 then wp=wpfx

    '
    tb=typb
    b=0
    '
    'SMALL TYPES
    '-----------
    '
    if typb=&h01 then b=1 'SIGNED BYTE itr sign extend? 
    if typb=&h21 then b=1 'UNSIGNED BYTE TO SHORT
    if typb=&h02 then b=2 'SHORT TO SHORT
    if typb=&h22 then
      b=4  'UNSIGNED WORD TO LONG
      if pp<0 then w1="and "+qeax+",0xffff"+cr
    end if
    '
    if b then
      b+=&h40
      if pp>=0 then
        w1="xor "+qeax+cm+qeax+cr+wp+ins(1,typb,wr)
      else
        pp=1
      end if
      if b=&h41 then w1+="and "+qeax+",0xff"+cr : b=&h42
      w1+=pusheax+ins(pp,b,pesp)+"add "+spw1+cr
      typb=b : goto xcv
    end if
    '
    if pp<0 then pp=1
    '
    'UNSIGNED DWORD
    '--------------
    '
    if typb=&h24 then
      typb=&h48
      w1="push 0"+cr+wp+"push "+wr+cr+ins(pp,typb,pesp)+"add "+spw2+cr
      goto xcv
    end if
    '
    'SIMPLE CONVERSION
    '-----------------
    '
    if typb<=8 then
      '
      'REGISTERS
      '
      typb+=&h40
      if asc(wr)<>91 then
        w1=wp+"push "+wr+cr+ins(pp,typb,pesp)+"add "+spw1+cr
        goto xcv
      end if
      '
    end if
    '
    if typb=&h01 then typb=&h42 : goto ncv ' BYTE TO SHORT
    if typb=&h02 then typb=&h42 : goto ncv ' SHORT TO SHORT
    if typb=&h04 then typb=&h44 : goto ncv ' LONG TO LONG
    'if typb=&h08 then typb=&h48 : goto ncv ' QUAD TO QUAD
    '
    '
    'UNSIGNED QWORD
    '--------------
    '
    if typb=&h28 then
      ' todo subroutine
      ers="Unsigned quad not implemented"
      goto xcv
    end if

  '
  'DEFAULT
  '-------
  '
  ncv:
  '
  w1+=wp+ins(pp,typb,wr) ' no operand conversion
  '
  xcv:
  '
  function=w1
  '
end function


'--------------------------------------------------
sub pushaddress(wsg as string, byref psg as string)
'==================================================
  if wsg<>pedi then
    psg+=ledi+wsg+cr
  end if
  appendt(psg+ins(4,4,qedi))
end sub


'-----------------------------------------------------------
function cvta(byval typa as sys,byval typb as sys) as string
'===========================================================
  '
  ' FOR ACCUMULATOR
  ' CONVERT FROM TYPE A TO TYPE B

  ' bytes are treated as unsigned
  '
  dim as sys a,b,la,lb,ta,tb
  dim as string tc,w1,w2,w3,w4
  '
  '
  'EXCLUDE MATCHING OR UNKNOWN TYPES
  '
  if (typa=typb)or(o2h=0)or(typa=0)or(typb=0) then goto xcvt

  '
  'NO HIGHER TYPE CONVERSIONS
  '
  '
  'GET LENGTH OF PRIMITIVE
  '
  la=typa and 31
  lb=typb and 31
  ta=typa and &h7fffffc0
  tb=typb and &h7fffffc0
  '
  '
  if typa=0 then typa=cpuw
  if typb=0 then typb=cpuw
  '
  '
  '=================================
  'CONVERSION FROM NUMBER TO BSTRING
  '=================================
  '
   if (tb=&hc0)or(tb=&h80) then
     if typa<&ha0 then
      '
      if vew>0 then w1=";CONVERT VAL TO STRING"
      '
      'UPGRADE NUMBER TYPE FIRST (CVTA RECURSIVE)
      '
      tc=cvta(typa,&h68)+rtl(2520)+cr 'STR
      '
      goto xcvt
    end if
  end if
  '
  '
  '=================================
  'CONVERSION FROM BSTRING TO NUMBER
  '=================================
  '
  if (ta=&hc0)or(ta=&h80) then
    if typb<&ha0 then
      '
      if vew>0 then w1=";CONVERT STRING TO VAL"
      '
      if cpuw=4 then
        tc=pusheax+rtl(192)+cr 'VAL
      else
        tc="mov rcx,rax"+cr+rtl(192)+cr
      end if
      '
      typa=&h6a : ta=&h40
      '
      'continue with conversion
      '
      goto fpucpu
      '
    end if
  end if
  '
  '
  '==================
  'STRING CONVERSIONS
  '==================
  '
  a=0
  if tb=&hc0 then
    if ta=&h80 then a=1
    if (ta=tb)and(la<>lb) then a=1
  elseif tb=&h80 then
    'if ta=&hc0 then a=1
    'if (ta=tb)and(la<>lb) then a=1
    if la<>lb then a=1
  end if
  if a then
    tc=" " 'allow concatenator
    w1="STRING"
    goto xcvt
  end if
  
  '
  '
  '=================
  'CPU to CPU RESIZE
  '=================
  '
  ' UNSIGNED AND SIGNED
  '
  'SOURCE SHORTS AND LONGS WILL BE SIGN EXTENDED BUT NOT BYTES
  '
  if ta+tb=0 then
    '
    if lb=1 then
      tc="and "+qeax+",0xff"+cr ' BYTES NOT SIGN EXTENDED
    end if
    '
    if lb=2 then
      if la=1 then tc="and "+qeax+",0xff"
    end if
    '
    if lb=4 then
      '
      'typb is either 04 or 24
      '
      if la=1 then
        tc="and "+qeax+",0xff"+cr 'BYTES NOT SIGN EXTENDED
      elseif typa=2 then
        tc="cwde"+cr 'SIGN EXTENDED TO 32 BIT
      elseif typa=&h22 then
        tc="and "+qeax+",0Xffff"+cr
      elseif typa=&h04 then
        if typb=&h24 then
          'requires upgrade to FPU
        end if
      elseif typa=&h24 then
        if typb=&h04 then
          'requires upgrade to FPU
        end if
      elseif la=8 then
        goto xcvt 'no conversion required
      end if
 
    end if
    '
    if lb=8 then
      if cpuw=4 then
        if la=1 then tc="xor "+qedx+cm+qedx+cr+"and "+qeax+",0xff"+cr ' BYTES NOT SIGN EXTENDED
        if typa=2 then tc="cwde : cwd"+cr
        if typa=&h22 then tc="and "+qeax+",0xffff"+cr
        if typa=4 then tc="cwd"+cr
        if typa=&h24 then tc="xor "+qedx+cm+qedx+cr
      else
        if la=1 then tc="and rax,0xff"+cr ' BYTES NOT SIGN EXTENDED
        if typa=2 then tc="cwde : cdqe"+cr
        if typa=&h22 then tc="and rax,0xffff"+cr
        if typa=4 then tc="cdqe"+cr
        if typa=&h24 then tc="and rax,0xffffffff"+cr
      end if
    end if
    '
    '
    if vew>0 then
      if typa>typb then w1="CPU DOWNSIZE" else w1="CPU UPSIZE"
    end if
    '
    goto xcvt
  end if
  '
  'if floats differ in type then prevent compatsig shortcut
  '
  if (ta=&h40)and(tb=&h40) then tc=" " : goto xcvt
  '
  '==========
  'FPU to CPU
  '==========
  '
  fpucpu:
  '
  if tb=0 then
    if ta=&h40 then
      if lb=8 then tc+="sub "+spw1+cr+"fistp qword "+pesp+cr+popeax
      if lb<=4 then tc+="sub "+spw1+cr+"fistp dword "+pesp+cr+popeax
      if lb=2 then tc+="and "+qeax+",0xffff"+cr
      if lb=1 then tc+="and "+qeax+",0xff"+cr
      if vew>0 then w1="FPU TO CPU"
      goto xcvt
    end if
  end if
  '
  '==========
  'CPU to FPU
  '==========
  '
  if (typa<&h40)and(isfpu(typb)<>0) then
    if vew>0 then w1="CPU TO FPU"
    tc=cpufpu(-1,typa,qeax)
  end if
  '
  xcvt:
  '
  if vew>0 then if len(tc) then tc="'CONVERT "+W1+cr+tc
  function=tc
  '
end function



'------------------------------------------------------------------------------
function callcoc(byval pn as sys, byval w2 as string, byval e as sys) as string
'==============================================================================
  dim as sys a,w,tg
  dim as string w1,w3
  '
  'MS64 CALLING
  '
  if (cco=2)or(cco=3) then
    a=pn
    if vaf>8 then
      a+=1 'OOP: ALLOW FOR 'THIS' IN RCX, DISPLACING THE OTHER PARAMS
    end if
    '
    w3=memreg(qesp,a*8-8)
    tg=typg
    if (e>48)or(tg>=&ha0) then tg=cpuw 'POINTERS OR STRING OR HIGHER TYPE
    '
    if isfpu(tg)=0 then 'NON-FLOATS
      '
      if instrword(" rax eax ax al ",w2) then
        w1=""
      else
        w1=ins(1,tg,w2)
      end if
      '
      w1+=ins(2,cpuw,w3) 'ALWAYS USE STACK
    elseif tg=&h40 then
      exit function 'FPU INTERNAL STACK TYPE
    else ' tg>&h40 DIRECT FLOATS
      if asc(w2)=91 then w1=ins(1,tg,w2) else w1=""
      w1+=ins(2,tg,w3) 'USE STACK
    end if
  elseif cco=16 then
    a=pn : if vaf>8 then a+=1 'OOP
    w1=rgp(a)+w2+cr 'CPU: PARAMS IN REGISTERS
  elseif cco=17 then
    w1="" 'PARAM REMAINS ON FPU STACK
  else 'NOT MS64
    if e>48 then
      a=cpuw 'byref
    else 'e<=48
      'byval
      'itr quads on 32bit cpu
      if typg>&h80 then a=cpuw else a=typg ' 
    end if
    w1=ins(4,a,w2) 'push onto stack (also supports double floats byval) 
  end if
  function=w1
end function


'-------------------------
function logas() as string
'=========================
  dts(funi)=1
  function=rtl(asstmpa)+cr 'LOG FOR DELETION
end function


'--------------------------------------------------
function strinit(s as string,u as string) as string
'==================================================
  dim as sys a
  dim as string w1
  a=strinstga : w1=s+u
  if instr(w1,"["+qebp+"-") then
    a=strinstla
  elseif instr(w1,"["+qebp+"+") then
    a=0
  end if
  w1="lea "+qecx+cm+wg+cr
  if a then w1+=rtl(a)+cr
  function=w1
end function

'---------------------------------------------------
function tmpstringbyref(byref s as string) as string
'===================================================
  dim as sys a,b
  a=instrevn(-1,s,"bx+2224]") 'asstmp
  if a then
    a-=7
    if mid(s,a,6)="call [" then
      mid(s,a)=space(15)
      function=rtl(16)+cr
    end if
  end if
end function


'         ##################
'       #                  #
'       # ################## #
'       # #                # #
'       # #                # #
'       # #                # #
'       # #                # #
'       # #                # #
'       # #                # #
'       # #                # #
'       # #                # #
'       # ################## #
'        #                  #
'         ################## 
'
'
'
'---------------------------------------------------------------------------------
function compatsig(byref p1 as string, byref p2 as string, byval pb as sys) as sys 
'=================================================================================
  '
  ' p1 COMPOSED, p2 REQUIRED
  '
  dim as sys i1,i2,k,a,b,c,d,e,pa,m,n,nd,e1,e2,tg,tl,apa
  dim as string s1,s2,w1,w2,w3,w4,fmem
  '

  if len(p1)+len(p2)=0 then function=1 : exit function 'NULL SIGNATURES
  '
  'SPLIT OFF INDIRECTION CODES
  '---------------------------
  '
  s1=splitsi(p1,wu1)
  s2=splitsi(p2,wu2)
  '
  'QTY OF PARAMS MISMATCH
  '----------------------
  '
  e1=len(wu1) : e2=len(wu2) : a=0
  '
  if e1<>e2 then
    if e1<e2 then
      if asc(wu2,e1+2)<65 then a=1 'OTHERWISE ASSUME OPTIONAL PARAMS
    elseif e1>e2 then
      if asc(wu2,e2)<>46 then a=1 'b: OTHERWISE ASSUME ANY PARAMS ACCEPTED: "..."
    else
      a=1
    end if
    if a then k=0 : exit function
  end if
  '
  'CHECK EACH PARAM
  '----------------
  '
  i1=1 : i2=1 : c=1
  do
    pa=c+pb
    w1=wordfrag(s1,i1) : w2=wordfrag(s2,i2)
    '
    'COMPARE PARAM TYPES
    '-------------------
    '
    if w2="" then
      if w1="" then k=1 : exit do 'NO MORE PARAMS
    end if
    '
    '
    '2 MODE COMPATIBILITY CHECK
    '--------------------------
    '
    '
    'INDIRECTION: BYVAL BYREF
    '------------------------
    '
    a=c*2
    d=asc(wu1,a)
    e=asc(wu2,a)
    if e>64 then e-=49 'DEDUCT 'OPTIONAL' SIGNAL
    if e=46 then apa=1 '..' any param acceped 
    '
    'ELLIPSIS
    '------------------
    '
    if apa then
      goto nxtel 'ANY PARAM ACCEPTED ...
    end if
    '
    '
    'OPTIONAL PARAMS
    '---------------
    '
    if d=0 then
      'USE NULLS IF OPTIONAL PARAM NOT GIVEN
      pas(pa)="" : pav(pa)=callcoc(c,"0",e)
      goto nxtel
    end if
    '
    if d=95 then goto nxtel ' _ BYVAL WITHOUT CONVERSION 'itr check X64 CALLING CONVENTION
    '
    '
    'GROUP COMPATIBILITY CHECKS
    '--------------------------
    '
    if (w1="")or(w2="")  then k=0 : exit do 'NUMBER OF PARAMETERS MISMATCH
    '
    n=identype(w2) : e+=indt
    m=identype(w1) : d+=indt
    '
    '
    if n=m then
      goto matchednm
    elseif (m<&h40)and(n<&h40) then
      a=m and 31
      b=n and 31
      if b<a then
        m=cpuw : n=cpuw 'NO CONVERSION CODE REQUIRED
      end if
    elseif n>=512 then
      if maco(n-512,0)=-2 then
        n=cpuw 'FOR ENUMERATION TYPES UNCHECKED
      else
        if m<>n then
          if (m>512)or(n>512) then
            if n<>-1 then
              exit function 'HIGHER TYPES MISMATCH
            end if
          end if
        end if
      end if
    end if
    '
    a=0
    '
    if w2="any" then
      m=n 'always compatible (treat as sys)
    elseif w2="gstr_" then
      if isdstr(m) then a=1 : 'accept any bstring/dyn string width
    elseif w2="cstr_" then
      if isstr(m) then a=1 : 'accept any string width
    end if
    '
    if a then
      a=m and 31
      b=n and 31
      n+=a-b
    else
      '
      'CONVERSION OF STRINGS WIDE<->ASCII
      '==================================
      '
      if isstr(n) then
        w4=charwidth(n and 31)
        w4=left(w4,len(w4)-3)
        a=instrevn(-1,pas(pa),w4)
        if a then
          a+=len(w4)
          mid(pas(pa),a)=chr(48+(n and 31))
        end if
      end if
    end if
    '
    '
    '=========
    matchednm: 'CHECK FOR MATCHING TYPE
    '=========
    '
    if m=n then k=1 else k=2
    k and=uk                  'WHEN UK=1 A PERFECT MATCH IS REQUIRED
    if k=0 then exit function 'NOT COMPATIBLE
    '
    'pas(pc)     'DEFAULT PARAM EXPRESSION from wd
    'pav(pc)     'DEFAULT COMPATIBILITY CODE (usually push eax) from w1
    'pax(pc)     'INDIRECTION CODE from wpfx

    'PAS AND PAV ARE COMBINED TO MAKE THE FULL PARAM PASSING EXPRESSON
    '    
    wg=paw(pa)             'LAST OPERAND (translated)
    opg=pao(pa)            'LAST OPERATOR
    typg=pat(pa)           'ACCUM TYPE
    tg=typg and &h7fffffe0 'ACCUM GENERIC TYPE
    tl=typg-tg             'ACCUM LENGTH
    '
    '
    'VOID* TYPES TO BE SAME AS SYS TYPE
    '==================================
    '
    a=0
    
    if m<0 then
      if d>48 then a or=1 : d-=1 : m=cpuw 'void* to sys
    elseif m=cpuw then
      a or=1 'ALLOW SYS TYPES TO BE TREATED LIKE VOID*
    end if
    if n<0 then if e>48 then a or=2
    '
    'PASSING TO VOID*
    '
    if a=3 then
      e-=1 : n=cpuw 'TREAT AS SYS TYPES (HANDLES ETC) itr
    end if
    '
    if e>48 then a=cpuw else a=n
    pat(pa)=a 'used to determine use of SIMD registers
    '
    '
    'OFFER CONVERSION CODE IF PERMITTED
    '==================================
    '
    w2="" : w3=""
    '
    'itr callcoc
    '
    if (k and 6)>0 then
      '
      'STRING CONVERSION CHECKS
      '
      if n=-1 then n=m 'void* no conversion
      '
      if (uk and 4)=0 then
        if isstr(m) then
          if isstr(n)=0 then k=0
        else
          if isstr(n) then k=0
        end if
        if isdstr(n) then
          if iszstr(m) then k=0
        end if
        if k=0 then exit function
      end if
      '
      if m<>n then
        w2=cvta(m,n)
     end if
      '
      if isstr(n) then
        '
        'NUMBER TO STRING CONVERSION
        '
        if isstr(m)=0 then
          if (e=48)and(iszstr(n)<>0) then
            goto nxtel 'CHAR AS ASCII
          else
            pas(pa)+=w2+logas() : w2=" " : d=48 'EARLY CONVERSION
          end if
        end if
        '
        'DIRECT ZSTRING
        '
        if iszstr(n) then
          if e=48 then 
            if (opg>1)or(len(w2)>0) then
              pas(pa)+="mov "+qeax+cm+peax+cr : goto nxtel 'CHAR DIRECT
            end if
          end if
        end if
      end if
      '
      '
      m=n 
      typg=n
      '
      if cpuw=8 then
        if isq(asc(wg))or(opg>1)or(isstr(n)<>0) then
          w1=qeax
        elseif (n>=&h40)and(n<&h80) then
          w1="" 'FPU
        elseif len(w2) then
          w1=qeax
        else
          w1=wg
        end if
        w3=w2+callcoc(c,w1,e)
      else
        w3=w2+ins(4,typg,"") 'itr
      end if
      '
      if ert then k=0 : exit function 'CONVERSION IMPOSSIBLE
      '
      'FPU CALLING CONVENTION
      '======================
      '
      if n=&h40 then
        pas(pa)+=w2 : pav(pa)="" : goto nxtel
      end if
      '
      pav(pa)=w3
    end if
    '
    '
    a=asc(wg)
    '
    '
    if d>48 then
      if len(w2) then d=48 'COMPEL TO USE TEMP STORAGE
    end if
    '
    '=========
    'SHORTCUTS
    '=========
    '
    if (opg<2)and(w2="") then
      '
      'STRING LITERALS & CONSTANTS
      '
      if isbstr(tg) then
        if asc(pax(pa))=&h6f then 'O2..
          if iszstr(n) then
            pas(pa)=pax(pa)
            if e=48 then
              pas(pa)+="mov "+qeax+cm+peax+cr 'CHAR DIRECT
            end if
            goto nxtel
          else 'not zstring
            if e=48 then pas(pa)=pax(pa) : goto nxtel
          end if
        end if
      end if
      '
      '
      'BYREF
      '=====
      '
      if d>48 then
        if iszstr(m) then
          if e=48 then
            pas(pa)=pax(pa)
            if wg<>qedi then pas(pa)+=leaedi(wg)
            pav(pa)=callcoc(c,pedi,e)
            goto nxtel
          end if
        end if
        '
        'DOUBLE POINTERED (ONLY)
        '
        if e>d then
          if left(pax(pa),4)="mov " then
            mid(pax(pa),1)="lea" : d+=1
          else
            ert=18 : ers="unable to match byref" : k=1 : exit function
          end if
        end if
        '
        if d=e then goto varbref 'otherwise continue
      end if
    end if
    '
    '
    '==============
    'BYVAL TO BYVAL
    'BYREF TO BYVAL
    '==============
    '
    if d>=e then
      '
      'INDIRECTION RESOLVED IN PWORD()
      '
      'SHORTCUTS
      '---------
      '
      if a=91 then
        '
        'VARIABLES ONLY
        'EXCLUDING BSTR
        '
        if (opg<2)and(w2="") then
          '
          'ELEMENTS AND MEMBERS BYVAL
          '
          if (left(wg,4)="["+qedi) then
            pas(pa)=pax(pa)
            if tg=&he0 then
              pas(pa)+="mov "+qedi+cm+wg+cr : wg=pedi 'DEREFERENCE DYNAMIC STRING
            end if
            pav(pa)=callcoc(c,wg,e)
            goto nxtel
          end if
          '
          'TO BYPASS STRINGS CONCATENATORS
          '
          if tg=&hc0 then
            if d=e then
              if iszstr(n) then goto varbref
              pas(pa)=pax(pa) : pav(pa)=callcoc(c,wg,e) : goto nxtel 'direct
            end if
          elseif tg=&he0 then
            goto varbref 'direct
          else
            '
            'if no conversion code / including floats
            '
            pas(pa)=pax(pa)
            pav(pa)=callcoc(c,wg,e)
          end if
        end if 'opg<2 and w2=""
      end if 'a=91
      '
      'if d>e then pas(pa) encoding takes care of dreferencing
      '
      goto nxtel
      '
    end if 'd>=e
    '
    '
    '--------------
    'BYVAL TO BYREF
    '==============
    '
    if d<e then
      'PROVIDE TEMP STORAGE AND ADDRESS FOR EXPRESSION RESULT
      'PASS ADDRESS IF SIMPLE OR ARRAY ELEMENT
      '
      '
      if e=d+1 then
        '
        'BSTRING TO ZSTRING PTR
        '
        if (iszstr(tg)=0)and(iszstr(n)<>0) then
          if len(w2) then pas(pa)+=cr+w2 : goto nxtel
          if opg>1 then goto nxtel
          goto varbref
        end if
      end if
      '
      '
      'GENERAL BYREF
      '-------------
      '
      'itr wg=qedi
      a=asc(wg)
      b=0
      '
      if opg>1 then
        b=1
      elseif len(w2) then
        b=2
      elseif isn(a) then
        b=3
      elseif isq(a) then
        b=4
      elseif wg=qedi then
        b=5
        w2="mov "+qeax+cm+wg+cr
      end if
      '
      'REQUIRING TEMP STORAGE
      '======================
      '
      if b then
        if w2="" then w2=" "
        goto varbref
      end if
      '
      '
      'ARRAYS OR OTHER POINTER BYREF
      '
      '=============================
      arrfuncref: 'ARRAYS FUNCTIONS
      '============================
      '
      if left(wg,4)="["+qedi then
        '
        'ARRAYS AND ELEMENTS BYREF
        '
        pas(pa)=pax(pa)
        if tg=&he0 then
          pav(pa)=strinit(pas(pa),wg)+callcoc(c,pecx,e) 'DEREF FOR STRINGS
        else
          if wg<>pedi then w1=ledi+wg+cr else w1=""
          pav(pa)=w1+callcoc(c,qedi,e)
        end if
        goto nxtel
        'end if
      end if
      '
      '
      '=======================
      varbref: 'VARIABLE BYREF
      '=======================
      '
      '
      'REQUIRES TEMP STORAGE?
      '
      if w2="" then if (isdstr(n)<>0)and(tg=&hc0) then w2=" "
      '
      if len(w2)and(e>48) then
        w1=tmpv()
        if n>&he0 then
          w4=tmpstringbyref(pas(pa))
          if len(w4) then
            if cpuw=4 then
              fmem+="push "+w1+cr+w4
            else
              fmem+="mov rcx,"+w1+cr+w4
            end if
          end if
        end if
        if n>&ha0 then n=cpuw
        pav(pa)=w2+ins(2,n,w1)+ledi+w1+cr+callcoc(c,qedi,e)
        goto nxtel
      end if
      '
      '
      if asc(wg)=91 then
        '
        if isstr(tg) then
          if (iszstr(tg)=0)and(iszstr(n)<>0) then
            e-=1
          end if
        end if
        '
        if tg=&he0 then
          '
          'DYNAMIC STRINGS (CHECK STRING INSTANCE)
          '---------------------------------------
          '
          '
          w1=strinit(pax(pa),wg) : w3=pecx
          '
          if e<=48 then
            for a=e to 48
              w1+="mov "+qecx+cm+pecx+cr 'DEREF
            next
          end if
          '
        else 'tg<>&he0
          if e<=48 then
            w1="" : w3=wg
            for a=e to 47
              w1+="mov "+qedi+cm+wg+cr : wg=pedi : w3=pedi 'DEREF
            next
          else
            if wg=pedi then w1="" else w1=ledi+wg+cr
            w3=qedi
          end if
        end if
        '
        pas(pa)=pax(pa)
        pav(pa)=w1+callcoc(c,w3,e) 'itr w2
        goto nxtel
      end if
      '
    end if
    '
    'fall thru
    '
    'ert=17 : ers="param compatibility problem "+wg
    '
    '===================
    nxtel: 'NEXT ELEMENT
    '===================
    '
    c+=1
    '
  loop
  '
  compatsx:
  '
  if k then
    if apa=0 then
      pc=pc+(e2-e1)*.5 'OPTIONAL PARAM FILL IN
    end if
    '
  end if
  '
  'RELEASE TEMP STRINGS PASSED BYREF AFTER THE CALL IS MADE
  '
  if len(fmem) then
    fmem=pusheax+"push "+qedx+cr+fmem+"pop "+qedx+cr+popeax+cr
  end if
  pas(pa)=fmem 'FREE TEMP BYREF STRINGS (AFTER CALL)
  function=k
  '
end function




'  BINDING:
'  ########    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##
'       ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##
'      ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##
'     ##====##====##====##====##====##----##----##----##----##----##----##----##----##----##
'    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##
'   ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##
'  ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ##    ########


'---------------------------------------------------
sub procaddrc(byref s as string, byref wr as string)
'===================================================
  '
  'LOW LEVEL `BIND`
  '---------------
  '
  dim as sys a,c,d,e,i,j,k
  dim as string wa,wb,wd,tt
  i=1 : j=0
  tt=space(len(s)) : k=1 : c=0
  do
    wd=tword(s,i) : if wd="" then exit do
    if cpuw=8 then a=2 else a=0 'DEFAULTING CALLING CONVENTION
    maco(me,0)=-4   'O2 CALL TYPE
    maco(me,3)=-1   'NON LIBRARY LIST INDEX
    maco(me,1)=cpuw 'LENGTH
    maco(me,4)=a    'CALLING CONVENTION
    macsi(wd,me,0)  'NAME
    addm(me)
    c+=1
    addme 'ME+=1 WITH BOUNDARY CHECK
    ' 
    wd="`"+noquotes(wrd(s,i))+"` 00"  ' GRAB ALIAS WITHOUT ALTERATION & ADD NULL TERMINATOR
    mid(tt,k)=wd+cr : k+=len(wd)+2
  loop
  '
  mid(tt,k)=" 03" : k+=3 'LIST TERMINATOR
  '
  'GET BASE TO ASSIGN ADDRESSES IN ASCENDING ORDER
  '-----------------------------------------------
  '
  if asce<0 then aoff-=c*cpuw : d=aoff else d=aoff : aoff +=c*cpuw
  '
  wa="lea "+qeax+cm+memreg(regs,d)+cr
  '
  'PUSH RUNTIME TABLE OFFSET PARAMETER
  '-----------------------------------
  '
  if asce>0 then
    wb=wa
  else
    wb=wa+"mov "+qesp+cm+qeax+cr 'ALLOCATE LOCAL SPACE ON STACK
  end if
  '
  '
  'ASSIGN ADDRESSES IN ASCENDING ORDER
  '-----------------------------------
  '
  e=me-c 'VARBASE
  '
  for a=1 to c
    maco(e,2)=d : wa=memreg(regs,d) : macsi(wa,e,1)
    d+=cpuw : e+=1 
  next
  '
  '
  '
  'RUN-TIME BINDING SETUP CALL
  '---------------------------
  '
  'appendt( wb+"data"+sp+left(tt,k-1)+ep+pusheax+"push "+wr+cr+rtl(48)+cr ) 'GETPROCADDRESS
  '
  if cpuw=4 then
    appendt(wb+pusheax+stodata(left(tt,k-1))+pusheax+"push "+wr+cr+rtl(48)+cr ) 'GETPROCADDRESS
  else
    appendt(wb+"mov r8,rax"+cr+stodata(left(tt,k-1))+_
    "mov rdx,rax"+cr+"mov rcx,"+wr+cr+rtl(48)+cr ) 'GETPROCADDRESS
  end if
  '
end sub



'---------------------------
function newstatvar() as sys
'===========================
  if lclv then
    function=aoffs : aoffs+=cpuw
  else
    function=aoff : aoff+=cpuw : aoffs=aoff
  end if
end function


'--------------------------------------------------------------
function addlib(byref wr as string, byref ali as string) as sys
'==============================================================
  dim as sys a
  wr=lcase(wr) ' MS case insens
  '
  'SEARCH BACKWARDS
  '----------------
  '
  a=libe
  do
    a-=1
    if a<dlb then exit do
    if wr=libs(a) then exit do
  loop
  '
  'ASSIGN NEW
  '----------
  '
  if a<1 then
    a=libe
    libu(a)=0
    '
    'ALWAYS STORE IN STATIC VARIABLE
    '
    libo(a)=newstatvar()
    libs(a)=wr
    libe+=1
    '
    'CHECK LIMIT
    '-----------
    '
    if libe>510 then libe=510 : ert=300 : ers="Too many libraries"
  end if
  '
  function=a
  '
end function




'-------------
sub addlproc()
'=============
  '
  'FORMAT : o2 ( ...02 h?xxxxxxxx `name` 00 ...
  '
  '
  dim as sys a,b,c,d,e,lw,pd
  dim as string wr,w1
  '
  'SELECT LIB BUFFER
  '-----------------
  '
  pd=maco(mp,3)
  c=libu(pd) 'LIB BUFF USED
  w1="`"+macso(mp,2)+"` 00"
  '
  '
  'CHECK IF ALREADY PRESENT
  '------------------------
  '
  d=instr(libl(pd),w1)
  '
  if (d>0)and(d<c) then exit sub 'ALREADY LISTED SO EXIT
  '
  'ALWAYS STORE IN STATIC VARIABLE
  '-------------------------------
  '
  a=newstatvar()
  '
  'CREATE A NEW VECTOR
  '-------------------
  '
  if cpuw=4 then
    wr="02 hl"+hex(a)+" "+w1+cr 'LINK DATA
  else
    wr="02 hq"+hex(a)+" "+w1+cr 'LINK DATA
  end if
  '
  lw=len(wr)
  '
  maco(mp,2)=a 'RECORD STATIC OFFSET
  '
  'EXTEND BUFFER IF NEEDED
  '-----------------------
  '
  e=len(libl(pd))
  if e<c+lw+1 then libl(pd)+=space(2048)
  '
  'APPEND PROC NAME AND REGSS OFFSET TO LIST
  '-----------------------------------------
  '
  mid(libl(pd),c+1)=wr
  libu(pd)=c+lw
  '
  impo=1
  '
end sub




'------------------------------
function bindlprocs() as string
'==============================
  '
  dim as sys a,k
  dim as string wa
  dim as string w1
  '
  '---------------------
  'BUILD BIND PROCEDURES
  '---------------------
  '
  a=dlb
  k=j
  wa=cr+stodata("")
  do
    if a>=libe then exit do
    '
    'PROCESS PROC ADDRESSES FOR EACH LIBRARY
    '---------------------------------------
    '
    if libu(a) then
      '
      '--------------------------------------------------
      'ONLY PROCS THAT HAVE BEEN INVOKED ARE TO BE LINKED
      '--------------------------------------------------
      '
      'LOAD LIBRARY MODULE
      '-------------------
      '
      ape(dats,dati,cr+"01 `"+libs(a)+"` 00"+cr)
      '
      'LOAD PROC LIST
      '--------------
      '
      ape(dats,dati,left(libl(a),libu(a) ))
      '
      'CLEAR PROC LIST
      '---------------
      '
      libu(a)=0 ' recycle space in buffer
      '
     end if
    '
    'NEXT LIB
    '
    a+=1
    '
  loop
  '
  'CLEAR LIBRARY LIST
  '------------------
  '
  libe=dlb : dlb=1
  '
  '
  'TERMINATION CODE
  '----------------
  '
  if cpuw=4 then
    w1="03 hl0"
  else
    w1="03 hq0"
  end if
  '
  ape(dats,dati,w1+cr)
  '
  'CALL RUNTIME DLL BINDER
  '
  function=wa+rtl(bindlsa)+cr+"cmp al,100"+cr+"jge fwd _error_"+cr 'ERROR QUIT
  '
  impo=0
  '
end function




