
'=============
'TYPE CATEGORY
'=============

'ASSUME SYS BYVAL

'--------------------------------
function iscpu(a as sys) as sys
'================================
asm
  xor eax,eax
  mov ecx,[a]
  cmp ecx,0
  jz xiscpu
  cmp ecx,&h40
  jge xiscpu
  niscpu:
  dec eax
  xiscpu:
  mov [function],eax
end asm
end function

'------------------------------
function isfpu(a as sys) as sys
'==============================
asm
  xor eax,eax
  mov ecx,[a]
  cmp ecx,&h40
  jl xisfpu
  cmp ecx,&h80
  jge xisfpu
  dec eax
  xisfpu:
  mov [function],eax
end asm
end function

'------------------------------
function isfloat(a as sys) as sys
'==============================
asm
  xor eax,eax
  mov ecx,[a]
  cmp ecx,&h60
  jl xisflo
  cmp ecx,&h80
  jge xisflo
  dec eax
  xisflo:
  mov [function],eax
end asm
end function

'------------------------------
function isstr(a as sys) as sys
'==============================
asm
  xor eax,eax
  mov ecx,[a]
  cmp ecx,&ha0
  jl xisstr
  cmp ecx,&h100
  jge xisstr
  nisstr:
  dec eax
  xisstr:
  mov [function],eax
end asm
end function

'------------------------------
function isdstr(a as sys) as sys
'==============================
asm
  xor eax,eax
  mov ecx,[a]
  cmp ecx,&hc0
  jl xisdstr
  cmp ecx,&h100
  jge xisdstr
  nisdstr:
  dec eax
  xisdstr:
  mov [function],eax
end asm
end function

'------------------------------
function isbstr(a as sys) as sys
'==============================
asm
  xor eax,eax
  mov ecx,[a]
  cmp ecx,&hc0
  jl xisbstr
  cmp ecx,&he0
  jge xisbstr
  nisbstr:
  dec eax
  xisbstr:
  mov [function],eax
end asm
end function


'------------------------------
function iszstr(a as sys) as sys
'==============================
asm
  xor eax,eax
  mov ecx,[a]
  cmp ecx,&ha0
  jl xiszstr
  cmp ecx,&hc0
  jge xiszstr
  niszstr:
  dec eax
  xiszstr:
  mov [function],eax
end asm
end function

'=========

'--------------------------------------------
function upgradelen(a as sys,b as sys) as sys
'============================================
asm
  mov ecx,[b]
  mov eax,[a]
  mov edx,eax
  and ecx,31
  and edx,31
  cmp ecx,edx
  jle nupgradl
  and eax,&hffffffe0
  or eax,ecx
  nupgradl:
  mov [function],eax
end asm
end function


'-----------------------------------------
sub roundup(byref v as sys,byval n as sys)
'=========================================
  dim as sys c
  '
  'IF LARGER THAN 4 BYTES (OR 8 BYTES) THEN ROUND UP TO NEXT
  '
  if n>cpuw then
    c=-cpuw
    c=n and c
    if c<n then n=c+cpuw
  end if
  '
  'ROUND UP TO NEXT ALIGNMENT
  '
  c=-n
  c=v and c
  if c<v then v=c+n
end sub



'========
'DATABASE
'========



'-------------------------------------------------------------
sub init4(byval p as any ptr, byval le as sys, byval c as sys)
'=============================================================
  asm
  mov edx,[p]
  mov ecx,[le]
  mov eax,[c]
  inil:
    mov [edx],eax
    add edx,4
    dec ecx
  jg inil
  end asm
end sub



'------------------------------------------
function hashcode(byref s as string) as sys
'==========================================
  dim as sys le
  dim as any ptr p
  le=len(s) : p=strptr(s)
  asm
  xor eax,eax
  mov ecx, [le]
  mov edx, [p]     ' name pointer
  mov ah,  cl      ' length
  mov al,  [edx]   ' 1st letter
  cmp cl,1
  jz xhash
  shl eax,3
  xor al,  [edx+1] ' 2nd letter
  shl eax,3
  nexh:
    rol eax,1
    xor al, [edx]
    inc edx
    dec ecx
  jnz nexh
  xhash:
  mov [function],eax
  end asm 
  '
end function



'=====================
'STRING POOL FUNCTIONS
'=====================

'-------------------------
sub macoin(byval m as sys)
'=========================
 init4 @maco(m,0),smaco,0
end sub


'-----------------------------------------------------------
sub macsi(byref w as string, byval m as sys, byval n as sys)
'===========================================================
  '
  'STORE STRING IN BUFFER
  'INDEX IT IN MACO (WITH OFFSET OF N)
  '
  dim as sys b,le
  n+=omacs
  le=len(w) : if le=0 then maco(m,n)=0 : exit sub
  b=spe+le+4
  if b>spl then sps+=string(1000000,chr$(0))
  maco(m,n)=spe
  mk4(sps,spe,le) : mid(sps,spe+4)=w
  spe=b
end sub



'-------------------------------------------------------
function macso(byval m as sys, byval n as sys) as string
'========================================================
  dim as sys a,le
  dim as any ptr p
  n+=omacs
  a=maco(m,n) : if a=0 then exit function
  p=strptr(sps)
  asm
    mov eax,[p]
    add eax,[a]
    dec eax
    mov eax,[eax]
    mov [le],eax
    add dword ptr [a],4
  end asm
  function=mid(sps,a,le)
end function


'-------------------------------------------------------
function cmpsp(byval w as string, byval i as sys) as sys
'=======================================================
dim as sys le
dim as any ptr p,q
le=len(w) : p=strptr(w) : q=strptr(sps)
asm
  mov ecx,[p]
  mov edx,[q]
  add edx,[i]
  dec edx
  mov eax,[edx]
  cmp eax,[le]
  jnz xcmpsp 'FAIL LENGTH MATCH
  '----------
  and eax,255
  mov ah,al
  add edx,3
  dec ecx
  '---------
  rcmpsp:
  '---------
  inc edx
  inc ecx 
  sub ah,1
  jl dcmpsp 'SUCCESS
  mov al,[edx]
  cmp al,[ecx]
  jz rcmpsp 'LOOP OTHERWISE FAIL CHAR MATCH
xcmpsp:
  mov eax,0
  jmp fcmpsp
dcmpsp:
  mov eax,-1
fcmpsp:
  mov [function],eax
end asm
end function



'------------------------------------------
function lookupm(byref wd as string) as sys
'==========================================
  '
  dim as sys f,v,i,k
  i=hashcode(wd)
  '
  'TAKE THE BOTTOM 9 BITS OF THE HASH CODE
  'TO FORM A BASE INDEX TO SELECT A CHAIN
  '
  v=i and 511
  '
  'FIND THE LAST MATCHING NAME IN THE CHAIN
  '
  f=0
  do
    if mach(v).h=i then ' match#
      k=mach(v).m
      if k>=me then
        mach(v).m=0  'ZERO MACS PTR WHEN OUT OF SCOPE
      else
        if k<>0 then
          if cmpsp(wd,maco(k,omacs)) then f=k : mph=v 'MATCH CANDIDATE
        end if
      end if
    end if
    '
    'GET THE NEXT INDEX IN THE CHAIN
    '
    v=mach(v).l
    '
    'AND CHECK FOR CHAIN TERMINATION
    '
    if v<512 then exit do 'NO MORE AVAILABLE
  loop
  '
  function=f 'INDEX OF MATCHING NAME OR NULL
  '
end function


'------------------------------------------
function lookupc(byref wd as string) as sys
'==========================================
  dim as sys v,i
  i=hashcode(wd):v=i and 511
  do
    if opd(v,0)=i then ' match#
      if wd=opn(v) then exit do ' confirm perfect match
    end if
    v=opd(v,1) : if v=-1 then exit do
  loop
  function=v
end function


'---------------------------------------------
function isreserved(byref wr as string) as sys
'=============================================
  dim as sys a,b
  if wr="" then exit function
  '
  a=lookupm(wr)
  if a then
    if uniq then
      if mach(mph).b=brc then
        ers="'"+wr+"' is already defined"  : ert=13 : function=-1
        exit function
      end if
    end if
    b=maco(a,0)
    if b=-9 then 'or b=-10 'register
      ers="'"+wr+"' is a reserved word"  : ert=13 : function=-1
    elseif a<mesb then
      'ers="'"+wr+"' is a reserved symbol"  : ert=13 : function=-1
    end if
  end if
  '
  '
end function


'----------
sub addme()
'==========
  me+=1 : if me>=maxit then ers="Too many definitions" : ert=10 : me=maxit-1
end sub


'-------------------------
sub addmin(byval m as sys)
'=========================
  '
  dim as sys i,j,k,t
  '
  i=hashcode(macso(m,0)) : if i=0 then ers="zero hash failure: "+macso(m,0) : ert=13 : exit sub
  j=i and 511
  do
    t+=1
    if (mach(j).l<=0)or(mach(j).l>=mle)or(mach(j).m>=me) then
      if mle>=maxit then
        ers="Too many entities to include "+macso(m,0) : ert=13 : exit do
      end if
      if (j>=512)or(mach(j).h<>0) then
        mach(j).l=mle : j=mle : mle+=1
      end if
      '
      'mach(j).t=0   'USAGE TALLY
      mach(j).h=i   'FULL HASH CODE
      mach(j).l=0   'LINK TO NEXT
      mach(j).m=m   'INDEX TO MACO
      mach(j).b=brc 'NESTING LEVEL
      exit do 
      '
    end if
    j=mach(j).l ' next in chain
  loop
  if t>lmax then lmax=t
  '
end sub

'-----------------------
sub addm(byval m as sys)
'=======================
  if isreserved(macso(me,0)) then
    exit sub
  end if
  addmin(m)
end sub


'------------------------------------------------------
function capm(byval i as sys, byval k as sys) as string
'======================================================
  function=str(maco(i,k))+dfd+cr
end function

'-------------------------------------------------------------
function writestates(byval b as sys, byval e as sys) as string
'=============================================================
  dim as string s,w1,c
  dim as sys i,k,le
  c=dfd+cr
  for i=b to e
    w1=capm(i,0)+capm(i,1)+capm(i,2)+capm(i,3)+capm(i,4)+capm(i,5)+_
    macso(i,0)+c+macso(i,1)+c+macso(i,2)+c+macso(i,3)+c
    le=len(w1)
    if k+le>len(s) then s+=space(8000)
    mid(s,k+1)=w1
    k+=le
  next
  function=iq+left(s,k)+iq+cr
end function


'---------------------------------------------------------
function nexm(byref s as string, byref i as sys) as string
'=========================================================
  dim as sys k
  k=instr(i,s,dfd)
  if k then
    function=mid(s,i,k-i)
    i=k+3 ' skip dfd followed by cr
  else
    i=len(s)+1
  end if
end function



'--------------------------------
sub readstates(byref s as string)
'================================
  dim as sys c,i,k
  dim as string w1
  i=2
  do
    if i>=len(s) then
      exit do
    end if
    k=me : addme : if ert then exit do
    for c=0 to 5 'omacs-1
      w1=nexm(s,i)
      maco(k,c)=wval(w1)
    next
    for c=0 to 3
      w1=nexm(s,i)
      macsi(w1,k,c)
    next
    addm(k) : if ert then exit do
  loop
end sub





'=====
'PARSE
'=====


'------------------------------------------------------------
function memreg(byref rg as string, byval d as sys) as string
'============================================================
  dim as string wa
  if d>0 then wa="+"
  if d<>0 then wa+=str(d)
  function="["+rg+wa+"]"
end function


'-------------------------------------
sub set_macro_name(byref wr as string)
'=====================================
  '
  macsi(wr,me,0)
  addm(me)
end sub







'       #######
'      #       #
'      #       #
'              #
'             #
'       ######
'      #
'      #
'
'     ###
'     # #
'     ###

    '========
    'IDENTIFY
    '========




'----------------------------------------
function isreg(byref wr as string) as sys
'========================================
  '
  dim as sys a
  a=lookupm(wr)
  if a then if maco(a,0)=-10 then function=maco(a,2)+1
  '
end function


'----------------------------------------------------------------------------
function himac(byval mm as sys, byref  s as string, byref i as sys) as string
'============================================================================
  dim as sys a,b,m,n,md,igb
  dim as string w1,w2,w3,w4,w5
  md=maco(mm,5)  ' MODE 104 #DEFINE 109 ,MACRO
  w1=macso(mm,1) ' BODY
  w3=macso(mm,3) ' PROTOTYPE EXCLUDING OUTER BRACKETS
  skiplspace(s,i)
  if ascn=lbr then
    i+=1 : skiplspace(s,i) : igb=1
  end if
  if ltrim(w3)="" then
    goto nhimac
  end if
  '
  b=1
  do
    w4=tword(w3,b) : b+=1             ' CAPTURE PARAM FROM PROTOTYPE
    if w4="" then exit do            ' END OF PROTOTYPE PARAMS
    nextinstruct(s,i)
    if ascn=rbr then exit do   ' FINISH WHEN RIGHT BRACKET ENCOUNTERED
    m=i : capts(s,i)                 ' CAPTURE SINGLE WORD OR EXPRESSION
    w2=mid(s,m,i-m)                  ' CAPTURE PARAM
    '
    if ascn=44 then
      i+=1 : nextinstruct(s,i)
    end if 
    '
    'CHECK MACRO EXPANSION OF THE PARAM
    '
    m=lookupm(w2)
    if m then
      n=maco(m,0)
      if (n=-1)or(n=-20) then
        w2=macso(m,1)                'EXPANSION TO 1 LEVEL
      end if
    end if
    '
    replacewd(w1,w4,w2)              ' REPLACE W4 WITH W2 IN BODY W1
    '
  loop
  nhimac:
  function=w1
  if igb then if ascn=rbr then i+=1 'closing bracket 
  skiplspace(s,i)
  '
end function





'-------------------------------------------
function identype(byref s as string) as sys
'===========================================
  '
  dim as sys a,b,c,n
  static as string w1,wm
  wm=s
  indt=0 'TYPE INDIRECTION ACCUMULATOR
  ary="" 'TYPE ARRAY ACCUM
  
  '-------------------------
  ridentype: 'recursive loop
  '-------------------------
  '
  if wm="" then exit function
  '
  'STANDARD PRIMITIVE TYPES
  '------------------------
  '
  if wm="void" then
    function=-1 : exit function
  end if
  if wm="string" then lent=cpuw : function=&he1 : exit function
  a=lookupm(wm)
  if a=0 then exit function
  idvt:
  if maco(a,0)=-15 then
    n=maco(a,5)
    if instrword(" sys any ",wm) then 
    'if instrword(" sys any bool ",wm) then 
      n=cpuw : lent=cpuw
    elseif (n>=&hc0)and(n<&h100) then
      lent=cpuw
    else
      lent=n and 31 ' pointer (BSTR or BSTR byref)
    end if
    function=n
    exit function
  end if
  '
  '
  'TYPEDEF STRUCT CHECK
  '--------------------
  '
  do
    b=maco(a,0)
    if (b=-1)or(b=-20) then 
      wm=macso(a,1) : goto ridentype 'MACRO RECURSE
    end if
    '
    'RESOLVE TYPEDEF TYPE
    '
    if b<>-8 then exit do
    c=maco(a,3)
    indt+=c 'INDIRECTION
    '
    w1=macso(a,2)
    if len(w1) then
      ary=w1+" "+ary 'MINORMAJOR MODE ACCUM
    end if
    '
    b=maco(a,4) 'GET UNDERLYING TYPE
    if b<512 then
      n=b : lent=maco(a,1) : exit do 'PRIMITIVE TYPE
    else
      a=b-512 'LOCATE TYPE OR TYPEDEF
    end if
  loop
  '
  if b=-2 then lent=cpuw : n=a+512    'ENUMERATION
  if b=-3 then n=a+512 : lent=maco(a,1)      'TYPE / STRUCT / CLASS
  if b=-10 then lent=maco(a,1) : n=maco(a,1) 'REGISTER (RETURNING 8 QUAD 4=LONG 2=SHORT OR 1=BYTE)
  '
  function=n
  '
end function


'---------------------------------------------------------------
sub ctype(byref s as string, byref i as sys, byref wr as string)
'===============================================================
  '
  'TRANSLATE C PRIMITIVES
  '
  '
  'arrays and pointers and functions resolved in o2prep.bas
  '
  'UNSIGNED SHORT INTEGER ETC
  '
  dim as sys a,b,c,d,k,m
  dim as string wn
  m=2
  '
  if wr="unsigned" then
    a=&h20 : b=2
  elseif wr="signed" then
    a=&h00 : b=2
  end if
  '
  if b=2 then
    wn=wordahead(s,i) : c=lookupm(wn)
    if c then
      c=maco(c,0)
      if c=-15 then i=nwd : wr=wn 'ready for next word
    end if
  end if
  '
  if wr="short" then
    m=1 : b=3
  'elseif (wr="long")or(wr="wide")  then
  elseif wr="wide"  then
    m=4 : b=3
  end if
  '
  if b=3 then
    wn=wordahead(s,i)
    if wn<>wr then 'excluding long long etc
      k=lookupm(wn)
      if k then
        d=maco(k,0)
        if d=-15 then
          i=nwd : wr=wn 'ready for next word
        end if
      end if
    else
      b=2
    end if
  end if
  '
  skiplspace(s,i)
  '
  c=identype(wr)
  '
  if typ<&h100 then
    if b then
      typ or=a 'SIGNED / UNSIGNED ADJUSTMENT
      if b=3 then lent*=m*.5 'LENGTH ADJUSTMENT
      'itr long double=extended (10 bytes)
      typ=(typ and &hffffffe0)+lent 'REFORMULATE TYPE
      wn=revdic(idtype,typ) 'REDEFINE TYPE NAME
      if len(wn) then wr=wn
    end if
  end if

end sub



'--------------------------------------------
function identypes(byval tp as sys) as string
'============================================
  '
  dim as sys l
  dim as string wr
  l=tp and 31
  select case l
  case  1 : wr="byte  "
  case  2 : wr="word  "
  case  4 : wr="dword "
  case  8 : wr="qword "
  case 12 : wr="eword "
  case 16 : wr="oword " ' mmx xmm registers supported in asm only
  end select
  function=wr
  '
end function

'-----------------------------------------------------------------------------------
sub varreg(byval pn as sys, byval dd as sys, byref wt as string, byref ws as string)
'===================================================================================
  dim as sys a,b
  if dd then a=cpuw else a=identype(wt)
  b=pn
  if (a>=&h40)and(a<=&h80) then b+=7 'XMM REGISTER
  ws+=" at "+regn(b)
end sub



'-----------------------------------------------------------
function readval(byref wm as string, byref k as sys)  as sys
'===========================================================
  '
  dim as sys a
  skipspace(wm,k)
  a=wval(mid(wm,k,5))
  nextspace(wm,k) : k+=1
  function=a
  '
end function


'-----------------------------------------------
sub readvals(byref wm as string, byref k as sys)
'===============================================
  '
  woff   = readval(wm,k) ' OFFSET
  varf   = readval(wm,k) ' ELEMENT VAR/PROC/METHOD
  priv   = readval(wm,k) ' PUBLIC/PRIVATE/PROTECTED 
  '
  '
  'SIGNATURES ETC
  '==============
  '
  dim as sys a,c,m,v
  dim as string w1
  '
  'CALLING-CONVENTION ETC
  '----------------------
  '
  cco=asc(uword(wm,k))-65
  '
  'PARAMS SIGNATURE
  '----------------
  '
  if ascn=44 then sig="" : k+=1 else sig=uword(wm,k)
  '
  '
  '
  'RETURN SIGNATURE (AND TYPE)
  '---------------------------
  '
  sog=uword(wm,k)
  typ=wval(sog)
  if typ=0 then typ=identype(sog)
  '
  elsize=lent
  '
  '
  '
  'DEFAULT PARAM VALUES (,a=3,b=4,)
  '--------------------------------
  '
  if ascn=lbr then
    capture(wm,m,k,a) : dvl=mid(wm,m,k-m)
  end if
  '
end sub



'----------------------------------------
function getreg(byval m as sys) as string
'========================================
  function=mid(macso(m,1),2,3)
end function


'--------------------------------------------
sub nextel(byref wm as string,byref k as sys)
'============================================
  '
  'GET NEXT ELEMENT IN STRUCTURE
  '-----------------------------
  '
  dim as sys a
  dim as string w1
  typ=0
  if k=0 then k=1
  do
    k=instr(k,wm,htb)
    if k=0 then exit do
    k+=1
    w1=wordahead(wm,k)
    if right(w1,2)="__" then continue do 'SKIP __ names (pvft and private)
    k=instr(k,wm," ")
    if k=0 then exit do
    '
    'READ ATTRIBUTES
    '===============
    '
    readvals(wm,k)
    if (typ=0)or(typ>=&h200) then continue do
    exit do
  loop
end sub

'--------------------
sub gettoff(m as sys)
'====================
  dim as sys c
  toff=0
  c=lookupm(macso(m,0)+"_table")
  '
  if c then
    regst=getreg(c)
    toff=maco(c,2) 'TABLE BASE OFFSET USED LATER
  else
    regst=""
  end if
end sub


declare sub indir(byref wr as string, byval n as sys)


'-----------------------------------------------------------------
sub matchm(byref wki as string,byref wr as string,byref ki as sys)
'=================================================================
  '
  dim as sys a,b,m,n,v,c,k,dt,chmp,ml
  dim as string wm,wn,w1,wk
  '
  wk=wki : ml=mp
  '
  'IS IT A VARIABLE?
  '=================
  '
  m=maco(ml,0)
  '
  'STRUCTURE INDEX
  '
  if m>=0 then
    ind=maco(ml,3) and 255  'INDIRECTION
    voff=maco(ml,2) 'BASE OFFSET OF VARIABLE
    '
    if ind=0 then 
      wn=getreg(ml) ' regs if is a var
    else
      wn=qedi : indir(macso(ml,1),ind) 'CREATE INDIRECTION CODE
    end if
    '
  else 'NOT A VAR
    '
    m=ml : ind=0 : voff=0 'ASSUME IT IS A TYPE STRUCTURE
    wn=""
    '
  end if
  '
  '
  '
  '-------------------------------------------------
  rmatchm:  'RECURSION POINT FOR INDIRECT STRUCTURES
  '-------------------------------------------------
  '
  'GET STRUCTURE
  '-------------
  '
  wm=macso(m,1)
  if dt=0 then k=ki
  vtp=maco(m,3) 'virtual table pointer field is present?
  '
  '
  'CHECK ELEMENT EXISTS
  '--------------------

  a=instrevn(k,wm,htb+wk+" ") : chmp=0

  if a=0 then
    '
    'CHECK FOR INDIRECT STRUCTURE
    '----------------------------
    '
    'LOOK FOR DOTTED PART OF NAME
    '
    b=instr(wk,".")
    '
    if b then
      w1=left(wk,b-1)
      '
      a=instrevn(k,wm,htb+w1+" ")
      '
      if a=0 then
        ki=0 : exit sub 'NOT LOCATED
      end if
      '
      wk=mid(wk,b+1) 'CHOMP W1
      b=len(w1) 'first part of name located
      chmp=1
      '
    else
      '
      ki=0 : exit sub 'NOT LOCATED
      '
    end if
  else 'main name located
    b=len(wk)
  end if
  '
  'SET PRIMARY LOCATOR AND DISABLE FURTHER UPDATES
  '
  if dt=0 then ki=a : dt=1
  '
  'READ ATTRIBUTES
  '===============
  '
  k=a+b+2 'skip over identified name
  readvals(wm,k)
  if elsize=0 then nextel(wm,k)
  '
  'INHERITED METHODS
  '-----------------
  '
  v=0 : c=m 'SET C SAME AS STRUCTURE
  '
  if varf then
    '
    if varf<9 then v=woff 'STRUCTURE OFFSET
    '
    'CHECK FOR CLASS STATIC ELEMENTS AND METHODS
    '-------------------------------------------
    '
    'VARF CODES
    '
    '1   body member
    '2   static member
    '3   pointer body member
    '4   pointer static member
    '8   procedure pointer
    '9   method pointer
    '10+ inherited method pointer
    '
    '
    'STATIC ELEMENTS
    '---------------
    '
    if (varf=2)or(varf=4)or(varf>8) then
      gettoff(m)
      if (varf=2)or(varf=4) then
        wn=regst : voff=toff 'USE TABLE BASE FOR STATIC VARIABLES
      end if
    end if
    '
  end if ' VARF
  '
  'VISIBILITY RESTRICTIONS
  '-----------------------
  '
  'private properties are invisible
  'looking at the last code word in the record:

  if priv<>9 then
    if macso(ml,0)<>"this" then
      ers="Private / Protected member: "+ow : ert=401
    end if
  end if
  '
  'STATIC VARIABLE OFFSET
  '----------------------
  '
  if (ind=0)or(varf=2)or(varf=4) then
    if (ml<>c) then v+=voff 'ADD VARIABLE BASE IF VF TABLE IS USED
  end if
  '
  'REBUILD THE ADDRESS OPERAND
  '===========================
  '
  if v<>0 then
    '
    m=asc(wn)
    '
    'RESOLVE HOST ADDRESS WITH OFFSET
    '--------------------------------
    '
    if m=35 then
      'resolve to abs address
      n=getvarptr(wn) : if n=0 then ert=300 : ers="Host variable not located: "+wn
      wn=str(n+v) : v=0
    end if
    '
    'ADJUST ABSOLUTE ADDRESS OFFSET
    '------------------------------
    '
    if isn(m) then
      '
      'QUICK HEXADECIMAL CHECK
      '
      n=asc(wn,2)
      if n=&h78 then mid(wn,1)="&h"
      wn=str(wval(wn)+v) : v=0
    end if
    '
  end if
  '
  wr=memreg(wn,v) 'COMPOSE OPERAND
  '
  '
  'CHECK IF INDIRECT STRUCTURE POINTER
  '===================================
  '
  if (varf=3)or(varf=4) then
    if len(wk) then
      '
      'IF FURTHER RESOLUTION REQUIRED
      '
      indir(wr,1)
      '
      if chmp=0 then
        wr=pedi : exit sub 'RESOLVED
      end if
      '
      wn=qedi
      ml=typ-512
      m=ml : ind=0
      voff=0 : toff=0
      k=-1
      goto rmatchm 'LOOP RECURSE FOR NEXT STRUCTURE
    end if
  end if
  '
  if wn<>qedi then wpfx="" 'STATIC MEMBER DIRECT
  '
end sub



'---------------------------------------------------------------------------------------------
function identop(byref s as string, byval k as sys, byref i as sys, byval wr as string) as sys
'=============================================================================================
  '
  ' n   operator code
  ' prl precedence level
  dim as sys n,a,b
  '
  '
  if len(wr)=1 then
    '
    a=asc(wr) : n=a
    '
    'higher prl means higher precedence
    '----------------------------------
    if a=94 then prl=8 : goto idop '^ power or C Xor ??
    if a=92 then prl=7 : goto idop '\
    if a=47 then prl=7 : goto idop '/
    if a=42 then prl=7 : goto idop '*
    '----------------------------------
    'power        8 ^
    'mult div     7 * / \
    'add subtract 6 + -
    'shifts       5 << >>
    'comparators  4 == <> > < >= <=
    'logicals     3 and 2 xor 1 or
    '----------------------------------
    '
    b=asc(s,k+1)
    '
    if (a=43)or(a=45) then
      prl=6                    '+ -
      if a=b then i+=1 : prl=9 '++ --
      goto idop '+
    end if
    '
    n=0
    '
    'AND && &
    '
    if a=38 then
      if b<>a then
        if (i>k+1)or(b=lbr) then n=33 : prl=3 : goto idop '&
        goto idop ' &h ignore
      end if
      i+=1 : n=71 : prl=3 : goto idop '&&
    end if
    '
    'OR || |
    '
    if a=124 then
      prl=1
      if b<>a then n=34 : goto idop    '|
      i+=1 : prl=1 : n=72 : goto idop  '||
    end if
    '
    if a=33 then
      if b=61 then i+=1 '!=
      n=101 : prl=4
      goto idop 'NOT !
    end if
    '
    '<< < <= <>
    '
    if a=60 then
      if b=60 then i+=1 : n=74 : prl=5 : goto idop '>> SHIFT LEFT
      prl=4             'COMPARATORS
      if b=61 then i+=1 '<=
      if b=62 then i+=1 '<>
      n=101 : goto idop '<
    end if
    '
    '= ==
    '
    if a=61 then
      prl=4 : n=101            '=
      if b=61 then i+=1 : goto idop '==
      if cnd=0 then n=0 : prl=0 'EXCLUDES A()= a()=> ASSIGNMENTS
      goto idop
    end if
    '
    '>> > >=
    '
    if a=62 then
      if b=62 then i+=1 : n=75 : prl=5 : goto idop 'SHIFT RIGHT
      prl=4             '>
      if b=61 then i+=1 '>=
      n=101 : goto idop 'COMPARE
    end if
  else
    '
    'LENGTH WORD >1
    '
    if wr="and"  then n=33 : prl=3 : goto idop
    if wr="xor"  then n=35 : prl=2 : goto idop
    if wr="or"   then n=34 : prl=1 : goto idop
  end if
  '
  'itr unaries?
  '
  'USER DEFINED OPERATORS
  '----------------------
  '
  a=lookupm(wr)
  '
  if a then
    if macO(a,0)=-12 then n=a+512 : prl=maco(a,5) 'precedence level
  end if
  '
  idop:
  '
  function=n
  '
end function


'-------------------------------------------------------------------------------
function identopeq(byref s as string, byref i as sys, byref w1 as string) as sys
'===============================================================================
  dim as sys a,b
  if ascw=60 then
    exit function
  elseif ascw=61 then
    function=2
    w1="mov "
    if cnd then
      function=&h14
      if asc(s,swd+1)=61 then i+=1 : skiplspace(s,i)
    end if
    exit function
  end if
  '
  b=swd
  a=identop(s,b,i,wordahead(s,swd))
  if a=0 then exit function
  '
  i+=1 'JUMP OVER `=`
  'opns=qu+mid$(s,b,i-b)+qu 'record operator
  ascw=61 : skiplspace(s,i)
  '
 if a=43 then
    op=43 : w1="add " : function=8  ' +=
  elseif a=45 then
    op=45 : w1="sub " : function=9  ' -=
  elseif a=42 then
    op=42 : w1="mul " : function=14 '*=
  elseif a=47 then
    op=47 : w1="div " : function=15 '/=
  elseif a=33 then
    op=33 : w1="and " : function=65 'AND=    
  elseif a=34  then
    op=34 : w1="or "  : function=66 'OR=
  elseif a=35 then
    op=35 : w1="xor " : function=67 'XOR=
  end if
end function


'------------------------------------------
function identops(byval n as sys) as string
'==========================================
dim as sys a
dim as string w1
  '
  'CHECK FOR USER DEFINED / EXOTIC OP
  '
  if n>512 then function=macso(n-512,0) : exit function
  w1=" "+str(n)+" "
  a=instr(opname,w1)
  if a then
    function=noquotes(tword(opname,a+len(w1)))
  end if
end function



declare function mword(byref s as string, byref i as sys) as string

'---------------------------------------------------------
function attributes(s as string, byref i as sys) as string
'=========================================================
  '
  dim as sys kn,a,c,k,m,wa
  dim as string wr,w1
  '
  kn=maco(mp,5)
  '
  if ascn=lbr then c=1 : i+=1 'SKIP LEFT BRACKET
  '
  w1=mword(s,i) 'resolve
  '
  if c then
    if ascn=rbr then
      i+=1 : skiplspace(s,i) 'BLANK RIGHT BRACKET
    end if
  end if
  '
  '
  '
  wr="0" : k=mp : m=k
  '
  'VARIABLE OR STRUCTURE ?
  '
  if mc>=0 then
    m=mc
  end if
  '
  '
  '
  select case kn
  case 1
    if mc=0 then
      if isn(ascw)or(ascw=38) then
        if dtf then
          wa=8
        else
          wa=cpuw
        end if
        goto attrin
      elseif isq(ascw) then
        wa=cpuw
        goto attrin
      end if
    end if
    if mc>=0 then
      wa=lent
    elseif instrword(" string wstring bstring bstring2 ",w1) then
      wa=cpuw
    elseif instrword(" char zstring asciiz ",w1) then
      wa=1
    elseif instrword(" wchar zstring2 ",w1) then
      wa=2
    elseif mc<0 then
      a=identype(w1) : if a then wa=lent 'SIZEOF
    end if
    goto attrin
  case 2
    if mc>=0 then
      wa=maco(mp,2)+woff
    end if
    goto attrin                     'OFFSETOF
  case 3
    if mc>=0 then
      wa=maco(mp,4)                   'SPANOF: NUMBER OF ELEMENTS OF MAIN ARRAY
      if wa=0 then wa=1
    end if
    goto attrin
  case 4                            'TYPEOF:
    wa=typ
    if (wa=0)and(mp=0) then
      if isn(ascw)or(ascw=38) then
        if dtf then
          wr="double"
        else
          wr="sys"
        end if
      elseif isq(ascw) then
        wr="string"
      else
        wr="unknown"
      end if
      goto attris
    end if
    if mc<0 then
      wr="metatype "+str(mc)+" "+_
     dicsn(metatypes,mc)            'TYPEOF TYPE
    elseif mc=0 then
      wr=sog                        'PRIMITIVE TYPE
    else 'if a>0 then
      wr=sog                        'COMPOUND TYPE
    end if
  case 5
    wr=macso(m,1)                   'STRUCTUREOF ENCODINGOF
  case 6
    wr=macso(k,3)                   'PROTOTYPEOF
  case 7
    wa=typ                          'TYPECODEOF
    if (wa=0)and(mp=0) then
      if isn(ascw)or(ascw=38) then
        if dtf then
          wa=&h68
        else
          wa=cpuw
        end if
      elseif isq(ascw) then
        wa=&hc1
      else
        wa=typ
      end if
    end if
    goto attrin
  case 8
    wr=noquotes(writestates(k,k))   'RECORDOF
  end select
  '
  '
  '-----
  attris:
  '-----
  '
  wr=chr(iq2)+wr+chr(iq2) : goto attrix
  '
  '-----
  attrin:
  '-----
  '
  wr=str(wa)
  '
  '-----
  attrix:
  '-----
  '
  mc=0 : mp=0 : mq=0 : typ=0 : varf=0
  function=wr
  '
end function



declare sub addlproc()
declare function metaval( byref s as string, byref i as sys, byref wa as string) as double





' #######   ######  ######
'  #     #  #       #
'  #     #  ####    ####
'  #     #  #       #
' #######   ######  #

'-------------------------------------------------------------------
function macres(m as sys,byref s as string,byref i as sys) as string
'===================================================================
  dim as sys a,b,c,d,n,v
  dim as string w1,wk
  '
  wk=macso(m,1)
  '
  '---------------------
  'LOW LEVEL MACRO (-1 )
  '=====================
  '
  'CHECK NO SUBSTITUTIONS
  '
  if incli then goto nmacres
  '
  'FIND HIGHEST PARAMETER
  '
  a=1 : b=48
  do
    c=asc(wk,a)
    if c=0 then exit do
    if c=37 then
      a+=1 : v=asc(wk,a)
      if (v>b)and(v<58) then b=v 'UP TO 9 PARAMS
    end if
    a+=1
  loop
  '
  'MAKE SUBSTITUTIONS
  '
  b-=48
  a=1
  '
  'GRAB MACRO PARAMETERS
  '
  do
    b-=1 : if b<0 then exit do
    c=asc(s,i)
    '
    'CAPTURE CONTENT BETWEEN BRACKETS
    '
    if isb(c) then
      wp(a)=captureblock(s,i,"")
      a+=1 : continue do
    elseif ise(c) then
      'end of line : no further params
      wp(a)="" : a+=1 : continue do
    end if
    '
    'CAPTURE INDIVIDUAL WORD / NUMBER
    '
    'standard lexing
    '
    w1=tword(s,i)
    '
    '
    'CHECK TO SEE IF PARAMETER IS A MACRO (BUT NO FURTHER RECURSION HERE)
    '
    if isn(ascw)=0 then
      c=lookupm(w1)
      if c then
        d=maco(c,0)
        if (d=-1)or(d=-20) then
          w1=macso(c,1)
        end if
      end if
    end if
    '
    'ENSURE CAPTURE NEGATIVE NUMBER
    '
    if ascw=45 then
      c=asc(s,swd+1) : if isn(c) then w1+=tword(s,i)
    end if
    '
    wp(a)=w1
    a+=1
  loop
  a=1
  '
  'SUBSTITUTE WORD SYMBOLS AND MARKUP BLOCK SYMBOLS
  '------------------------------------------------
  '
  do
    a=instr(a,wk,"%") 'ascii 37
    if a=0 then exit do
    b=ascl(wk,a+1) : n=a+2
    if b=37 then ' %37
      wk=left(wk,a)+mid(wk,a+2) : a+=1
      do
        a+=1
        if asc(wk,a)<>37 then exit do
      loop
      continue do ' %% ESCAPE %
    end if
    b-=48
    if (b>0)and(b<10) then
      wk=left(wk,a-1)+wp(b)+mid(wk,n)
      a+=len(wp(b))-1
    else
      a+=2
    end if
  loop
  '
  nmacres:
  '
  incli=0
  function=wk
end function



declare sub vars(byref s as string, byref i as sys)



'   #####                      #####
'  ######                      ######
'  ##                              ##
'  ##   ##########    ##########   ##
'  ##  ############  ############  ##
'  ##  ##    \|/ ##  ##    \|/ ##  ##
'  ##  ##    -O- ##  ##    -O- ##  ##
'  ##  ##    /|\ ##  ##    /|\ ##  ##
'  ##  ############  ############  ##
'  ##   ##########    ##########   ##
'  ##                              ##
'  ######                      ######
'   #####                      #####



'-----------------------------------------------------------
function mword(byref s as string, byref i as sys ) as string
'===========================================================
  '
  ' s    source
  ' i    position in source
  ' swd  start of word position
  ' a    ascii code
  ' b    general purpose
  ' k    general purpose
  ' wr   word
  ' wk   struc or variable string
  ' wm   struc or variable string
  ' wn   gen
  ' wp   () capture macro parameters

    dim as sys a,b,c,k,m,n,v,kn
    dim as string wr,wk,wm,wn,wo,W1

    typ=0 : varf=0 : elsize=0
    mc=0 : mp=0 : mq=0 : woff=0
    '
    wr=tword(s,i)
    '
    'CHECK FOR COLON LABELS
    '----------------------
    '
    'first word on line
    '
    if nl then
      if ascn=58 then
        if swd+lenw=i then
          if ascw=46 then
            i=swd+1 : wr=tword(s,i) 'STRIP DOT AND LEAVE COLON
          end if
          mp=lookupm(wr)
          if mp then
            a=maco(mp,0)
            if (a=-13)or((o2h>0)and((a=-14)or(a=-19))) then 
              mc=a : goto mwcases 'exclude these keywords as labels
            end if
          end if
          goto exitmword1
        end if
      end if
    end if
    '
    if ascw>250 then goto exitmword1 '(not iq4 which is ascii 250)
    '
    'ASM OPERANDS
    '------------
    '
    if ascw=91 then
      a=instr(swd,s,"]")
      if a then
        a+=1 : lenw=a-swd : wr=mid(s,swd,lenw)
        i=a : skiplspace(s,i)
      end if
    end if
    '
    'EXPECTING ENUMERATION TYPE
    '--------------------------
    '
    '
    if enu then
      if isa(ascw) then
        a=1
        '
        'CHECK FOR VARIABLE TO VARIABLE ASSIGN/COMPARE
        '---------------------------------------------
        '
        b=lookupm(wr) : if b then if maco(b,0)>0 then a=0
        '
        'OTHERWISE IT IS AN ENUMERATION VALUE TO LOCATE
        '----------------------------------------------
        '
        if a then
          wk=wr : mp=enu : mq=mp : mc=-2 : dtf=-1 : goto mwcases
        end if
      end if
    end if
    '
    'WITH prefix
    '-----------
    '
    if wi then if ascn=61 then inserts(s,wth+wr,i) : wr=tword(s,i)
    '
    '
    ow=wr
    '
    '
    '--------------------------------------------------
    wredo: 'RECURSION POINT FOLLOWING A MACRO EXPANSION
    '==================================================
    '
    if nquot=0 then goto quotyp
    '
    'HUGE RECURSION CHECK
    '--------------------
    '
    mct+=1
    if (mct>=&h400)or(len(s)>mex) then
      ert=102 : goto exitmword
    end if
    '
    '
    wk=""
    '
    if wr="" then goto exitmword1
    'if compo then goto ncompo
    '
    'ASSEMBLER OPERANDS
    '------------------
    '
    if ascw=91 then
      m=swd
      a=instr(m,s,"]")
      if a>m then
        i=a+1
        '
        if i=swd+2 then goto sqbrw 'EMPTY []
        '
        wk=mid(s,m,a-m)
        '
        a=2 : c=0 : w1=tword(wk,a)
        '
        if ascw<>35 then
          '
          'RESOLVE VARIABLE FB SYNTAX [VAR]
          '
          if dtf then a=dtf-1 else a=lenw 
          a=lookupm(left(w1,a))
          if a then
            c=maco(a,0)
            if (c>=0)or(c=-14) then 'allow [function] or [method]
              wk=w1 : goto insertw 'RECURSE WITH VARIABLE NAME
            end if
          end if
        end if
        '
        'OTHERWISE ASSUME A NORMAL ASM MEMORY OPERAND
        '
        a=1
        do
          b=asc(w1,a)
          if b<32 then a=0 : exit do
          if (b=35)or(b=36)or(b=37)or(b=64) then c=-10 : exit do
          a+=1
        loop
        '
        if c<>-10 then
          ert=10 : ers="unknown " : exit function
        end if
        '
        if a then
          '
          'RESOLVE  #MACRO
          '
          wn=left(wk,a-1) 'HOLD LEFT SIDE
          if b<>35 then a+=1 'exclude % $ prefix
          w1=tword(wk,a)
          b=lookupm(w1)
          '
          if b then
            w1=macso(b,1) '[ .. #mac]
            m=maco(b,0)
            if m>=0 then
              '
              'possibly a variable then strip [.. ]
              '
              if asc(w1)=91 then
                m=instr(w1,"]") : w1=mid(w1,2,m-2)
                m=1
                wn+=tword(w1,m)
                wn+=mid(w1,m,1) ' [ebx+ not to be evaluated
                ascn=asc(w1,m)
                w1=mid(w1,m+1) 'capture remainder for evaluation
              end if
            end if
          else 'if b=0
           b=getvarptr(w1)
           if b then w1=str(b) 'HOST VARIABLE ADDRESS
          end if
          '
          if b then
            '
            'TEST FOR EXPRESSION
            '
            if (ascn=42)or(ascn=43)or(ascn=45) then
              wm=w1+mid(wk,a) 'REASSEMBLE EXPRESSION FOR METAVAL
              '
              b=metaval(wm,1,w1)
              '
            end if '*+- metaval 'RESOLVE METAEXPRESSION
            '
            'REASSEMBLE  AND INSERT ADDRESS OPERAND
            '
            inserts(s,wn+w1+"]",i) : m=i : i+=len(w1)+len(wn)+1
            '
          end if 'b
        end if ' #
      end if ' `]`
      '
      sqbrw: 'RETURN WHOLE [..] ASM MEMORY OPERAND
      '
      swd=m : wr=mid(s,swd,i-swd) : skiplspace(s,i)
      goto exitmword 
    end if '[..]  91
    '
    '
    'SYMBOLS, NUMBERS, DOT LABELS PASS THRU
    '--------------------------------------
    '
    '
    '=====================================
    quotyp: 'determine literal string type
    '=====================================
    '
    if nquot=0 then
      'if lenw<=8 then
      '  mp=lookupm(wr)
      '  if mp=0 then
      '    cnst=1 : vars(w1+wr+" "+wr,1) : mp=me-1 : cnst=0
      '  end if
      '  wpfx=macso(mp,1) : sgl=wpfx : wr="eax"
      '  nquot=1
      '  mp=0
      '  skiplspace(s,i)
      'end if
      typ=&hc1
      goto exitmword
    end if
    '
    a=0
    '
    '->
    '
    if o2h then
      if ascn=45 then
        if isc(ascw)=0 then
          if asc(s,i+1)=62 then i=swd : wr=arrows(s,i,1)
        end if
      end if
    end if
    '
    if (ascw>=36)and(ascw<=64) then
      a=1
      if ascw=38 then
        '
        ' `&B` `&H` `&O` NUMBERS
        '
        'use workaround for addresses that look like basic numbers: &h1 &b2 etc: & h1, & b2
        '
        numco(s,i) 'converts &h to 0x etc
      end if
    end if
    '
    'LITERAL NUMBERS CHECK
    '
    if a then
      if isn(ascw) then wordval(s,swd,i)
      if nan=0 then
        if dtf then
          typ=&h68 : lent=8
        else
          typ=cpuw : lent=cpuw
        end if
        wr=mid(s,swd,i-swd)
      end if
      goto exitmword1
    end if
    '
    '----------------------
    'CHECK FOR DOTTED NAMES
    '======================
    '
    if dtf then
      ow=wr             'original (after macro resolution)
      wk=mid(wr,dtf+1)  'possible member
      wr=left(wr,dtf-1) 'possible name
      if wr="that" then
        wr=wk : dtf=instr(wr,".") : nth=1
      end if
    end if
    '
    '
    mp=lookupm(wr)
    b=0
    '
    '
    if nth then nth=0 : goto notthis 'That' override
    '
    '
    'GIVE PRIORITY TO IMPLICIT `THIS` SYMBOLS IN METHODS
    '---------------------------------------------------
    '
    'BUT CORE SYMBOLS ALWAYS HAVE PRIORITY (MESB)
    '
    if ths then
      if mp=0 then
        b=ths
      elseif mp<mesb then
        '
        ''check for register-like names eg ax bx cx
        '
        if maco(mp,0)=-10 then
          w1=wr : m=maco(ths,0)
          c=instrevn(-1,macso(m,1),htb+w1+" ")
          if c then mp=ths : wk=w1 : dtf=5 : goto dtvar
        end if
      elseif mp<mest then
        b=ths
      elseif wr="this" then
        mp=ths : goto dtvar
      end if
    end if
    '
    if b then
      '
      'CHECK FOR IMPLICIT THIS.
      '------------------------
      '
      m=maco(ths,0)
      a=dtf
      c=0
      if a then
        'extra dotted
        w1=wr+"."+wk
        c=instrevn(-1,macso(m,1),htb+w1+" ")
      else
        w1=wr
      end if
      '
      if c=0 then
        c=instrevn(-1,macso(m,1),htb+wr+" ") 'either non-dotted or possibly indirect
      end if
      '
      dtf=a
      '
      if c then
        wk=w1
        if dtf=0 then dtf=5
        mp=ths
        goto dtvar
      end if
      '
      'OTHERWISE LET WORD PASS THRU
      '----------------------------
      '
    end if
    '
    '
    '-------
    notthis:
    '=======

    if mp=0 then goto exitmword
    '
    '
    'VARIABLES OF INTRINSIC AND USER DEFINED TYPE
    '--------------------------------------------
    '
    dtvar:
    '-----
    '
    mc=maco(mp,0) ' structure index if any
    mq=mp
    '
    if mc=-3 then
      if dtf then goto isdtf
    end if
    '
    if mc>=0 then
      '
      'ENUMERATION VARIABLE?
      '---------------------
      '
      b=maco(mc,0)
      '
      'FOR ASSIGNMENTS AND COMPARISONS
      '-------------------------------
      '
      if b=-2 then
        if dtf=0 then
          if ascn=61 then  enu=mc 'itr default parameters
          lent=cpuw : typ=cpuw : wr=macso(mp,1) : ind=maco(mp,3)
          if ind then indir(wk,ind) : wr=pedi
          goto exitmword 
        end if
      end if
      '
      'LOWER LOCAL BOUNDARY
      '
      'prevent attempt to access parental locals
      '
      if mp<mel then
        if (ths=0)or(dtf=0) then
          if left(macso(mp,1),4)="["+qebp then
            mp=0 : mc=0 : goto exitmword
          end if
        end if
      end if
      '
      if dtf=0 then wk=macso(mp,1)
      '
      '
      typ=maco(mq,5)
      '
      '------------------------
      isdtf: 'IS IT A DOT NAME?
      '========================
      '
      if dtf then
        '
        '
        'USER DEFINED TYPES
        '------------------
        '
        k=-1 : matchm(wk,wr,k)
        '
        if k=0 then
          ert=402 : ers="Not found : "+ow
        elseif funn(funi)<>13 then
          if mp=ths then
            if (varf=1)or(varf=3)or(funi=8) then
              ert=405 : ers="Static Members only"
            end if
          end if
        end if
        '
        tye=typ
        if ert then wr=ow : goto exitmword
        wk=wr : goto insertw
        '
      end if 'dtf
      '
      'NON DOTTED NAMES
      '----------------
      '
      '====
      ndtf:
      '====
      '
      lent=maco(mp,1)
      ind=maco(mp,3)
      if ind then
        indir(wk,ind) : wk=pedi
      end if
      w1=macso(mq,3) : a=1
      sog=tword(w1,a)
      if ascn>32 then
        sig=mid(w1,a) : varf=8 'FUNCTION POINTER WITH SIGNATURE
      end if
      skiplspace(s,i)
      if asc(wk)<>91 then
        'CONSTANTS
        if isstr(typ) then wpfx=wk : wr=qeax : goto exitmword 'STRING LITERAL
      end if
      wr=wk : goto exitmword
      '
    end if 'mc>0
    '
    '
    '
    'O2 EXCLUSIONS
    '-------------
    '
    if o2h=0 then
      if mc<=-14 then
        if mc=-14 then
          'allow these
          if instrword(" function method ",wr) then wk="_return" : goto insertw
        end if
        mc=0 : mp=0 : mq=0 : goto exitmword
      end if
    end if
    '
    
    '=======
    mwcases:
    '=======
    '
    select case mc
    '
    case -1  : wk=macres(mp,s,i) : goto insertw 'LOW LEVEL MACROS
    case -3  : goto exitmword1 'TYPE OR CLASS
    case -4  : wr=macso(mp,1) : varf=8 : goto exitmword 'O2 INTRINSIC FUNCTION
    case -5  : varf=8 : goto exitmword1 'LABELED OR VECTORED
    case -6  : varf=8 : addlproc() : wr=memreg(regss,maco(mp,2)) : goto exitmword 'IMPORT
    case -7  : varf=8 : wr=macso(mp,1) : goto exitmword 'EXPLICIT
    case -8  : goto exitmword1 'DERIVED TYPE
    case -9  : goto exitmword1 'COMMON RESERVED WORDS
    case -10 : typ=maco(mp,1) : sog=identypes(typ) : goto exitmword 'REGISTER
    case -11 : wk=attributes(s,i)
               if nl=1 then wk=noquotes(wk) 'raw inline code
               goto insertw 'ATTRIBUTES
    case -12 : goto exitmword1 'CUSTOMISED OPERATORS
    case -13 : goto exitmword1 'O2 MAJOR KEYWORD
    case -14 : goto exitmword1 'O2H MAJOR KEYWORD
    case -15 : ctype(s,i,wr) : goto exitmword 'C TYPE IDENT
    case -16 : varf=8 : goto exitmword1 'O2H INSTRINSIC VECTORED
    case -17 : goto exitmword1 'INTRINSIC FLOAT MACRO
    case -18 : goto exitmword1 'LABEL RECORD
    case -19 : wk=macso(mp,1) : tmnt=1 : goto insertw 'SYSTEM TERMINATION MACRO
    case -20 : wk=himac(mp,s,i) : goto insertw 'HI-LEVEL MACRO
    case -2
    '
    'ENUMERATION TYPES (defs and defs bit)
    '-------------------------------------
    '
    '
    'DIM TYPE CREATING AN ENUMERATION VARIABLE
    '-----------------------------------------
    '
    if dtf=0 then typ=mp+512 : lent=cpuw : goto exitmword
    '
    'OTHERWISE RETRIEVING AN ENUMERATION VALUE
    '-----------------------------------------
    '
    typ=cpuw
    wm=macso(mp,1)
    b=instr(wm," "+wk+" ")
    if b then
      a=ascn
      wr=yword(wm,b+len(wk)+2)
      ascn=a
    else
      wr=wo : ers="Enum not located" : ert=426
    end if
    mc=0 : mp=0 : mq=0 : typ=cpuw : dtf=0
    wordval(wr,1,1)
    skiplspace(s,i)
    goto exitmword
    '
    '---------
    end select
    '=========
    '
    '
    'corruption check
    '
    ers="unclassified Word " : ert=123
    '
    '-------
    insertw:
    '=======
    '
    inserts(s,wk+" ",i) : bgl=i
    '
    '------
    recurw:
    '======
    '
    wr=tword(s,i) : goto wredo
    '
    '---------
    exitmword:
    '=========
    '
    ascw=asc(wr) : lenw=len(wr)
    '
    '----------
    exitmword1:
    '==========
    '
    function=wr
    '
end function


'-------------------------------------------
function newvector(byval m as sys) as string
'===========================================
  '
  'ASSIGN A NEW MEMORY ADDRESS FOR A PROCEDURE VECTOR
  '
  dim as string wr
  if asce<0 then aoff-=cpuw : appendt("sub "+spw1+cr) 'RESERVE STACK SPACE
   wr=memreg(regs,aoff)
   if asce>0 then aoff+=cpuw
   if lclv=0 then aoffs=aoff
   '
   maco(m,0)=-7  'SET AS VECTORED PROCEDURE
   macsi(wr,m,1) 'SET VECTOR LOCATION
   function=wr
end function




'
'  ###################
'  #    NUMBERS      #        #       #  #  #    ###          ###    ##    #
'  #    STRINGS      #         ##      #####     #              #    # #   #
'  #    ADDRESES     # ############  ## PFX ##   # REG + OFFSET #    #  #  #
'  #    POINTERS     #         ##      #####     #              #    #   # #
'  #    VARIABLES    #        #       #  #  #    ###          ###    #    ##
'  ###################


declare function stodata(s as string) as string

'----------------------------------------------------------
function pword(byref s as string, byref i as sys) as string
'==========================================================
  '
  dim as sys a,b,c,d,e,k,m,n,v,ty,tyc,gg,da
  dim as string wr,ws,wt
  '
  ind=0 : nan=1 : wpfx="" : ou="" : typk=0
  '
  '
  '============================
  'RECURSION POINT
  ' (FOLLOWING MACRO EXPANSION)
  '============================
  '
  '-----------
  'INDIRECTION * **********
  'and CASTING
  '===========
  '
  b=0 'POINTER '*' COUNTER
  '
  do
    wr=mword(s,i)
    if nan=0 then goto xpword 'literal numbers
    '
    if isc(ascw) then goto xpword
    '
    if ert then wr=ow : exit function
    '
    ' `METHOD` `FUNCTION` RETURN VARIABLES
    '
    if mc=-14 then
      if isa(ascn)+isq(ascn)=0 then
        '
        'translate to _return
        'itr and xor or
        '
        if (wr="function")or(wr="method") then inserts(s,"_return ",i) : continue do
      end if
      if wr="that" then nth=1 : continue do
    end if

    '
    'WORDS STARTING WITH DOT
    '-----------------------
    '
    if dtf=1 then
      if i=swd+1 then wr+=tword(s,i) : swd-=1 : ascw=46 : goto xpword
    end if
    '
    'CASTING EG: (HANDLE) (void *) H
    '===============================
    '
    if ascw=&h62 then
      if wr="byval" then bvg=1 : ty=cpuw : continue do
    end if
    '
    'DETECT EXPLICIT CASTING
    '-----------------------
    '
    d=0
    if ascw=97 then
      if wr="as" then d=2
    elseif (ascw=60) then
      d=1
    end if
    '
    'INTERPRET CASTING 
    '-----------------
    '
    ' a = as long b
    ' a = <as long> b
    ' a = <long> b
    ' a = <as ?string> b
    ' a = <as string*> b
    ' a = <as string ptr> b
    '
    if d then
      m=swd : k=i : c=0
      do
        ws=wordahead(s,i) : a=asc(ws)
        if (a=42)or(a=38)or(a=63) then i=nwd : c=cpuw : continue do
        if d=1 then if ws="as" then i=nwd : continue do
        if c=0 then c=identype(ws)
        a=asc(s,nwd)
        if (a=42)or(a=38)or(a=63) then i=nwd : c=cpuw : continue do  ' * & ?
        if a=&h70 then if wordahead(s,nwd)="ptr" then i=nwd : c=cpuw 'PTR
        exit do
      loop
      '
      'CAST IDENTIFIED?
      '
      if c then
        i=nwd
        if d<>2 then i+=1 'SKIP RIGHT BRACKET
        tyc=c
        if tyc=0 then
          if indt then tyc=cpuw 'INDIRECTION
        end if
        ou+=" "+mid(s,m,i-m)
        continue do 'NEXT WORD OR CAST EXPRESSION
      else
        i=m
        wr=tword(s,i) 'REVERT TO PRIOR STATE
      end if 'IF IDENTYPE
    end if
    '
    'INDIRECTION SYMBOLS * ? &
    '-------------------------
    '
    if ascw=63 then ty=cpuw : ou+=wr : continue do '?'
    if ascw<>42 then exit do           '*'
    if ascn=61 then exit do            '*='
    '
    b+=1 : ou+=wr : 'TALLY INDIRECTION
    '
  loop
  '
  if (b>0)and(ascw=91) then
    if mp then if ascn=91 then fixsqbr(s,i)
    '
    'prefix wpfx updated
    '
    indir(wr,b) : wr=pedi : lenw=5
    '
    ty=cpuw ' TYPE OVERRIDE
    '
  end if
  '
  '
  '
  '
  '================
  'ADDRESSES & or @
  '================
  '
  if (ascw=38)or(ascw=64) then
    '
    if ascw=64 then i=swd+1 : skiplspace(s,i)
    '
    ou+=wr ' capture indirection
    '
    'ADDRESS OF STRING LITERAL
    '-------------------------
    '
    'if isq(ascn) then wr=tword(s,i) : ty=cpuw : goto xpword
    if ascn=38 or ascn=64 then da=1 : i+=1 'double address && or @@
    wr=mword(s,i) : typ=cpuw
    if isq(ascw) then wpfx=stodata(wr) : wr=qeax : ty=cpuw : goto xpword 'address of string data
    if asc(wpfx)=&h6f then ty=cpuw : goto xpword 'address of const o2 ....
    '
    '
    '
    'RENDER PROCS AS PLAIN VARIABLES
    '-------------------------------
    '
    '
    if (ascw=91)or(mc=-5)or(mc=-3)or(ascw=38) then
      '
      if varf=8 then
        '
        'CHECK IF A VECTOR NEEDS TO BE CREATED (fixed late binding)
        '
        'NOT '='
        '
        if ascn<>61 then
          varf=1 : mc=0
          if ascw=91 then goto xpword 'RETURN FUNCTION POINTER
          goto addrlab 'ASSUME TO BE A LABELLED FUNCTION
        end if
        '
        'MAKE A NEW VECTOR IF NEEDED &FUN=
        '
        if ascw<>91 then
          wr=newvector(mp)
          ascw=91 : lenw=len(wr) 'RETURN LOCATION [..]
        end if
        '
        varf=1 : goto xpword
        '
      elseif varf>8 then
        '
        'ITR not for com  like methods with remote VA
        '
        'ADDRESS OF (NON DLL) VIRTUAL FUNCTION
        '
        'CHECK FOR PRESENCE OF METHODS TABLE
        '
        a=0
        if mc=-3 then
         if maco(mp,2)=1 then a=1 'IS A CLASS RATHER THAN AN OBJECT
        elseif mc>0 then
          if (maco(maco(mp,0),2))=1 then a=1 'OTHERWISE CHECK THE CLASS OF THE OBJECT
        end if
        '
        if a=1 then
          '
          'ACCESS FUNCTION TABLE DIRECTLY
          '
          wr=memreg(regst,toff+woff)
          if da then wpfx=ledi+wr+cr : wr=qedi
          '
        else
          '
          'METHODS TABLE NOT DEFINED SO ASSUME
          'EXTERNAL WITH VIRTUAL TABLE POINTER
          '
          indir(wr,1)
          wr=memreg(qedi,woff)
        end if
        mc=0 : dtf=0
        varf=1 : goto xpword
      end if 'PROCEDURES
      '
      '&& @@ (for passing pointer addresses)
      '----------------------------------
      '
      if da then
        if len(wpfx) then
          mid(wpfx,1)="lea" : wr=qedi : typ=cpuw : varf=1
        else
          ers="Invalid address" : ert=7 : goto xpword
        end if
      end if
      '
      'ADDRESS DERIVED FROM ARRAY
      '--------------------------
      '
      if (ascn=lbr)or(ascn=91) then
        adra=nst+1 : varf=1 : goto xpword
      end if
      '
      'ADDRESS OF VARIABLE [ebx+/-offset] etc
      '--------------------------------------
      '
      if wr=pedi then
        if len(wpfx) then
'if ow="voice" then qq wpfx+crg+wr,varf
          'if (maco(mp,3)=1)and((varf<2)or(varf>7)) then
          '  wpfx="" : wr=macso(mp,1) : lenw=len(wr) : ascw=asc(wr)
          'else
          a=instrevn(-1,wpfx,"mov ")
          if a then
            if instr(a,wpfx,"mov "+qedi+cm+pedi) then
              wpfx=left(wpfx,a-1) 'CHOP DEREFERENCE
            else
              mid(wpfx,a)="lea"
            end if
          end if
          'end if
        else
          wr=qedi
        end if
      elseif wr<>qedi then
        wpfx+=ledi+wr+cr : wr=qedi
      end if
      '
      goto xpword
      '
    end if
    '
    '=======
    addrlab: 'ADDRESS OF LABEL
    '=======
    '
    if cpuw=4 then
      wpfx="call fwd here : .here : pop edi : sub edi,here : add edi,"+wr+cr
    else
      wpfx="lea rip rdi,"+wr+cr
    end if
    '
    wr=qedi : varf=1 : goto xpword
    '
  end if 'LABELS
  '
  '
  '
  '======
  xpword:
  '======
  '
  if tyc then ty=tyc
  if ty then typ=ty : typk=ty
  function=wr 
  '
end function






'-----------------------------------------------------------
function namesig(byref s as string,byref k as sys) as string
'===========================================================
  '
  dim as sys a,b,pt=bref,f,j,opf,ta,ct
  dim as string wr,wd,wt,wv,pts,w1
  '
  a=k : b=swd
  do
    wr=tword(s,k)
    if wr="..." then pts+=".."   : continue do   'ELLIPSIS
    if wr="byval" then pt=0      : continue do   'BASIC BYVAL
    if wr="byref" then pt=1      : continue do   'BASIC BYREF
    if wr="optional" then opf=49 : continue do   'OPTIONAL PARAMS
    '
    if isc(ascw) then endline(s,k) : continue do 'SKIP COMMENTS
    if ascw=rbr then exit do                     'END OF PARAMS
    '
    'CHECK FOR DEFAULT VALUES
    '========================
    '
    if ascn=61 then
      wv+=wr+"=" : k+=1 : j=k
      capts(s,k)
      wv+=mid(s,j,k-j)+","
      if ct=0 then continue do
    end if
    '
    if wr="as" then f=2 : ct=0   'BASIC TYPE FOLLOWS
    if ascn=97 then
      if wordahead(s,k)="as" then
        k=nwd : f=2 : ct=0       'BASIC TYPE FOLLOWS
      end if
    end if
    '
    if f=2 then wt=tword(s,k) : ta=identype(wt) 'AS TYPE
    '
    'C STYLE
    '=======
    '
    if f=0 then
      '
      'TYPE RECOGNITION
      '----------------
      '
      k=swd : wr=mword(s,k)
      if wr="optional" then
        opf=49 : continue do
      end if
      a=identype(wr)
      '
      if a then
        pt=0 : ct=1 'identified as C style typing so set indirection to 0
      else
        if len(wt) then
          wr=wt : a=ta 'default type
          if ct then pt=0 else pt=bref 'default indirection
        end if
      end if
      '
      if a then
        ta=a : f=1 : wt=wr
        do
          if ascw=42 then pt+=1 'COLLECT POINTERS
          if (ascn<>44)and(ascn<>rbr) then
            w1=tword(s,k)
            '
            'CHECK FOR DEFAULT ASSIGNMENTS
            '-----------------------------
            '
            if ascn=61 then
              wv+=w1+"=" : k+=1 : j=k
              capts(s,k)
              wv+=mid(s,j,k-j)+","
            end if
          else
            exit do  'SWALLOW NAMES
          end if
        loop
      end if
      '
    end if
    '
    'COLLECT POINTERS
    '================
    '
    do
      if (ascn=42)or(ascn=&h70) then
        if instrword(" ptr pointer * ",wordahead(s,k)) then k=nwd : pt+=1 : continue do
      end if
      exit do
    loop
    '
    if ascn=44 then k+=1 : skiplspace(s,k)
    '
    'ADD SIG FRAGMENT
    '================
    '
    if f=0 then wr="sys" 'DEFAULT TYPE
    '
    f=0
    '
    if pt=0 then
      if wr="void" then
        if ct then pt=0 else pt=bref
        continue do 'no parameter
      end if
    end if
    '
    wd+="#"+wt: pts+="a"+chr(pt+opf+48)
    if ct then pt=0 else pt=bref  'set ptr to the default level
 loop
  '
  swd=b
  if len(wd) then wd+="@"+pts       'ADD INDIRECTION DATA
  if len(wv) then wd+=" (,"+wv+") "  'ADD DEFAULT VALUES
  function=wd
  '
end function


'================
'ELEMENT ENCODING
'INTERNAL FORMAT:
'================
'
' TAB NAME OFFSET LENGTH VARF PRIV CALLTYPE SIG SOG DEFAULTS?
'------------------------------------------------------------
'
' 0 TAB
' 1 ELEMENT NAME
' 2 LENGTH
' 3 OFFSET
' 4 VARF
'   1 PROPERTY
'   8 CALL
'   9 METHOD
'   10+ INHERITED METHOD WITH OBJECT OFFSET
' 5 PRIV
'   0 PRIVATE
'   1 PROTECTED
'   9 PUBLIC
' 6 CALLING CONVENTION
'   A stdcall
'   B cdecl
'   C ms64
'   I pascal 
' 7 PROTOTYPE SIGNATURE OR ','
' 8 RETURN TYPE
' 9 DEFAULE VALUES?
'   (,A=1,B=32,C=12.5,) etc
'

'-----------------------------------------------------------------------------------------------------------------------------------------
function encodele(byref wm as string, byref wr as string, byref k as sys, byval n as sys, byval vtl as sys, byref ws as string ) as string
'=========================================================================================================================================
  '
  'PARAMS
  '
  'wm  source string
  'wr  type name
  'k   source string index
  'n   type code
  'vtl virtual pointer flag
  '
  '
  ' tt as sys
  ' virtual amphibian frog(100)
  ' tt aa! (as sys) as sys

  dim as sys a,b,m
  dim as string w1,w2,w3,wd
  '
  'DEFAULT ELEMENT
  '---------------
  '
  ws="" : m=1  ' attributes flag default
  '
  '
  'SUBS / FUNCTIONS '8'
  '--------------------
  '
  if n=&h11f then m=8
  '
  '
  'POINTER TO OTHER TYPES '3'
  '--------------------------
  '
  if (n>=512)or(indt>0) then m=3
  '
  'METHODS AND STATIC MEMBERS 2 4 9
  '--------------------------------
  '
  if (vtl>1) then m+=1
  '
  '
  '
  skiplspace(wm,k) : b=ascn
  '
  'CALLING SIGNATURE / ARRAY SIGNATURE SIG
  '---------------------------------------
  '
  w2=","
  '
  if ascn=lbr then
    '
    k+=1 : ws=namesig(wm,k)
    '
    'SIMPLIFY SIGNATURE FOR ARRAYS
    '-----------------------------
    '
    if m<8 then ws=splitsi(ws,w3)
    if len(ws) then
      a=instr(ws,"(")
      if a then
        wd=" "+mid(ws,a) 'default values
        ws=left(ws,a-1)  'exclude default params from signature
      end if
      w2=ws
    end if
  end if
  '
  w1=wordahead(wm,k)
  '
  'RETURN SIGNATURE SOG
  '--------------------
  '
  w3=","
  '
  if n>=512 then
    w3=str(n)
  elseif w1<>"as" then
    if len(wr) then w3=wr
  else
    k=nwd : w3=tword(wm,k)
  end if
  '
  '
  'PRIVATE AND PROTECTED MEMBERS
  '-----------------------------
  '
  if priv then a=priv else a=57 'default 9 for public
  '
  'VARF PRIV/PROT CALLCONV SIG SOG
  '===============================
  '
  '            VARF       PRIV       CALLINGCONV     SIG  SOG  DEFAULTS
  function=" "+str(m)+" "+chr(a)+" "+chr(cco+65)+" "+w2+" "+w3+wd
  '
end function


'-----------------------------------------------------------
function arraysize(byref s as string, byref i as sys) as sys
'===========================================================
  '
  'itr macro index
  '
  dim as sys a,v,lb,rb
  dim as string wr
  lb=asc(s,i) : if lb=91 then rb=93 else rb=rbr
  v=1
  i+=1 'SKIP FIRST LEFT BRACKET
  wr=mword(s,i) 'supports macros
  if ascn<>rb then ers="Unexpected symbol after array index" : ert=404
  i+=1 : skiplspace(s,i) 'OTHERWISE NEXT DIMENSION
  a=wval(wr) : if a>0 then v*=a
  function=v
  '
end function


'---------------------------------------------------------------------------
function vword(byref s as string, byref i as sys, byref wr as string) as sys
'===========================================================================
  dim as sys a
  do
    a=dic(" static 10, declare 1, dim 2,  public 39, private 30, protected 31, const 40, ",wr)
    if a=0 then exit do
    if a<=2 then dcl=a
    'itr ignore static (10)
    if a=40 then a=0 'ignore const
    if a>=&h30 then priv=a
    mid(s,swd)=space(i-swd) 'BLANKOUT
    if isx(ascn)=0 then
      wr=tword(s,i)
    else
      wr="" : exit do
    end if
  loop
  function=0
end function



'--------------------------
function readin() as string
'==========================
dim as sys b
dim as string w1,w2
  '
  w2=string(&h1000,chr(0)) : b=1
  do
    read w1 : if w1="!end!" then exit do
    mid(w2,b)=w1+cr : b+=len(w1)+len(cr)
  loop
  function=left(w2,b-1)
end function


'--------------
sub localvars()
'==============
 if lclv then
   aoffl=aoff
 else
   aoffs=aoff : regs=regsl
 end if
 lclv=1 : aoff=aoffl : asce=-1
end sub


'--------------
sub staticvars()
'==============
 if lclv then
   aoffl=aoff : regs=regss
 else
   aoffs=aoff
 end if
 lclv=0 : aoff=aoffs : asce=1
end sub


'---------
sub nest()
'=========
  dim p as any ptr
  brc+=1
  if brc>99 then ers="Depth limit exceeded ((()))" : ert=10 : exit sub
  p=@scop(brc,0)
  asm
  mov ecx,[p]
  mov eax,[me] '0
  mov [ecx],eax
  add ecx,4
  mov eax,[aoff] '1
  mov [ecx],eax
  add ecx,4
  mov eax,[asce] '2
  mov [ecx],eax
  add ecx,4
  mov eax,[mle] '3
  mov [ecx],eax
  add ecx,4
  mov eax,[lclv] '4
  mov [ecx],eax
  add ecx,4
  mov eax,[spe] '5
  mov [ecx],eax
  add ecx,4
  mov eax,[casf] '6
  mov [ecx],eax
  add ecx,4
  mov eax,[ixb] '7
  mov [ecx],eax
  add ecx,4
  mov eax,[sr2] '8
  mov [ecx],eax
  add ecx,4
  mov eax,[ct2] '9
  mov [ecx],eax
  add ecx,4
  end asm
  sregs(brc)=regs
  if lclv=0 then aoffs=aoff
end sub


'-----------
sub unnest()
'===========
  dim p as any ptr
  '
  'LOCAL OR STATIC VARIABLES?
  '
  if lclv=0 then aoffs=aoff else aoff=aoffs 'RETAIN VARSPACE EXPANSION
  p=@scop(brc,0)
  asm
  mov ecx,[p]
  mov eax,[ecx] '0
  mov [me],eax
  add ecx,8
  mov eax,[ecx] '2
  mov [asce],eax
  add ecx,4
  mov eax,[ecx] '3
  mov [mle],eax
  add ecx,4
  mov eax,[ecx] '4
  mov [lclv],eax
  add ecx,4
  mov eax,[ecx] '5
  mov [spe],eax
  add ecx,4
  mov eax,[ecx] '6
  mov [casf],eax
  add ecx,4
  mov eax,[ecx] '7
  mov [ixb],eax
  add ecx,4
  mov eax,[ecx] '8
  mov [sr2],eax
  add ecx,4
  mov eax,[ecx] '9
  mov [ct2],eax
  add ecx,4
  end asm
  if lclv then aoff=scop(brc,1)
  regs=sregs(brc)
  brc-=1
  if brc<0 then
    brc=0
    ers="Too many right brackets (..))" : ert=10
  end if
end sub



'-------------------------------------------
function params(byval s as string) as string
'===========================================
  dim as sys a,b,c,e,i,v
  dim as string w1,w2,w3,w4,w5,w6
  '
  'TRANSLATE SIG TO PARAMETERS
  '
  w1=macso(a,3)
  c=instr(w1,"@") : if c=0 then exit function
  w2=mid(w1,c+1) : W1=left(w1,c-1) 'SEPARATE PARAMS AND INDIRECTION
  e=len(w2)
  '
  i=1
  for b=1 to e
    v=asc(w2,b)-48
    w4=wordfrag(w1,i)
    if hlo=0 then 'C
      w6+=w4+string(v,"*") 'itr typedefs
    elseif hlo=1 then 'BASIC
      if v=0 then
        w3="byval " : w5=""
      elseif v=1 then
        w3="byref " : w5=""
      else
        w4="dword" 'ANON POINTER
        w3="byval " : w5=" ptr"
      end if
    end if
    '
    w6+=w3+w4+w5+", "
    '
  next
  
  c=len(w6)-2 'TRIM LAST COMMA
  function=left(w4,c)
  '
end function




'----------------------------------------------------------------
sub nextsig(byref s as string, byref k as sys, byref w as string)
'================================================================
  k=instr(k,s,"##")
  if k then k+=1 : sig=uword(s,k) : sog=uword(s,k) : typ=identype(sog) : w=uword(s,k)
end sub



'--------------------------------------------------------------------------------------------
function namedparams(wr as string,byref s as string, byref i as sys, byval igb as sys) as sys
'============================================================================================
  'overloading suppoted
  dim as sys a,b,k,kk,kr,m,oo,sb
  dim as string dvm
  '
  if varf=8 then
    b=3 : m=mq : oo=1
  else
    b=1 : m=maco(mq,0) : oo=-1 '
  end if
  '
  dvl=macso(m,b) : kk=oo
  '
  do
    if b=3 then 
      kk=instr(kk,dvl,wr)    ' '##' PROCEDURES
    else
      kk=instrevn(kk,dvl,wr) ' HTB+MEMBERNAME FOR METHODS
    end if
    '
    if kk=0 then
      exit do
    end if
    '
    'itr can't do this with overloading
    '
    k=instr(kk,dvl,"(,")     '(,DEFAULT PARAM BLOCK,)
    if k then
      kr=instr(kk,dvl,cr)
      if kr=0 then kr=len(dvl)
      if k>=kr then
        k=0
      else
        capture(dvl,m,k,a)
        dvm=mid(dvl,m,k-m)   'GET PARAM DEFAULT VALUES
        sb=subsas(s,i,dvm,igb)
        if sb then exit do   'SUCCESFUL SUBSTUTION
      end if
    else 'k=0: no '(,'
      if b=3 then exit do    'NO DEFAULT VALUES AVAILABLE
    end if
    kk+=oo 'try next element
  loop
  '
  if k then
    if sb=0 then
      ers="unable to match param names" : ert=106
    end if
  end if
  '
  function=k
  '
end function


'----------------------------------------------------------
function cloneit(byref wr as string, byval b as sys) as sys
'==========================================================
  '
  'CLONE AN EXISTING ENTITY
  '
  dim as sys i
  dim as string s
  for i=0 to 6
    maco(me,i)=maco(b,i)
  next
  macsi(wr,me,0)
  for i=1 to 3
    s=macso(b,i) : macsi(s,me,i)
  next
  addm(me) : function=me : addme()
end function



'---------------------------------------------------------------------------------
sub erasek(byref w1 as string, byref w2 as string, byval b as sys, byval c as sys)
'=================================================================================
  '
  'ERASE KEYWORD IN A STRING AND C WORDS FOLLOWING
  '
  dim as sys f,m
  dim as string w3
  '
  f=instr(b,w1,w2) : if f=0 then exit sub
  m=f : f+=len(w2)
  do
    c-=1 : if c<0 then exit do
    w3=mword(w1,f)
  loop
  mid(w1,m)=space(f-m) 'erase section
end sub



'---------------------------------------------------------------------------
function cbrencah(byref s as string, byref i as long, byval c as sys) as sys
'===========================================================================
  dim as long a,b
  a=i : b=ascn
  nextinstruct(s,i)
  if ascn=123 then
    if cbri>63 then ert=101 : ers="Too many '{' " : exit function
    cbrk(cbri)=c : cbri+=1 : i+=1 : skiplspace(s,i)
    function=1
  else
    i=a : ascn=b
  end if
end function


'----------------------------------------------------------------
sub paths(byref s as string, byref i as sys, byref pth as string)
'================================================================
  dim as sys b
  dim as string wr
  if ascn=43 then b=1 : i+=1
  wr=noquotes(mword(s,i)) 
  if b then pth+=wr else pth=wr
end sub



'-------------------------------------------------
function issub(s as string, byref i as sys) as sys
'=================================================
  dim as long a
  dim as string w1
  w1=wordahead(s,i) : a=asc(s,nwd)
  if asc(w1)=91 then
    function=0
  elseif a=lbr then
    function=-1
  elseif a=44 then
    function=0
    w1=wordahead(s,nwd) : a=asc(s,nwd) ',..MULTILINE SUB
    if ise(a) then function=-1
  elseif instrword(" byte word dword qword eword ptr float ",w1) then
    function=0
  else
    function=-1
  end if
end function


'--------------------------------
sub intrinsic(byref w1 as string)
'================================
  dim as sys a,b,c
  dim as string wr
  c=1 : wr=yword(w1,c)
  macsi(wr,me,0) : addmin(me)
  a=-wval(yword(w1,c)) : maco(me,0)=a
  if a=-16 then b=3 else b=1
  w1=mid(w1,c)
  if a=-4 then w1=memreg(qebx,wval(w1))
  macsi(w1,me,b)
  if (a<=-11)and(a>=-15) then
    b=wval(w1) : maco(me,5)=b 'KEYWORD ENCODING
    if a=-15 then maco(me,1)=b and 31 'LENGTH FOR CTYPE KEYWORD
  end if
  me+=1
end sub


'---------------
sub intrinsics()
'===============
  dim as sys a,b,c
  dim as string w1
  do
    read w1
    if w1="" then exit do
    intrinsic(w1)
  loop
end sub



'------------------------------------------------------------------------------
sub typeinit(w1 as string,byref wr as string, byref s as string,byref i as sys)
'==============================================================================
  '
  dim as sys a
  macoin me
  if ert then exit sub
  set_macro_name(wr)
  lbw=wr
  '
  'CAPTURE ENTIRE DEF BLOCK
  '
  a=o2h : o2h=0 : wr=captureblock(s,i,w1) : o2h=a 'set o2h 0 prevents suffix stripping
  '
end sub



'----------------------------------------------------------
function expandm(byref wr as string ,byref b as sys) as sys
'==========================================================
  dim as sys a,c,d,f
  dim as string w1,w2
  d=swd
  w1=wordahead(wr,b)
  a=lookupm(w1)
  if a then
    c=maco(a,0)
    '
    'MACRO EXPANSION 'itr one level only
    '
    if (c=-1)or(c=-20) then
      f=nwd
      'w1=macso(a,1)+" "
      if c=-1 then w1=macres(a,wr,f) else w1=himac(a,wr,f)
      wr=left(wr,d-1)+w1+mid(wr,f) 'SUPPORTS MACRO PARAMETERS
      b=d : function=1
    end if
  end if
end function




  '---------------------------------------------------------------------------------
  function precedence(byref s as string, byref i as sys, byval bs as sys ) as string
  '=================================================================================
  '
  static as sys ppl(31),pk(31)
  dim as string uu,u,wr
  dim as sys a,b,c,d,k,f,nl,pp,twd,dd,ma,ido
  nl=bs
  '
  'itr early macro expansion?
  '
  do
    c=i : skipspace(s,i) : if i>c then u+=mid(s,c,i-c) 'ADD CRLF ETC
    '
    wr=arrows(s,i,1)                                           'CAPTURE WORD INCLUDING '->' POINTERS
    '
    'CHECK FOR MACROS AND EXPAND THEM
    '
    if met=0 then
      f=lookupm(wr)
      if f then
        b=maco(f,0) : a=0
        if (b=-1)or(b=-20) then
          ma+=1 'recurs protect from infinite expansion
          if ma<100 then
            if b=-1 then wr=macres(f,s,i) else  wr=himac(f,s,i)
            inserts(s,wr+" ",i) : continue do
          end if
        end if
      end if
    end if
    '
    if ascw=ascn then
      if (ascw=43)or(ascw=45) then
        u+=string$(2,chr$(ascn)) : i+=1 : continue do          'PRE ++ --
      end if
    end if
    '
    if ascw=45 then
      if (k=0)or(ido>0) then u+=mid(s,c,i-c) : continue do                'NEGATIVE SIGNED OPERAND
    end if
    '
    ido=0
    '
    if (ise(ascw)<>0)or(ascw=sr1)or(ascw=sr2)or(ascw=123) then
      i=c : exit do                                            'EXCLUDE TERMINATOR
    end if
    '
    if instrword(" then else to ",wr) then i=c : exit do       'SPLIT COMPOUND EXPRESSIONS
    '
    if ascw=91 then
      a=instr(i,s,"]") : if a then i=a+1 : skiplspace(s,i)     '[..] AS WHOLE WORD
    end if
    '
    twd=len(u)+1 : a=i-c : u+=mid(s,c,a) : k=twd+a             'INCLUDE SPACING

    if (ascw=rbr)or(ascw=125) then
      exit do                                                  'TERMINATE INCLUDING BRACKET
    end if
    '
    if ascw=44 then
      a=nl-bs 'number of closing brackets
      uu+=string(dd,"(")+left(u,twd-1)+string(a,")")+"," 'CLOSE ALL BRACKETS BEFORE COMMA AND RESET PP & DD
      u="" : nl=bs : pp=0 : dd=0
      continue do
    end if
    '
    if (ascw=lbr)or(ascw=123) then
      if (ascn<>rbr)and(ascn<>125) then
        skipspace(s,i) : wr=precedence(s,i,nl+1) : u+=wr 'RECURSE INSIDE BRACKETS
      else
        u+=tword(s,i) 'EMPTY BRACKET PAIR
      end if
      if iss(ascn) then
        exit do
      end if
      continue do
    end if
    '
    b=i : a=0
    '
    if ascw<>91 then a=identop(s,swd,i,wr)
    if a=47 then divi=1
    if ascw=61 then if a=0 then exit do '= is an assignment
    '
    if a>0 then
      '
      ido=a
      if i>b then
        a=asc(s,b) : wr+=chr(a) : u+=chr(a) : k+=1 '2 char operators
      end if
      '
      do
      ' 
      b=ppl(nl)
      d=1
      '
      if prl>b then
        '
        'HIGHER PRECEDENCE: PLACE BRACKET AFTER PREVIOUS OPERATOR
        '--------------------------------------------------------
        '
        if pp then u=left(u,pk(nl)-1)+"("+mid(u,pk(nl)) : k+=1 : nl+=1
        '
      elseif prl<b then
        '
        'LOWER PRECEDENCE: PLACE CLOSING BRACKET BEFORE OPERATOR
        '-------------------------------------------------------
        '
        if (nl>bs)or(pp<>0) then
          u=left(u,twd-1)+")"+mid(u,twd) : k+=1 : twd+=1 'eg: if (a=b)or..
        end if
        '
        if nl>bs then
          nl-=1 : d=0 ' to repeat loop
        else
          if pp then dd+=1
        end if
        '
      end if
      '
      '
      if d then exit do
      loop
      '
      ppl(nl)=prl : pk(nl)=k 'RECORD PRL AND LOCATION FOLLOWING THE OPERATOR
      pp=a
      '
    else 'NOT AN OPERATOR
      if iss(ascn)  then exit do 'CHECK FOR TERMINATION AFTER AN OPERAND
      if ascn=asc(s,i+1) then if (ascn=43)or(ascn=45) then u+=string$(2,chr$(ascn))+" " : i+=2  ' POST ++ --
    end if
  loop
  '
  function=uu+string(dd,"(")+u+string(nl-bs,")") 'CLOSE REMAINING BRACKETS AND RETURN TO PREVIOUS LEVEL
  '
  end function


