  '
  '=============================
  'SEMANTIC LEVEL FOR O2 AND O2H
  '=============================


  'RESOLVE HIGH LEVEL EXPRESSION, MACROS ETC INTO ASSEMBLER



  '----------------------------------------------
  function translate(byref ss as string) as string
  '==============================================

  '===========================
  'LOCAL VARIABLES DESCRIPTION
  '===========================

  ' s     source string
  ' fp    include string index
  ' qf    inline quote flag
  ' i     source index
  ' sst() source string buffers for include
  ' a     general ascii value
  ' k     general purpose
  ' m     general purpose
  ' n     general purpose
  ' v     general purpose
  ' w     general purpose
  ' w1.w9 param
  ''' wc    inherited elements to append
  ' wd    word string
  ' wr    word string
  ' wm    word string
  ' wn    word string
  ' ws    word string
  ' wt    word string
  ' typo  type definition flag
  ' aoff  offset value for local vars etc
  ' poff  previous offset
  ' sregs nesting for indexers
  ' asce  ascending/descending flag
  ' regs  macro used to specify index regs for variables
  ' adr   address indirection flag for proc params
  ' sigs  parameters type signature
  ' sigd  parameters indirection signature
  ' mq1   hold index mq
  ' mqf   hold proc descriptor mq
  ' mqp   proc mq
  ' op1   hold op
  ' opp   proc op
  ' sih   single inheritance
  '-------------------------
  ' typa  type of variable
  ' typa1 type of first variable
  ' typa1 length of first variable
  ' typc  type of accumulator in use
  ' typp  return type of procedure
  ' ccp   call convention type of provedure
  ' typl  left hand (assigment type in use
  ' bs    bracketed expression present and skipped
  ' va    hold varf
  ' bv    byval flag
  ' tpt   indirection counter
  ' psg   preassign string
  ' wsg   preassign operand
  ' ali   alias   for imported or expoted functions
  ' lby   library for imported functions
  ' it    identified type
  ' atf   flag indicating exported function
  ' lcl   flag stack params or locals
  ' lcls  flag local/param strings used
  ' blcl   block local ebp code (positions)
  ' tm    t marker for splitting t
  ' fdd   def flag
  ' fro   for flag
  ' prf   private flag for inherited elements
  ' noin  noinit flag prevents local vars being set to 0
  ' ctbl  class table flag
  ' wlc   wlc local vars flag
  ' eord  export ordinal counter
  ' mage  binary image (for pe formatting)
  ' clss  class record
  ' clsi  class level
  ' reto  tally offset for ret n instruction
  ' retb  tally base offset for ret n instruction
  ' th    ths this flag holder
  ' ml    mp lower local boundary holder
  ' tdst  typedef struc flag
  ' un    outer union flag
  ' dcp   declared C prototype
  ' deco  C style typdef function function flag
  ' pn    parameter counter for function prototypes
  ' leaf  leaf flag
  ' fql   include filename and hash array index
  ' ccx   calling convention extern block default
  ' atx   external flag block default for proc internals
  ' etx   export flag block default for proc internals
  ' wx    headers for exposed procedures
  ' opa   flag for optional params
  ' typd  inferred type in dim/declare statements
  ' cnsl  console mode flag for PE file SubSytem 3 (normally 2)
  ' bpb   Block param bracket flag
  ' epi   Epilog flag
  ' typf  default type (c style prototype)
  ' df    indirection count (c style prototype)
  ' dg    default type (prototype default type establish flag)
  ' lbli  flag to add plain label to proc header
  ' fc    byval/byref spec

  '===============
  'LOCAL VARIABLES
  '===============


  dim as sys a,b,c,d,e,f,i,k,m,n,p,q,u,v,w,qf,typo,poff,pk,adr,mq1
  dim as sys bs,va,bv,tpt,it,tm,fdd
  dim as sys op1,typa,typc,typa1,lent1,mqf,mqp
  dim as sys opp,fro,ctbl,wlc,eord,clsi,tdst,un,dcp,deco
  dim as sys clss(31),pn,leaf,fql,atx,etx,opa,typd,cnsl,bpb,epi,typf,df,dg,lbli,fc

  dim as sys relaxed=1,independent=0,linemarkers=1
  dim as long ptr pm



  dim as string w1,w2,w3,w4,w5,w6,w7,w8,w9,wd,wm,wn,wr,ws,wt,s
  dim as string psg,wsg,ali,lby,sigs,sigd,prf,mage,wx
  
  '==============
  'INITIALISATION
  '==============

  start_prep:

  s=ss+cr
  if linemarkers then lineMark(s)
  t=space(len(s)+1000)
  i=1 : j=1
  '
  mex=len(s)*10+100000
  if mex<2e6 then mex=2e6

  GlobalClear()
  regnames() 'DEFAULT TO 32 BIT REGISTERS


  'skiplspace(s,i) : wr=wordahead(s,i)

  if dep then goto mainstart 'BYPASS FOR SECONDARY COMPILING


  '
  'STATICS OFFSET
  '--------------
  '
  'The run-time function table is combined with static variable table 
  '
  aoff=&h1000 'COMBINED RTFT AND SVT


  spl=1000000 : sps=string(spl,chr(0)) : spe=8 ' STRING POOL BUFFER

  '
  '=======================
  'EMPTY DEFINITION TABLES
  '=======================
  mle=&h200
  init4 @mach(0),mle*smach,0  'clear hash table base
  init4 @maco(0,0),me*smaco,0 'clear previous
  me=1 : mp=0

  ixb=1 'DEFAULT INDEX BASE



  '===============
  'LOAD INTRINSICS
  '===============

  restore kernel_funs : Intrinsics()
  restore x86_registers : Intrinsics()
  '
  '
  'FIRST WORD COMMANDS
  '
  'to come before declarations
  '
  '
  w1=wordahead(s,i)
  if w1="#view" then vew=2 : i=nwd
  if w1="#prep" then vew=3 : i=nwd
  '
  '
  '####################
  '####################
  '
  ' #######    ######                  #
  '  ##    #  #      #                 ##
  '  ##    #  #      #  ###################
  '  ##    #  #      #  ### MAIN ############
  '  ##    #  #      #  ###################
  '  ##    #  #      #                 ##
  ' #######    ######                  #
  '
  '####################
  '####################
  '
  '---------
  mainstart:
  '---------
  '
  regs=regss
  mest=me
  mesb=me
  '
  '
  '========================
  mainloop: 'main line loop
  '========================
  '
  '
  nl=1 : bg=j : skiplspace(s,i) : typa1=0
  '
  '
  '======================
  do 'main statement loop
  '======================
  '
  '
  if ert then goto exitap
  mct=0 : sig="" : mq=0
  '
  wr=pword(s,i)
  '
  'COMMENTS
  '--------
  '
  if isc(ascw) then
    endline(s,i)
    if ascn=lnm then wr="'_"+mid$(s,swd+2,i-swd-2) : lnmks=mid(wr,3)
    ascn=13
    goto addsrc
  end if
  '
  if ascw=59 then
    if ct2<>59 then wr=":" : ascw=58 : mid(s,swd)=wr
  end if
  '
  'STRING LITERALS
  '---------------
  '
  if isq(ascw) then
    appendt(stodata(wr))
    continue do
  end if
  '
  '
  '++ -- PRE POST
  '--------------
  '
  a=0
  if (ascn=43)or(ascn=45) then
    if ascw=ascn then
      a=1 : w1=wr
    elseif typ then
      if ascn=asc(s,i+1) then a=1 : w1=ou+ow+" "
    end if
  end if
  if a then
    inserts(s,w1,i) : goto generalexp
  end if
  '
  '
  md=0
  '
  if o2h then
    if (ascw>=60)and(ascw<=62) then goto unass
    if mc=-14 then
      nl=0 : goto o2hmain
    end if
  end if
  if mc=-13 then
    goto oxygenword
  end if
  '
  '
  if mc=0 then
    if wr="end" then
      w1=wordahead(s,i)
      if w1="asm" then i=nwd : o2h=1 : goto mainloop
    end if
  end if
  '
  op=1
  '
  'REGISTERS
  '---------
  '
  if mc=-10 then
    if nl then typa1=typ  
  end if
  '
  '
  'COMMAND OPERATOR (custom operators with objects)
  '------------------------------------------------
  '
  if mc=-12 then
    op=mp+&h200 : goto directexp
  end if
  '
  'CHECK FIRST WORD IN STATEMENT
  '=============================
  '
  if nl then
    '
    'LINE NUMBERS
    '------------
    '
    if nan=0 then
      if ascn=58 then if i=swd+lenw then i+=1
      appendt("._"+wr+cr) : bg=j
      continue do
    end if
    '
    '
    'COLON LABELS: CHANGE TO DOT LABELS
    '----------------------------------
    '
    if ascn=58 then
      '
      'CHECK ASSIGNMENT OPERATOR AHEAD :=
      '
      if asc(s,i+1)=61 then
        i+=1 : ascn=61 : goto nlabel
      end if
      '
      if i=swd+lenw then
        '
        i+=1 : skiplspace(s,i)
        if ise(ascn)=0 then goto nlabel 'not a label because other statements are on the same line
        '
        'MAKE LABEL RECORD
        '
        macoin(me) : macsi(wr,me,0) : maco(me,0)=-18 : addm(me) : addme
        inserts(s,cr+"."+wr+cr,i)
        skiplspace(s,i)
        lbw=wr
        continue do
      end if
    end if
    '
    '======
    nlabel:
    '======
    '
    a=0
    '
    if mq then
      if ascw=91 then
        a=1
      elseif (mc>=0)and(typ>0) then
        a=1
      end if 
      if a then
        if varf=0 then if typ=0 then typ=cpuw
        typa1=typ : mq1=mq 
      end if
    else
      if ascw=91 then typ=cpuw : typa1=typ
    end if
    '
    '-------------------
    'TYPES (C STYLE DIM)
    '===================
    '
    a=0
    '
    'CHECK FOR BUILT-IN STRING FUNCTION
    '----------------------------------
    '
    if mc=-16 then
      if wr="string" then a=-1 'THIS IS A STRING PRIMITIVE
    end if
    '
    if mc=-15 then
      if isn(ascn) then if wr="int" then nl=0 : goto addsrc 'asm int
    end if
    '
    'CHECK FOR TYPE OR DERIVED TYPE, ENUMERATION, C PRIMITIVE
    '--------------------------------------------------------
    '
    if (mc=-3)or(mc=-8) then
      '
      'CHECK FOR FUNCTION POINTER TYPES
      '--------------------------------
      '
      if mc=-8 then
        m=maco(mp,4) 'LOCATE THE FUNCTION ATTRIBUTES
        b=maco(m,0)
        if (b=-5)or(b=-6)or(b=-7) then
          wr=mword(s,i) 'ASSUME NO * POINTER HERE
          c=cloneit(wr,m) 'COPY THE PROCEDURE ATTRIBUTES TO A NEW ENTITY
          if ert then goto exitap
          wr=newvector(c) 'CREATE ANOTHER MEMORY VECTOR FOR IT
          if ascn=61 then inserts(s,wr+" ",i) 'ASSIGN VALUE? EG: [EBX+104]= ...
          goto mainloop
        end if
      end if
      '
      a=1 'C style UDT variable 'VAR
      '      
    elseif mc=-2 then
      i=swd : goto vardef 'ENUMERATION
    elseif mc=-15 then
      a=-1 'IDENTIFIED C PRIMITIVE
      if wr="sys" then lent=cpuw : typ=cpuw
    end if
    '
    'CHECK FOR C STYLE DECLARATIONS
    '------------------------------
    '
    if a then
      '
      a=0 : w4="" : w7=" "
      '
      do
        w3=wordahead(s,i)
        c=asc(w3)
        if c=42 then wr+=w3 : i=nwd : continue do 'SUPPORT FOR POINTER TYPES INCLUDING VOID*
        if c=lbr then a=1 : exit do        'long (*foo)(...)
        if c=39 then i=nwd : endline(s,i) : continue do
        c=lookupm(w3)
        if c then
          if maco(c,0)=-20 then
            i=nwd : w3=himac(c,s,i)
            if len(w3) then inserts(s,w3+" ",i)
            continue do
          end if
        end if
        '
        if w4="" then
          nextinstruct(s,nwd) : c=asc(s,nwd)
          if c=lbr then a=2 : exit do 'long foo(...)
        end if
        '
        captqualif:
        '----------
        '
        b=dic(" lib 1, alias 2, cdecl 3, stdcall 4, ms64 5, pascal 6, ",w3)
        if b then
          i=nwd
          if b<3 then w3+=" "+tword(s,i)
          w7+=w3+" "
          nextinstruct(s,i)
          '
          if ascn=lbr then
            if w4="" then a=1 else a=2
            exit do
          end if
        else
          if len(w4) then
            exit do
          else
            c=casf : casf=2 : w4=tword(s,i) : casf=c 'no case alteration
            w3=wordahead(s,i)
            goto captqualif
          end if
        end if
      loop
      if len(w4) then inserts(s,w4+" ",i)
      skiplspace(s,i)
      '
      'IS A VARIABLE (INCL ENUMERATION)
      '-----------------------------
      '
      if a=0 then
        inserts(s,chr(39)+chr(lnm)+lnmks+cr+"dim as "+wr+" ",i)
        goto mainloop
      end if
      '
      'OTHERWISE  A PROCEDURE
      '
      '
      '=================================================================
      fundec: ' ENTRY POINT FOR EG: TYPEDEF INT ( *FUNC) (LONG* pv,...);
      '=================================================================
      '
      'FUNCTION OR SUB
      '
      ' itr calling convention and library name
      '
      'VOID* EXCLUDED
      '
      if wr="void" then
        w1="sub " : w2=""
      else
        '
        'NOTE THAT VOID* IS A FUNCTION
        '
        w1="function " : w2=" as "+wr
      end if
      '
      if a=1 then
        '
        'IS PROCEDURE POINTER
        '--------------------
        '
        '
        i+=1 : skiplspace(s,i)                 'SKIP LEFT BRACKET
        w4=tword(s,i)                           'GRAB ANY MACRO OR '*'
        if ascn=42 then i+=1 : skiplspace(s,i) 'CAPTURE '*'
        wr=uword(s,i) : skipspace(s,i)         'CAPTURE NAME OF FUNCTION IN UNALTERED CASE
        if ascn=41 then i+=1                   'CAPTURE RIGHT BRACKET
        '
        'itr w4 is not used later
        '
      else
        '
        'OTHERWISE DIRECT
        '----------------
        '
        wr=uword(s,i)
        '
      end if
      '
      nextinstruct(s,i)
      '
      if deco then
        me-=1 : set_macro_name(wr) : addm(me) : me+=1 'SET NAME OF TYPEDEF ENTITY
        wr="typedef_"+wr
        deco=0
      end if
      '
      'LIBRARY SPECIFIED?
      '------------------
      '
      '
      'CAPTURE ARGUMENTS
      '-----------------
      '
      ascn=asc(s,i) : w4=""
      if ascn=lbr then capture(s,m,i,0) : w4=mid(s,m,i-m)
      '
      'CAPTURE MODIFIERS
      '----------------
      '
      do
        skiplspace(s,i)
        if ise(ascn) then exit do
        w5=wordahead(s,i)
        a=dic(" external 1, export 2, callback 3, at 4, link 5, ",w5)
        if a then
          w2+=" "+w5 : i=nwd
          if a>=4 then w2+=wword(s,i)+" "
        else
          exit do
        end if 
      loop
      '
      nextinstruct(s,i)
      '
      if (ascn<>123)and(ascn<>lbr)and(ascn<>61) then
      'if (ascn<>123)and(ascn<>lbr) then
        w1="declare "+w1 : dcp=1
      end if
      '
      '
      'CLEANUP PROTOTYPE
      '-----------------
      '
      w3="" : a=1
      '
      do
        w5=tword(w4,a)
        if isc(ascw) then endline(w4,a) : continue do 'remove comment
        if lenw=0 then exit do
        if w5="const" then continue do 'OMIT
        b=lookupm(w5)
        if b then 
          if maco(b,0)=-20 then
            c=a
            w6=himac(b,w4,c)
            if len(w6)=0 then a=c : continue do
          end if
        end if
        w3+=w5
        if ascn=44 then a+=1 : w3+=","
        if ascn<>41 then w3+=" "
      loop
      '
      wr=chr(39)+chr(lnm)+lnmks+cr+w1+wr+w7+w3+w2+cr
      inserts(s,wr,i)
      goto mainloop 'TRANSLATED INTO SEMI-BASIC
      '
    end if 'C declarations
    '
    '
    '
    '
    '----------------------
    brackets: 'FOR SCOPING
    '======================
    '
    if ascw=lbr then ' (
      nest()
      if ert then goto exitap
      appendt(sp)
      goto mainloop
    end if
    '
    if ascw=rbr then ' )
      unnest : if ert then goto exitap
      appendt(ep)
      if len(wx) then inserts(s,wx,i) : wx=""
      goto mainloop
    end if
      '
    '
    'CHECKS FOR SYNTAX
    '=================
    '
    a=0
    if ascw=44 then a=1
    if ascw=91 then
      if varf=0 then
        if typ=0 then
          'a=1
        else
          if isx(ascn) then a=1
          'pass symbolname to asm cmt?
        end if      
      end if
    end if
    if a then ert=100 : ers="Syntax:" : goto exitap
    '
    'END OF `FIRST WORD ON LINE` CHECK
    '
  end if 'nl=1
  '
  nl=0
  '
  '
  '======
  nctype:
  '======
  '
  if o2h then
    '
    'START BLOCK {
    '=============
    '
    if ascw=123 then
      i=swd : cbrencah(s,i,0)
      if ert then goto exitap
      goto mainloop
    end if
    '
    'END BLOCK }
    '===========
    '
    if ascW=125 then
      if cbri>0 then
        '
        cbri-=1 : a=cbrk(cbri)
        '
        'CHECK FOR a=1: IF ELSE ENDIF
        '
        if a=1 then
          w1=wordahead(s,i)
          if w1="else" then goto mainloop
          if w1="elseif" then goto mainloop
          md=13 'IF
        end if
        '
        if a=2 then md=21 'END DO
        if a=3 then md=23 'END WHILE
        if a=4 then md=34 'NEXT
        if a=5 then md=29 'END SELECT
        if a>1100 then n=a-1100 : goto endpro
        if a>1000 then md=a-1000
        if a then
          goto endings2
        else
          goto mainloop
        end if
      end if
    end if
    '
  end if
  '
  'QUALIFY FOR AUTODIM (ARRAYS EXCLUDED)
  '-------------------------------------
  '
  if ascn<>61 then goto nrelaxed
  if isa(ascw)=0 then goto nrelaxed
  '
  if mp<>0 then
    if relaxed then goto nrelaxed
  else
    if relaxed=0 then ers="not defined" : ert=42 : goto exitap
  end if
  '
  '-----
  enlet:
  '=====
  '
  '
  '
  '------------------------------
  'IF RELAXED CREATE NEW VARIABLE
  '==============================
  '
  '
  'EXPRESSION
  '----------
  '
  'itr restricted to primitives or non-pointered types
  '
  i+=1 : typa1=0 : asg=" " : op=0 : w3=ow
  w2=expressions(s,i,0)
  c=typg
  if ert then goto exitap
  if c=0 then c=cpuw                    '
  if isstr(c) then
    c=&he0+(c and 31)  'DEFAULT TO NATIVE STRING/WSTRING
    if funi then lcls(funi)=1
  end if
  if opg>=1024 then
    opg-=1024
    if typg>&h200 then w3="*"+w3 'creating an indirect variable
  end if
  '
  if c=cpuw then
    w1="sys"          '
  elseif c<&h200 then
    w1=revdic(idtype,c)
  else
    w1=macso(c-&h200,0)
  end if
  '
  typa1=c
  '
  'CREATE VARIABLE BUT DO NOT INITIALISE
  '-------------------------------------
  '
  if isstr(c) then a=0 else a=1 'ONLY STRINGS REQUIRE INIT
  varsal(w1+" "+w3,1,a) : if ert then goto exitap
  '
  'ASSIGN VALUE
  '------------
  '
  if c>512 then
    c=cpuw 'for assigning a pointer to a higher type
    'itr save effective address for linkage
  end if
  w1=w2+ins(2,c,macso(me-1,1))
  '
  wr=macso(me-1,1) : ow=macso(me-1,0)
  goto cleardown
  '
  '
  '--------
  nrelaxed:
  '========
  '
  '
  'COLONS AS STATEMENT SEPARATORS OR ASM PREFIXES
  '----------------------------------------------
  '
  if ascw=58 then appendt(": ") : goto mainloop
  '
  '
  if ascw=35 then
    '
    'RUN TIME HOST VARIABLE ADDRESS RESOLUTION ##V
    '---------------------------------------------
    '
    b=asc(wr,2)
    if (b=35) then
      if asc(s,swd+2)=35 then
        '
        'VIEW MARKERS ###
        '
        if vwb=0 then vwb=1 : w1="#view" else vwe=1 : w1="#endv"
        appendt(w1+cr) : goto mainloop
      end if
      '##var runtime binding
      inserts (s,"proc [ebx+40] "+chr(34)+mid(wr,3)+chr(34)+cr,i)
      continue do
    end if
  end if
  '
  '
  '================
  'VARIABLE ON LEFT
  '================
  '
  if ascw=91 then
    psg=wpfx
  end if
  '
  '
  '============
  'DO PROCEDURE
  '============
  '
  'PROCEDURE OR EXPRESSION
  '
  'itr [asm] params
  '
  if varf>=8 then
    if o2h then
      if ascn<>91 then goto procs 'normal procedure (not an array of procedures)
    else
      goto procs
    end if
  end if
  '
  '
  '
  '==========================
  'ASSIGN TO VARIABLE ON LEFT
  '==========================
  '
  '                    ####          ####
  '                    ##              ##
  'RESOLVED VARIABLES: ##  [reg+offs]  ##
  '                    ##              ##
  '                    ####          ####
  '
  '
  if typ then
  'if ascw=91 then
    '
    '                ##     ##
    '               ##       ##
    '============  ##         ##
    'ARRAY ASSIGN  ##  INDEX  ##
    '============  ##         ##
    '               ##       ##
    '                ##     ##
    '
    '
    'CONVERT SQUARE ARRAY BRACKETS
    '-----------------------------
    '
#if 0
    a=typa1 : b=0
    '
    if (ascn=91)or(ascn=lbr) then
      b=fixsqbr(s,i)
      '
      'is it an element of an indexed object (in an array)
      '
      if b then
        w2=wordahead(s,b)
        if asc(w2)<>46 then w2="" : b=0 'otherwise an element
        ascn=lbr
      end if
    end if
    '
    '
    if ascn=lbr then
      if varf>=8 then a=cpuw 'selecting an indexed method
      psg=arrayres(s,i,a,wr) 'may affect wpfx
      if b then ow+=w2       'compose the full name element resolved before 
      '
      if varf>=8 then
        wpfx=psg : goto procs 'array of functions or indexed object with method call
      end if
      '
      typa1=a : bg=j : wsg=wr : appendt(wr)
      continue do
    end if 'arrays
#endif
#if 1
    if (ascn=91)or(ascn=lbr) then
      a=typa1
      b=fixsqbrp(s,i)
      psg=arrayres(s,i,a,wr) 'may affect wpfx
      if b then ow+=w2       'compose the full name element resolved before 
      typa1=a : bg=j : wsg=wr : appendt(wr)
      continue do
    end if 'arrays
#endif
    '
    '
    '=============================
    'FOR SIMPLE LEFT SIDE VARIABLE
    '=============================
    '
    bg=j : psg=wpfx : goto addsrc
    '
  end if ' a=91
  '
  if mc=-10 then bg=j : psg=wpfx : goto addsrc
  '
  '-----
  unass:
  '=====
  '
  if (ascw<>61)and(ascn<>61) then goto nassign
  cpa=identopeq(s,i,w1) : w2=cm+qeax
  nextinstruct(s,i)
  '
  '
  '      #
  '      #     ########
  '   #######
  '      #     ########
  '      # 
  '
  '
  '---------
  'LEFT SIDE
  '=========

  '
  'BACKTRACK OUTPUT STREAM
  '-----------------------
  '
  j=bg
  '
  '
  '------------------------------
  'CHECK FOR MULTIPLE ASSIGNMENTS
  '==============================
  '
  '
  'ARRAY ASSIGNMENTS & OBJECT ASSIGNMENTS
  '
  '<= =>
  '
  if (ascw=60)or(ascn=62) then
    i+=1
    if vew>0 then appendt(";MULTIASSIGN =>"+cr)
    pushaddress(wsg,psg)
    asgm=1
    asgo=0 
    asgi=maco(mq1,1)
    asgj=0
    asgk=0
    if typa1>=&h200 then
      asgs=macso(typa1-&h200,1)
    end if
    '
    nextinstruct(s,i)
    '
    'skip left bracket
    '
    if (ascn=lbr)or(ascn=123) then
      i+=1 : skiplspace(s,i)
    end if
    '
    'READ IN DATA SERIES
    '
    psg=""
    goto mainexp
    '
  end if
  '
  'SINGLE ASSIGNMENT CODE
  '
  w3=""
  '
  if (o2h)and(mq1>0) then
    if typa1<&h200 then
      '
      'ASSIGNMENT FOR PRIMITIVE TYPES
      '
      asg=psg+ins(2,typa1,wsg)
      '
    else
      '
      'ASSIGNMENT FOR HIGHER TYPES (OPERATOR "=" METHOD)
      '
      d=op
      '
      mp=mq1 : w1="=" : ard=1 : asg=operhi(psg,w1) : ard=0 'with array displacement ard flag
      '
      if cpa>2 then
        mp=mq1 : w1="" : ard=1 : w1=operhi(psg,w1) : ard=0
      else
        w1="" : d=0
      end if
      op=d
      if ert then goto exitap
      goto directexp
    end if
  else
    asg=psg+w1+wsg+w2+cr
  end if
  '
  if iss(ascn) then w1=asg : asg="" : goto cleardown 'NO RIGHT SIDE
  '
  '
  '
  'RIGHT SIDE
  '----------
  '
  '=======
  mainexp:
  '=======
  '
  '
  'SIMPLE INTEGER ASSIGNMENTS (OPTIMISATION)
  '--------------------------
  '
  if isn(ascn)=0 then goto nsimpass
  if typa1>=&h40 then goto nsimpass
  if (cpa=14)or(cpa=15) then goto nsimpass 'no*= or /=
  b=typa1 and 31 'SIZE
  w2=wordahead(s,i)+cr
  a=ascl(s,nwd)
  if ise(a) then
    if (b=0)or(b=cpuw) then
      '
      'LONG,DWORD ALSO QUAD,QWORD FOR 64 BIT
      '
      w1=ins(cpa,typa1,wsg) : a=len(w1)
      w1=psg+left(w1,a-5)+w2 'eg: ADD [EBX+4048],73
      i=nwd : goto cleardown
    end if
  end if
  '
  '========
  nsimpass:
  '========
  '
  '
  'LOW LEVEL STRING LITERALS
  '-------------------------
  '
  if o2h=0 then if isq(ascn) then w1=tword(s,i)+cr+asg : goto cleardown
  '
  '
  ' 
  '==============================
  generalexp: 'GENERAL EXPRESSION
  '==============================
  '
  if cpa<=2 then
    op=0
    w1=""
  else
    '+= -= *= /* and= or= xor=
    'op already defined
    '
    'need brackets? 'a+=(b*c)'
    '
    if (ascn<>lbr)and(nprec=0)and(typa1<&h80) then
      w1=wordahead(s,i) : a=asc(s,nwd)
      if isx(a)=0 then
         b=i : capts(s,i) : w1="("+mid(s,b,i-b)+")"
         inserts(s,w1,i)
      end if
    end if
    w1=psg+ins(1,typa1,wsg)+cr
  end if
  '
  '
  '=========
  directexp:
  '=========
  '

  w1+=expressions(s,i,typa1)+asg : if ert then goto exitap
  cpa=2
  goto cleardown 'ASSIGNMENT COMPLETED

  '
  '=======
  nassign:
  '=======  

  '
  '---------------------------------
  'ASM CALL/JMP OR IMPLIED PROCEDURE
  '=================================
  '
  if wr="call" then
    typ=0
    if wordahead(s,i)="far" then goto fargo
    '
    'CHECK FOR CALL CALL..
    '
    do
      wr=pword(s,i)
      if (wr="proc")or(wr="call") then
        continue do
      else
        exit do
      end if
    loop
    if isx(ascn) then
      appendt("call "+wr)
      if ascn<=13 then appendt(cr)
      goto mainloop
    end if
    if varf<8 then varf=8
    goto procs
  end if
  '
  if wr="jmp" then
    if wordahead(s,i)="far" then
      '
      fargo:
      '
      m=i : endline(s,i)
      appendt(wr+" "+mid(s,m,i-m)+cr)
      goto mainloop
    end if
  end if
  '
  '
  if (wr<>"proc") then goto nproc
  '
  'EXPLICIT PROCEDURE
  '
  wr=pword(s,i)
  '
  '============================
  'ALL COMMAND LEVEL PROCEDURES
  '============================
  '
  '
  '=====
  procs:
  '=====
  '
  'PSEUDOVARIABLES
  '---------------
  '
  if ascn=61 then mid(s,i)=" "  ' SIMPLE PSEUDO ASSIGN
  '
  'WATCH OUT FOR COMMAND FUNCTIONS LIKE MID()=
  '--------------------------------------------
  '
  if mc=-16 then
    if instrword(" mid ",wr) then
      inserts(s,"_"+wr+" ",i) : wr=mword(s,i)
    end if
  end if
  '
  '
  parx=1 'ensure garbage collection
  w1=procedures(s,i,wr)+asg

  '
  if ert then goto exitap
  '
  '
  '=========
  cleardown:
  '=========
  '
  if isbstr(typa1) then
    a=0
    w2="["+qebp+"+"
    a=instrevn(-1,asg,w2)
    if a then
      a=instr(a,asg,"]")
      a+=1
      if asc(asg,a)=44 then
        ert=156 : ers="Must not assign to a string param passed byval" : goto exitap
      end if
    end if
  end if
  '
  jn=0   'clear string joining flag itr
  if dts(funi)>0 then
    w1+=rtl(deltmpa)+cr
    dts(funi)=-1 'delete temp strings
  end if
  '
  appendt(w1) 'FULLY RESOLVED TO ASSEMBLY CODE
  '
  if ert then goto exitap
  skiplspace(s,i)
  cpa=0 : fpu=0 : nprec=0 : parx=0 : divi=0 : enu=0
  psg="" : asg=""
  '
  '
  goto mainloop
  '
  '
  '=====
  nproc:
  '=====

  '
  '-------
  'EQUATES
  '=======
  '
  '
  '   ###    ##
  '   # #   ##
  '   ###  ##
  '       ##
  '      ##  ###
  '     ##   # #
  '    ##    ###
  '
  '
  '
  '$ % EQUATES
  '-----------
  '
  if (ascw=36)or(ascw=37) then
    m=swd : a=ascw : wr=tword(s,i)
    '
    if (a=36)or(a=37) then
      if ascn=61 then
        i+=1
      end if
    end if
    '
     : typo=1 : goto isdefi
    '
  end if
  '
  '
  '
  '##############################
  '
  '     #####    #####   #     #
  '    #     #  #     #  #     #
  '    #     #        #  #     #
  '    #     #   #####   #######
  '    #     #  #        #     #
  '    #     #  #        #     #
  '     #####   #######  #     #
  '
  '##############################


  if (mc<>-14) then goto end_o2h
  '
  '
  '
  '=======
  o2hmain:
  '=======
  '
  'O2H KEYWORDS
  '
  md=maco(mp,5)
  '
  '
  '
  n=0 ': d=0
  '
  select case md
  '
  case 1
    goto defs 'ENUM
  case 2
    wr=pword(s,i) : goto enlet 'LET
  case 3
    '
    'OPERATOR
    '
    'support muliple operator declarations
    '
    do
      w1=noquotes(tword(s,i))
      macoin me
      set_macro_name(w1)
      maco(me,0)=-12
      '
      'SET PRECEDENCE LEVEL (WITH HIGH DEFAULT)
      '
      if isx(ascn)=0 then
        a=wval(tword(s,i))
      else
        a=99 'HIGHEST PRECEDENCE
      end if
      '
      maco(me,5)=a 'RECORD OPERATOR PRECEDENCE
      '
      addme : if ert then goto exitap
      if ascn=44 then i+=1 : continue do 'MORE OPERATORS TO FOLLOW
      exit do
    loop
    continue do
    '
    '
    '
    '
    '  ############################
    '
    '  #########   ###  ##       ##
    '   #       #   #   # #     # #
    '   #       #   #   #  #   #  #
    '   #       #   #   #   # #   #
    '   #       #   #   #    #    #
    '   #       #   #   #         #
    '  #########   ###  #         #
    '
    '  ############################
    '
    '
  case 4 'DIM
    n=4 : if funi then n=1 'GLOBAL/LOCAL
    if wr="const" then cnst=1
  case 5 
    n=1 'LOCAL
    if funi=0 then ers="Locals must be inside a procedure block" : ow="" : ert=99 : goto exitap
  case 6
    n=4 : if funi then n=3 'STATIC
  case 7
    n=4 'GLOBAL
    if funi then ers="Globals must be outside procedure block" : ow="" : ert=200 : goto exitap
  case 8
    n=18 'DECLARE
  case 9
    n=11 'FUNCTION
  case 10
    n=12 'SUB
  case 11
    n=13 'METHOD
  end select
  '
  w=swd 'SET BLANKOUT MARKER
  '
  'ENDINGS
  '--------
  ' "=" at         then n=19    ' assignment expressions
  ' "export"       then n=23    ' export addresses
  '
  '
  '
  'DISTINGUISH FROM ASSEMBLER sub
  '------------------------------
  '
  if n=12 then
    if issub(s,i)=0 then n=0
    'if n then if w1="finish" then tmnt=1
  end if
  '
  if n then 'TRANSLATE DIM TO VAR AND INITIALISE
    '
    wt="" : wm="" : ws="" : w1="" : w2="" : w4=""
    q=0 : fdd=0 : sigs="" : sigd="@" : w5="" : w6="" : w7=""
    pn=0 : typd=0 : typf=0 : df=0 : dg=0 : fc=0 : lbli=0
    '
    'PREPARE FOR PROCEDURES
    '----------------------
    '
    if n>10 then
      w4=lnmks
      if n<>18 then
        w8=wr 'function sub etc
        a=i : b=i : CaptProcHead(s,b) : w9=w8+" "+mid(s,a,b-a)+cr
        skiplspace(s,i)
      end if
      '
      '
      'PROCUDURE HEADER
      '----------------
      '
      if funi>=7 then ert=160 : ers="Too many procedure nestings" : goto exitap
      funi+=1
      '
      typp(funi)=cpuw
      th(funi)=0
      noin(funi)=0
      ml(funi)=0
      funn(funi)=0
      lcl(funi)=0
      lcls(funi)=0
      mlcl(funi)=0
      '
      wva(n)="" : wlc=0          'CLEAR STATE
      ccp(funi)=ccx              'DEFAULT CALLING CONVENTION
      atf(funi)=atx              'DEFAULT EXTERNAL FLAG
      '
      if n=18 then
        w1=wordahead(s,i) 'DECLARE
        if instrword(" function sub ",w1) then
          i=nwd
        end if
      end if
      '
      ali=uword(s,i)             'ALIAS NAME WITH QUOTES REMOVED
      wn=wword(ali,1)            'CASE CONVERTED NAME
      skiplspace(s,i)
      '
      '
      if vew>0 then
        if(n>=11)and(n<=13) then appendt(cr+cr+ucase("'"+wr+" "+wn)+cr+cr) : bg=j
      end if
      '
      c=0
      '
      funn(funi)=n
      '
      do
        w1=wordahead(s,i)
        a=dic(" lib 1, alias 2, ",w1)
        if a=1 then
          i=nwd
          lby=noquotes(mword(s,i))
          continue do
        elseif a=2 then
          i=nwd
          ali=noquotes(tword(s,i))
          continue do
        end if
        a=dic(callco,w1) 'EXPLICIT CALLING CONVENTION
        if a then
          if a=&h110 then leaf=1
          ccp(funi)=a and &hff 'leave only the lower byte
          i=nwd : continue do
        end if
        exit do
      loop
      '
      '
      if n=18 then
        if lby="" then lby=libr 'POSSIBLE DEFAULT LIBRARY NAME
      else 
        lby=""
        ths=0
        if funi>1 then ml(funi)=me : mel=me 'LOCAL FENCE
      end if
      '
      funm(funi)=ali 'remember original name
      '
      '
'      fdd=bref
      '
      'CHECK (PARAM BLOCK) PRESENT
      '---------------------------
      '
      if n<>18 then nextinstruct(s,i) else skiplspace(s,i)
      '
      lnmks=w4 : w4=""
      '
      if (ascn=lbr) then
        i+=1 : nextinstruct(s,i) : bpb=1
      elseif (ascn=61)or(ascn=123) then
        goto ndimbr
      elseif (n=12)or(n=18) then
        goto ndimbr
      end if
      '
      w1=wordahead(s,i)
      if instrword(" : as at dim static local return function method exit end ",w1) then
        goto ndimbr
      end if
      '
      if n=13 then pn=1 'offset allowing for 'this'

    end if 'N>10

    '
    '
    'STATICS ARE MARKED FOR TRANSFER TO STATIC ZONE AT TOP OF PROG
    ' 
    if n=3 then w6=sq+cr : w7=eq+cr
    '
    '
    '
    '    #
    '  ##
    ' ##
    ' ##  PROCESS EACH DECLARATION PARAMETER
    ' ##
    '  ##
    '    #
    '
    '=======
    dimiter:
    '=======
    '
    do
      '
      m=0 : skiplspace(s,i) : b=ascn
      '
      if n>10 then
        if isc(ascn) then nextinstruct(s,i) : b=ascn
      end if
      '
      'CHECK FOR END OF DIM
      '--------------------
      '
      'check for closing ')'
      '
      if bpb then
        if b=rbr then
          i+=1 : skiplspace(s,i) : m=2 : bpb=0
        elseif iss(b) then
          nextinstruct(s,i)
          if ascn=rbr then i+=1
          m=2 : bpb=0
        end if
      else 'no bpb ')' expected
        if iss(b) then m=2
      end if

      if n=1 then
        wlc=1
      end if 
      '
      if n<10 then if len(wt) then if ws="" then m=0 : nextinstruct(s,i)  
      '
      'END OF DIM OR DELARATION
      '------------------------
      '
      if m=2 then
        '
        'LOCAL VARIABLES SETUP INLINE
        '
        '
        'ASSIGN TYPE IF NEEDED
        '
        if len(ws) then
          if wt="" then
            if typd then wt=revdic(idtype,typd) else wt="sys"
          end if
        end if
        wr=wt : dg=2 : goto recovar
        '
      end if 'm=2 'end of dim or declaration
      '
      '
      'NEXT PARAMETER OR TYPE IN THE LIST
      '==================================
      '
      skipcomcom(s,i)
      '
      c=0
      do
        wr=tword(s,i)
        '
        if (ascw=36)or(ascw=37) then
          i=swd+1              'STRIP LEFT % OR $ (thinBasic)
        elseif isc(ascw) then
          endline(s,i)         'SKIP COMMENT
        elseif wr="..." then
          a=ccp(funi)
          if a=0 then a=1 'AUTO CDECL ELLIPSIS
          a or=256
          ccp(funi)=a
          sigd+=".."
          goto dimiter 'ELLIPSIS ...
        else
          exit do
        end if
      loop
      '
      '
      if ascw=lbr then continue do
      '
      '
      do
        b=dic(" byval 1, byref 2, optional 8, ",wr)
        if b then
          if b<=2 then
            fc=b : fdd=b-1
          elseif b=8 then
            opa=49
          end if
          wr=tword(s,i)
        else
          exit do
        end if
      loop
      '
      '
      'CHECK FOR LEADING '*' INDIRECTION
      '=================================
      '
      '
      f=0
      '
      if ascw=42 then
        do
           if ascw<>42 then exit do
           fdd+=1 : wr=tword(s,i)
        loop
      end if
      '
      ow=wr
      '
      'IDENTIFY TYPE
      '=============
      '
      f=0
      '
      '
      if wr="as" then 
        wr=tword(s,i)
        '
        f=2
        '
        'CHECK FOR INLINE TYPE
        '---------------------
        '
        'dim as (byte r,g,b) pix[256]
        'dim as pixel (byte r,g,b) pix[256]
        '
        a=0
        if (ascw=lbr)or(ascw=123) then
          wr="_anon_" : a=1 : i=swd
        elseif (ascn=lbr)or(ascn=123) then
          a=1
        end if
        '
        if a then
          macoin me : if ert then goto exitap
          set_macro_name(wr) : lbw=wr
          a=o2h : o2h=0
          w1=captureblock(s,i,"")
          o2h=a 'set o2h 0 prevents suffix stripping
          nocomments(w1)
          macsi(w1,me,1)
          types(0)
        end if
        skiplspace(s,i)
      elseif fc then
        if n=18 then if identype(wr) then f=2 'BYREF/BYVAL USED
      end if
      '
      if f then goto astype
      '
      '--------------------
      'DEFINITELY NOT TYPES
      '--------------------
      '
      if ascn=97 then
        w1=wordahead(s,i)
        if w1="as" then
          if n>10 then
            if fc=0 then fdd+=bref 'IMPLICIT BYREF DEFAULT
          end if
          goto addvarlis 'CANNOT BE A TYPE
        elseif w1="at" then
          goto addvarlis 'CANNOT BE A TYPE
        end if
      end if
      '
      '------------------------
      'IDENTIFY POSSIBLE C TYPE
      '------------------------
      '
      if (isa(ascn))or(ascn=42) then 'C TYPE
        '
        i=swd 'REPARSE
        '
        '=====
        rnxdw:
        '=====
        '
        wr=mword(s,i) 'MACRO EXPANSION
        '
        if lenw=0 then
          '
          continue do 'FOR EXIT PROCEDURE
          '
        elseif (mc=-4)or(mc=-13)or(mc=-14) then
          '
          if n<>18 then ers="reserved word" : ert=319 : goto exitap
          a=0
          '
        else 'PRIMITIVES UDT / CLASSES
          '
          'PRIMITIVE (ALSO RESOLVES MACROS)
          '--------------------------------
          '
          a=identype(ow)
          '
        end if
        '
        if a then
          if ascn=42 then
            if wr="void" then 
              wr="sys" 'PARAM COMPATIBILITY SIG
              i+=1
              skiplspace(s,i)
            end if
          end if
          '
          f=1 : typf=a : goto astype
          '
        end if 'a
        '
      end if 'identify c type
      '
      '
      '-------------
      'IMPLICIT TYPE
      '-------------
      '
      a=0
      if (ascn=44)or(ascn=rbr)or(ascn=61) then a=1 ' *, ) =
      if n>10 then a or=2
      '
      if a then
        if n>10 then
          '
          if ascn=rbr then
            if wr="void" then continue do
          end if
          '
          'skip ()() [] etc
          '
          if (ascn=lbr)or(ascn=91) then
            if n=18 then b=identype(wr) else b=0
            if b then wt=wr : wr="__" : typf=b
            '
            if wt="void" then
              wt="sys"
            else 'not void
              if fdd=0 then fdd=1
            end if
            '
            while (ascn=lbr)or(ascn=91)
              capture(s,m,i,0)
              skiplspace(s,i)
            wend
            '
            ascw=asc(wr)
            '
          end if ' (..) [..]
          '
          '
          '
          'C TYPE OR DEFAULT TYPE FOR FUNCTION PARAMS
          '------------------------------------------
          '
          '
          typd=typf
          '
          'CHECK FOR INFERRED TYPE IN A PROTOTYPE
          '
          if (ascn=60)or(ascn=61) then
            a=i
            capts(s,a)
            if (ascn=rbr)or(ascn=44) then
              w1=mid(s,i,a-i)
              if typd=0 then
                b=asc(w1,2)
                if (b=61)or(b=62) then a=3 else a=2 '<=' '=>' support
                nsto=1 : w1=expressions(w1,a,0) : typd=typg : nsto=0 'discover type of expression
                if isbstr(typd) then typd+=32 'auto dynamic string
                ascn=44
              end if
            end if
          end if
          '
          'CHECK FOR NO OTHER WORDS
          '
          if (ascn=rbr)or(ascn=44) then
            w1=wr
            if len(wt) then
              wr=wt
            elseif typd>&h200 then
              wr=macso(typf-&h200,0)
            elseif typd then
              wr=revdic(idtype,typd)
            else 'typd=0
              wr="sys" ' 32 / 64 bit according to mode
            end if
            '
            '
            sigs+="#"+wr : sigd+="a"+chr(48+fdd+opa) 'BUILD SIGNATURE
            if n<>18 then ws=string(fdd,"*")+w1
            skiplspace(s,i)
            dg=1 : goto recovar
          end if
        end if ' n>10
      end if 'a
      '
      '
      '------
      astype:
      '------
      '
      if f then
        '
        'EXPLICIT TYPE
        '-------------
        '
        if f=2 then typf=identype(wr)
        '
        if typf=0 then
          'if (fdd>0)and(n=18) then
          '  typf=-1 : wr="void" ' void ptr
          'else
          ers="Unknown type " : ert=201 : ow=wr : goto exitap
          'end if
        end if
        '
        w3=wr : b=0 : w5=""
        '
        if ascn=&h70 then
          '
          'RESTRICT TO POSTDEF: DIM B AS BYTE PTR
          '
          if len(ws) then
            if instrword(" ptr pointer ",wordahead(s,i)) then
              i=nwd : fdd+=1 : b+=1 : w5=" ptr"
            end if
          end if
        end if
        '
        if w3="string" then
          if (n=1)or((n>10)and(n<18)) then
            lcl(funi)=1 : lcls(funi)=1 ' FLAG LOCAL DYNAMIC STRINGS
          end if
        end if
        '
        skiplspace(s,i)
        '
        'ARRAY OF A TYPE
        '
        if ascn=91 then
          inserts(s,"__",i)
        end if
        '
        if n>10 then
          if f=2 then sigs+="#"+w3 : sigd+="a"+chr(48+fdd+opa) 'BUILD SIGNATURE FOR PROCEDURES
        end if
        '
        '
        if ws="" then
          wt=w3+w5 : continue do 'FIRST TIME PREDEF ONLY
        end if
        '
        if wt="" then
          wr=w3+w5 'POSTDEF
        else
          wr=wt    'PREDEF
          wt=w3    'SET NEXT PREDEF
        end if
        dg=1
      end if 'f=1  AS TYPE
      '
      '====================
      recovar: 'DECLARE VAR
      '====================
      '
      if dg then
        '
        if len(ws) then
          pn+=1 : if leaf then varreg(pn,fdd,wr,ws)
          '
          'CHECK FOR ARRAY TYPEs
          '
          while (ascn=91)or(ascn=lbr)
            capture(s,m,i,0) 'discard [] () 'multi
            skiplspace(s,i)
            if asc(ws)<>42 then ws="*"+ws 'ensure byref
          wend
          '
          if n<>18 then
            declvars(wr+" "+ws+cr,n,w4,noin(funi))
          end if
          '
          if n>10 then
            if cpuw=8 then typl(pn)=identype(wr)
          end if
          '
          if ert then goto exitap
          if n=1 then lcl(funi)=1
          skiplspace(s,i)
          '
          if (ascn=60)or(ascn=61) then
            wr=mid(ws,fdd+1) : ws="" : w2="" : w3=""
            dg=0 : goto assig ' AS ATYPE = ...
          else ' not = <=
            if n>10 then
              if len(w4) then
                ert=107 : ers="Expecting param '=' expression in "+wn
                goto exitap
              end if
            end if
          end if
          ws=""
        end if 'len ws
        '
        'TERMINATION OF DIM STATEMENT
        '
        if dg=2 then
          '
          'INITIALISATION
          '
          'includes stack allocation and zero and explicit vales
          '
          if n<10 then
            '
            if len(w4) then
              inserts(s,w4,i) : w4=""
            end if
            cnst=0
            goto mainloop
            '
          else 'n>=10
            '
            ws="" : exit do 'FURTHER PROCESSING FOR PROCEDURES
            '
          end if
        end if 'dg=2
        dg=0 : goto nextidim 'next item
      end if 'dg
      '
      '
      '===============================
      addvarlis: 'ADD VARIABLE TO LIST
      '===============================
      '
      '
      ws+=" "+string(fdd,"*")+wr
      '
      skiplspace(s,i)
      '
      'CAPTURE ARRAY
      '=============
      '
      w3=""
      c=0
      '
      if (ascn=lbr)or(ascn=91) then
        '
        'CHECK FOR EMPTY BRACKETS
        '
        w1=wordahead(s,i+1)
        a=asc(w1)
        '
        if (a=rbr)or(a=93) then
          i=nwd : skiplspace(s,i) : c=1 'SIGNAL EMPTY BRACKETS
        else
          capture(s,m,i,a) : skiplspace(s,i) : w3+=mid(s,m,i-m)
        end if
        '
      end if
      '
      w2=""
      '
      if ascn=97 then
        '
        'MAPPING TO REGISTER
        '===================
        '
        if wordahead(s,i)="at" then
          i=nwd
          do
            w2+=tword(s,i) : a=ascw ' COLLECT POINTERS
            if a<>42 then exit do
          loop
          if (a=38)or(a=64) then
            w2+=tword(s,i)       'MAP TO ANOTHER VAR
          elseif a=91 then
            i=swd : w2+=mid(mword(s,i),2) 'REGISTER ETC
            'itr member of parameter etc
          end if
          w2=" at "+w2 : skiplspace(s,i)
        end if
        '
      end if
      '
      '
      '=================
      assig: 'INITIALISE
      '=================
      '
      'typd=0
      '
      '<=' '=>'
      '
      if (ascn=60)or(ascn=61) then
        '
        b=i
        a=i+1
        if ascn=60 then a+=1
        skipspace(s,a)
        '
        '
        'CHECK FOR ARRAY DATA
        '
        if c then
          '
          'ONLY SUPPORTS ONE STRING LITERAL
          '
          if isq(ascn) then
            w1=tword(s,a+0)
            w3+="["+str(lenw)+"]" 'insert array
          end if
        end if
        '
        'CAPTURE EXPRESSION
        '------------------
        '
        i=a
        capts(s,i)
        '
        'IF EXPRESSION EXISTS
        '
        if i>a then
          w1=mid(s,b,i-b)
          if (n<10)and(cnst=0) then
            w4+=w6+wr+w1+cr+w7
          else 'PARAMS DEFAULTS
            w4+=wr+w1+cm
          end if
        end if
        '
      end if
      '
      ws+=w3+w2 'APPEND ARRAY AND MAPPING
      '
      '
      '========
      nextidim:
      '========
      '
      skiplspace(s,i)
      '
      if ascn=44 then
         fdd=0 : fc=0 'CLEAR INDIRECTION FLAGS
      end if
      '
    loop ' NEXT DIM MEMBER
    '
    '
    '  #
    '   ##
    '    ##
    '    ##
    '    ##
    '   ##
    '  #
    '
    '
    '======
    ndimbr:
    '======
    '
    opa=0
    '
    if n>10 then
      '
      macoin me
      w1="" : w5="" : w6="" : wm=""
      if len(sigs) then w2=sigs+sigd else w2=""
      nextinstruct(s,i) ' may check on lines following.
      '
      '
      c=etx
      b=-5  'metatype
      e=0
      '
      '============
      do 'rqualpro:
      '============
      '
      skiplspace(s,i)
      '
      if ascn=44 then
        i+=1 : continue do 'SUPPORT COMMA SPACING
      end if
      '
      if c=0 then
        '
        if isx(ascn)=0 then
          w1=wordahead(s,i)
        else
          w1="" :  exit do
        end if
        '
        d=dic( " as 1, export 2, extern 3, external 3, callback 3, com 3, link 4, at 5, label 6, exposed 7, ",w1)
        '
        if d then
          i=nwd
        else
          exit do
        end if
        '
      else 'default export
        d=2
        c=0
      end if
      '
      '
      '============
      select case d
      '============
      '
      case 1
        '
        'AS
        '--
        '
        w5=tword(s,i)
        '
        if (w5="void")and(ascn<>42) then
        else
          if n<>18 then lcl(funi)=1
          wva(2)=w5
        end if
        '
        'RETURNING POINTERS (SWALLOW)
        '
        d=0
        '
        do
          skiplspace(s,i)
          if ascn=42 then
            i+=1 : d+=1 : continue do
          elseif ascn=&h70 then
            if wordahead(s,i)="ptr" then i=nwd : d+=1 : continue do
          end if
          exit do
        loop
        '
        'ASSUME HIGHER TYPES RETURN A POINTER
        '       
        a=identype(w5)
        '
        if a>=&h200 then
          '
        elseif a>=&h100 then
          '
        elseif a>=&he0 then
          a-=32
          if n<>18 then lcls(funi)=1 'GARBAGE COLLECTION
        elseif a>=&hc0 then
          if n<>18 then lcls(funi)=1 'GARBAGE COLLECTION
        elseif a>=&ha0 then
          '
        else
          if d then
            a=cpuw : w5="sys" 'TREAT POINTER AS SYS
          elseif a<0 then
            a=0 : w5="" 'VOID
          end if
        end if
        '
        typp(funi)=a
        wm+="as "+w5
        d=0
        '
      case 2
        '
        'ADD TO EXPORT TABLES
        '--------------------
        '
        'exluding declared functions and methods
        '
        if (n<>18)and(n<>13) then
          wm+=" "+wr : exportadd(wn,ali,eord)
          atf(funi)=1
        end if
        '
      case 3
        '
        atf(funi)=1 'EXTERNAL ETC
        '
      case 4
        '
        'LINK
        '====
        '
        'IN  ARRAY OR PROCEDURE HEADER
        'GIVE PROCEDURE POINTER TO EXTERNAL OR INTERNAL VARIABLE
        '
        'COULD BE MAPPED TO RUNTIME: at [EBX+offset]
        '
        'OR PROVIDE FUNCTION ADDRESS FOR HOST    ..at #hv
        '
        w1=mword(s,i)
        if ascw<>91 then
          atf(funi)=1 'SET AS EXTERNALLY ACCESSIBLE PROC
          'FOR EXTERNAL USE: 'EXTERNAL LINK'
        end if
        '
        atadd (s,i,wn+sigs, w1, w6)
        '
      case 5
        '
        'AT
        '==
        '
        'IN DECLARE STATEMENT
        '
        'EXTERNAL / VECTORED FUNCTION DECLARATION
        '
        'declare function xyz() as sys at a   /  at xyz
        '
        'LINK A FUNCTION TO AN EXISTING VARIABLE OR ANOTHER FUNCTION
        '
        w1=mword(s,i)
        b=-7
        macsi(w1,me,1) 'DYNAMIC VECTOR
        '
      case 6
        '
        lbli=1 'LABEL
        '
      case 7
        '
        e=1 'EXPOSED
        '
      end select
      '
      loop
      '
      '
      'MAP  PROCEDURES
      '===============
      '
      ' FUNCTION SUB DECLARE but exclude METHOD
      '
      if n<>13 then
        '
        'CREATE PROCEDURE RECORD
        ' excluding methods
        '
        c=0
        '
        'IF DECLARED
        '-----------
        '
        if n=18 then
          if len(lby) then
            '
            'ADD LIBRARY IF NOT SEEN BEFORE, THEN ADD PROC TO LIST
            '
            b=-6 ' metatype
            c=addlib(lby,ali) : lby=""
            macsi(space(16),me,1) 'RESERVE SPACE FOR ENCODING
          end if
          lbw="declare .. "+wn
        else 'N<>18
          lbw=wn
        end if
        '
        '
        '
        'itr overloaded functions: family must have similar spec.
        '
        '
        if w2="" then w2="#@"    'NO PARAMS
        if w5="" then w5="-"     'NO RETURN
        '
        '
        'DEFAULT PARAMS
        '--------------
        '
        if len(w4) then
          w4=" (,"+w4+")"
        end if
        '
        '
        'FINALISE SIGNATURE + DEFAULTS RECORD
        '------------------------------------
        '
        'EG: ##long#string@a0a1 double n (,a=3,b=4,)
        '
        '
        '
        w3="#"+w2+" "+w5+" n "+w4+cr
        '
        '
        'SELECTED OVERLOADING
        '--------------------
        '
        mqf=0 : d=0
        '
        if b=-5 then
          d=lookupm(wn) 'lookup prior
          if d then
            a=maco(d,0)
            if (a=-5)or(a=-6)or(a=-7)or(e>0) then
              w3+=macso(d,3) 'overload and append prior
              macsi(w3,d,3)
              maco(me,0)=b
              mqf=d
            else
              d=0
            end if
          end if
        end if
        '
        if d=0 then
          '
          e=ccp(funi)
          if b=-5 then
            if cpuw=8 then
              if atf(funi)=0 then e=3 'fastcall not used internally
            end if
          end if
          '
          '======================================================================='
          macsi(wn,me,0)        ' name
         'macsi(??,me,1)        ' source code (-5) vectors (assigned for metatypes -6 and -7)
          macsi(ali,me,2)       ' alias for export or import
          macsi(w3,me,3)        ' list of param signatures (overloadable if -5 or -7)
          '-----------------------------------------------------------------------'
          maco(me,0)=b          ' metatype -5 direct -6 library -7 vector
         'maco(me,1)=0          ' stack cleanup nbytes (assigned later)
         'maco(me,2)=0          ' aoff offset for imported proc addr (assigned later)
          maco(me,3)=c          ' library list index
          maco(me,4)=e          ' calling convention
         'maco(me,5)=??         ' expressed function flag
          '======================================================================='
          '
          addm(me) : mqf=me : addme() : if ert then goto exitap
          '
        end if
        '
        ali=""
        '
        'DECLARATION
        '-----------
        '
        if n=18 then
          '
          dcp=0 : goto ClearDownFuns
          '
        end if
        '
        '
      end if ' n=11 12 18 but not 13

      '
      'LOOK AHEAD (SKIP COMMENTS)
      '--------------------------
      '
      nextinstruct(s,i)
      '
      '
      '-------------------------------
      'SHORT FORM FUNCTION() AS TYPE =
      '===============================
      '
      if ascn=61 then
        m=i : endcomcomline(s,i)
        w1="{ _return"+mid(s,m,i-m)+" }"
        inserts(s,w1,i) : ascn=123
      end if
      '
      '-----------------------
      'FUNCTION() AS TYPE (..)
      '=======================
      '
      '(..BODY..) bracket conversion {..}
      '
      fixrobr(s,i)
      '
      '-------------------
      'possible {..BODY..}
      '===================
      '
      cbrencah(s,i,n+1100)
      '
      if ert then goto exitap
      '
      '================
      'CONSTRUCT PROLOG
      '================
      '
      'COMPOSE LABEL
      '-------------
      '
      wn="."+wn
      '
      if atf(funi)or(lbli<>0) then
        w1=wn+cr 'ADD PLAIN LABEL
      else
        w1=""
      end if
      '
      if e then w1="o2 sx"+cr+w1 : wn="o2 sx"+cr+wn 'EXPOSED

      if n=13 then
        wn+=sigs 'name underscore signature
        'if the name is an operator then it is enclosed by double quotes eg: ."+"_
      else
        wn=w1+wn+sigs
      end if

      'STEPOVER THE INLINE PROCEDURE
      '-----------------------------
      '
      wm=w6+"jmp fwd _endproc"+cr+"o2 !10"+cr+wn+" ' "+wm+sp
      '
      'SCOPE RESTRICTION
      '------------------

      nest() : if ert then goto exitap
      '
      mest=me 'LOCAL FENCE (SET BEFORE PARAMS AND LOCALS)
      '
      a=2*cpuw 'DEFAULT OFFSET FOR PARAMS ON STACK
      '
      if ccp(funi)=16 then leaf=1 'cpu' calling convention
      '
      'EXTERNAL EXPORTED OR CALLBACK FUNCTIONS
      '
      if atf(funi) then
        if cpuw=4 then
          b=3
        else
          b=4  'ALLOW FOR EXTRA REGISTER STORAGE
          c=ccp(funi)
          if c=0 then ccp(funi)+=2 'SWITCH TO MS64 CALLING CONVENTION
        end if
        a+=b*cpuw
      end if
      '
      'BASELINE USED TO ESTABLISH
      'PARAM BYTES TO BE DUMPED ON RETURN
      '
      retb=a
      '
      'METHODS
      '-------
      '
      if n=13 then
        '
        'mapping override of this in exported methods
        '
        ths=mest : lcl(funi)=1
        w1=macso(clss(clsi-1),0) 'get name of class (potentially nested)
        '
        if leaf then
          w2=pecx 'REGISTER PARAM BASED `THIS` PTR
        else
          w2="*"+memreg(qebp,a) 'MEM PARAM BASED `THIS` PTR
        end if
        '
        '
        'RESERVE PLACE FOR `THIS` ON STACK
        '
        a+=cpuw
        '
      else 'n=11 n=12
        if clsi then
          ths=mest 'function inside a class
          w1=macso(clss(clsi-1),0)
          w2=memreg(qebp,0) 'for access to static members
        end if
      end if
      '
      if ths then vars(w1+" this at "+w2+cr,1)
      th(funi)=ths
      '
      'PROCEDURE PARAMETERS
      '--------------------
      '      
      localvars() : asce=1 : aoffl=a : aoff=a
      '
      if len(wva(n)) then
        'if cpuw=8 then vstp=8 'FORCE VAR LOCATION INCREMENT
        vars(wva(n),5) : lcl(funi)=1  'PARAMETERS
        'vstp=0
      end if
      '
      reto(funi)=aoff-retb : maco(mqf,1)=reto(funi) 'RETURN DUMPING N BYTES
      '
      '
      'PRESERVE REGS FOR EXTERNAL.EXPORTED FUNCTIONS
      '-----------------------------------------
      '
      if atf(funi) then
        wm+=preserveregs()
      end if
      '
      '
      appendt(wm) : bgl=i
      '
      w1=""
      '
      '
      '
      'THE FOLLOWING LINE MAY BE BLANKED OUT (IF LOCAL VARS NOT USED)
      '--------------------------------------------------------------
      '
      blcl(funi)=j
      w1=makelocalspace(pn,leaf)+cr
      plcl(funi)=j+len(w1)-12 'for patching in stack allocation
      '
      '
      'PREPARE FOR CREATING LOCAL VARIABLES
      '------------------------------------
      '
      asce=-1 : aoffl=-cpuw*3 : aoff=aoffl 'allow for string lists
      '
      '
      'CREATE A RETURN VARIABLE
      '------------------------
      '
      a=0
      '
      if (len(wva(2))<>0)and (ccp(funi)<>17) then
        '
        a=typp(funi)
        '
        if a<&h200 then
          if a=&h40 then a=&h68 : wva(2)="double" 'fpu return type using qword slot
          w3=" _return"
          a and=31
        else
          w3=" *_return"
          a=cpuw 'FOR RETURNING A POINTER ONLY
        end if
        '
        if leaf then w3+=" at "+regn(0) 'SPECIFY REGISTER AS PARAMETER
        '
        vars(wva(2)+w3,1)
        '
        '
      end if 'RETURN VARIABLE
      '
      'RESERVE STACKSPACE FOR RETURN VAR AND TMP/LOC STRING DEATH LISTS
      '
      a+=3*cpuw 'ALLOWING FOR LISTS
      '
      'ENSURE 16 BYTE ALIGNMENT FOR 64 BIT
      '
      if cpuw=8 then
        if (a=24)or(a=40) then a+=8 : aoff-=8 : aoffl=aoff
      end if
      '
      if leaf then
        mlcl(funi)=a
      else
        w1+=stackspace(a,noin(funi))
      end if
      '
      appendt(w1+crg) 'crg is used as an end marker for blanking
      '
      '
      'CLEARDOWN CODE BUFFERS
      '----------------------
      'and resume sequential coding
      '
      wlc=0 : leaf=0 'LEAF APPLIES TO PROC PARAMETERS ONLY.
      '
      for m=0 to 19 : wva(m)="" : next 'CLEAR
      goto mainloop
      '
      '
    end if ' n>10
    '
    continue do ' main
    '
  end if ' n>0
  '
  '
  '
  '
  '=======
  endings:
  '=======
  '
  '
  '
  '############################################
  '
  '    ######  ##    #  #####
  '    #       # #   #   #   #
  '    #####   #  #  #   #   #
  '    #       #   # #   #   #
  '    ######  #    ##  #####  FUNCTION SUB PROC
  '
  '#############################################
  '

  if md=12 then 'END
    '
    w=swd
    wr="" : n=0 : md=0
    '
    if isx(ascn)=0 then
      wr=mword(s,i)
      if isx(ascn)=0 then w1=mword(s,i) ' swallow
      if mc=-14 then
        md=maco(mp,5)
      end if
    end if
    '
    '
    '========
    endings2:
    '========
    '
    a=0
    select case md
    case 09 :           goto endpro   '          SUB
    case 10 :           goto endpro   '          FUNCTION
    case 11 :           goto endpro   '          METHOD
    case 34 :           goto endcons  '          NEXT
    case 13 : md=17   : goto endcons  'IF     to ENDIF
    case 21 : md=18   : goto endcons  'DO     to ENDDO
    case 23 : md=19   : goto endcons  'WHILE  to ENDWHILE
    case 29 : md=20   : goto endcons  'SELECT to ENDSEL / SWITCH TO ENDSEL
    case 37 : a=1                     '          METHOD
    case 41 : a=1                     '          BLOCK
    case 42 : a=1                     '          SCOPE
    case 48
    if cpuw=4 then ccx=0 else ccx=2 'ms64
    atx=0 : etx=0 : libr="" : goto mainloop 'EXTERN
    case 00
    if wr="with" then
      wi=0 : wth="" : goto mainloop
    end if
    end select
    '
    endline(s,i)
    '
    if a then ' METHODS BLOCK SCOPE
      '
      w1=ep
      '
      if md=37 then
        '
        'INSERT TABLE BUILDING CODE ETC
        '------------------------------
        '
        if clsi then
          clsi-=1 'nestable classes
          a=clss(clsi)
          w1="._mt_"+cr+macso(a,3)+ep
          wr+=" of "+macso(clss(clsi),0) 'label for vew
        else
          ert=107 : ers="Class not defined" : goto exitap
        end if
      end if
      '
      '
      if vew then
        if wr="}" then wr=""
        w1+="'END "+ucase(wr)+cr+cr
      end if
      '
      'inserts(s,w1,i) : goto mainloop
      appendt(w1) : unnest() : goto mainloop
      '
    end if
    '
    ers="Invalid end: "+wr+str(md) : ert=99 : ow="" : goto exitap
    '
    '
    '
    '
    '========================
    endpro: 'PROCEDURE EPILOG
    '========================
    '
    '
    'RETURN VALUES
    '-------------
    '
    n=funn(funi)
    '
    if (lcl(funi)<>0)and(ccp(funi)<>17) then
      w1=retvalue(n,typp(funi))
    else
      w1=""
    end if
    '
    w1+=".end_return"+cr
    '
    '
    'RELEASE LOCAL RESOURCES
    '-----------------------
    '
    a=0
    if lcl(funi) then a=1 
    if (ccp(funi)=16)and(mlcl(funi)=0) then a=0 'applies to cpu calling convention 
    if (lcls(funi) or dts(funi) or dcs(funi)) then a=1
    '
    if a then
      '
      'RESTORE STACK POINTER
      '---------------------
      '
      w2=restorestack()
      '
      a=mlcl(funi)
      if cpuw=8 then roundup(a,16)
      mid(t,plcl(funi))=str(a)+" " ' patch in reserve stack space
      '
    else 'NO LOCAL PARAMS USED
      '
      'LOCAL VARIABLES NOT USED SO ERASE THE 
      'STACK OPERATIONS LINE IN THE PROLOG
      '
      'TO MAINTAIN 16 BYTE STACK ALIGNMENT IN 64 BIT MODE (CPUW=8)
      '-----------------------------------------------------------
      '
      if cpuw=4 then
        w2=""
        '
        'THE EBP REGISTER IS NOT USED TO HOLD THE STACK POINTER
        '
        a=blcl(funi)
        b=instr(a,t,crg)
        mid(t,a)=space(b-a) 'BLANK OUT
        '
      else
        '
        w2=restorestack()
        '
      end if
      '
    end if 'LCL FUNI
    '
    '
    '
    a=lcls(funi) 'LOCAL STRINGS
    b=dts(funi)
    c=dcs(funi)
    d=a or b or c
    '
    'SAVE RETURN REGISTERS
    '---------------------
    '
    if d then
      if cpuw=4 then
        w1+=pusheax
        if typp(funi)=&h28 then
          w1+="push "+qedx+cr
        end if
      else
        w1+="push rax"+cr+"push rdx"+cr
      end if
    end if
    '
    'RELEASE LOCAL STRINGS
    '---------------------
    '
    if a then
      w1+=rtl(delloca)+cr
      lcls(funi)=0
    end if
    '
    'RELEASE TEMP STRINGS
    '--------------------
    '
    if b then
      if a>0 then w1+=rtl(deltmpa)+cr
      if cpuw=4 then
        w1+="push [ebp-8]"+cr+"call [ebx+16]"+cr
      else
        w1+="mov rcx,[rbp-16]"+cr+"call [rbx+16]"+cr
      end if
      dts(funi)=0
    end if
    '
    'RELEASE CONCATENATION BUFFER
    '----------------------------
    '
    if c then
      if cpuw=4 then
        w1+="push [ebp-12]"+cr+"call [ebx+16]"+cr
      else
        w1+="mov rcx,[rbp-24]"+cr+"call [rbx+16]"+cr
      end if
      dcs(funi)=0
    end if
    '
    'RESTORE RETURN REGISTERS
    '------------------------
    '
    if d then
      if cpuw=4 then
        if typp(funi)=&h28 then
          w1+="pop "+qedx+cr
        end if
        w1+=popeax
      else
        w1+="pop rdx"+cr+"pop rax"+cr
      end if
    end if
    '
    'RESTORE NON-VOLATILE REGISTERS
    '------------------------------
    '
    if atf(funi) then
      w2+=restoreregs()
    end if
    '
    'BYTES TO DISCARD FROM STACK WHEN RETURNING
    '------------------------------------------
    '
    a=reto(funi) : maco(mqf,1)=a 'LENGTH OF PARAMS
    b=ccp(funi)                  'CALLING CONVENTION
    w2+="ret"
    '
    'APPLIES TO STDCALL AND PASCAL ONLY
    '
    if (b=0)or(b=8) then
      if a then w2+=" "+str(a) 'but not with ellipsis (auto cdecl)
    end if
    '
    appendt(cr+".end_proc"+cr+w1+w2+ep+"._endproc"+cr)
    '
    unnest
    '
    '
    '=============
    ClearDownFuns:
    '=============
    '
    funi-=1
    ths=th(funi)
    mel=ml(funi)
    '
    goto mainloop
    '
    '
  end if 'MD=12 END
  '
  '
  '------------------------------
  'CHECK FOR START OF INNER SCOPE
  '==============================
  '
  'BLOCK 41
  'SCOPE 42
  if (md=41)or(md=42) then
    nextinstruct(s,i)
    cbrencah(s,i,md+1000)
    if ert then goto exitap
    if ascn<>lbr then inserts(s,sp,i)
    goto mainloop
  end if
  '
  '
  if md=25 then 'EXIT
    if (isn(ascn)=0)and(iss(ascn)=0) then
      wr=tword(s,i) : c=0
      '
      if instrword(" function sub method",wr)  then
        wr="proc" : c=1
      elseif instrword(" do if for ",wr) then
        c=2
      elseif instrword(" while ",wr) then
        wr="do" : c=1
      end if
      '
      if c then appendt("jmp fwd end_"+wr+cr) : goto mainloop
      '
    end if
  end if
  '
  '
  '-------------
  'METHODS OF ..
  '=============
  '
  if md=37 then
    w1=tword(s,i)
    if w1="of" then w1=tword(s,i) 'SWALLOW `OF`
    mp=lookupm(w1)
    '
    '
    if mp=0 then ers="class/type not found: "+w1 : ert=11 : goto exitap
    if maco(mp,0)<>-3 then ers="not a class/type: "+w1 : ert=11 : goto exitap
    '
    maco(mp,2)=1 'SET CLASS METHODS FLAG (internally defined methods)
    '
    if vew>0 then appendt(cr+cr+"'METHODS OF "+w1+cr)
    '
    'CAPTURE OR START SCOPE
    '
    cbrencah(s,i,md+1000) : if ert then goto exitap
    inserts(s,sp,i) 'support for static members in functions
    clss(clsi)=mp : clsi+=1 : 'REMEMBER CLASS
    '
    goto mainloop
  end if
  '
  '
  '
  '   #########
  '  ###########
  ' ## CONTROL ##
  '  ###########
  '     ##
  '     ##
  '     ##
  '     ##
  '    ####
  '   ######
  '   ######
  '  ########
  '
  '
  '------------
  'GOTO / GOSUB
  '============
  '
  if (md=35)or(md=36) then
    w1=tword(s,i)
    if isn(ascw) then w1="_"+w1 'LINE NUMBERS
    if md=35 then w2="jmp long "
    if md=36 then w2="call "
    appendt(w2+w1+cr) : goto mainloop 'GOTO 'GOSUB
  end if
  '
  n=0
  '
  '
  '=============
  select case md
  '=============
  '
  '
  '--------------
  'RETURN C STYLE
  '==============
  '
  case 38
  '
  if funi then
    '
    n=funn(funi)
    typa1=typp(funi)
    if typa1=&h40 then
      typa1=&h68 'fpu type treated as double
    end if
    '
    w2="jmp fwd end_return"
    '
    if (typa1>&h200)or(typa1<=0) then
      typa1=cpuw 'HIGHER TYPES RETURN POINTER
    end if
    '
    if isx(ascn) then
      w1=cr 'NO RETURN PARAM GIVEN
      '
    else
      '
      'THE RESULT IS LEFT IN THE ACCUM (CPU / FPU ETC)
      '
      op=0 : asg=" "
      w1=wordahead(s,i) : b=nwd
      if isx(asc(s,nwd)) then
        if cpuw=8 then
          w1=mword(w1,1)
          if asc(w1)=91 then
            if (isfloat(typ))and(typ=typa1)and(typp(funi)<>&h40) then
              i=b
              w4="movups xmm0,"+w1+cr
              if (typa1 and 31)=8 then mid(w4,6)="d" 'double
              w1=wpfx+w4
              goto pendret
            end if
          end if
        end if
      end if
      w1=expressions(s,i,typa1) 'TEMP STRINGS NOT DELETED HERE
      if cpuw=8 then
        if isfloat(typa1)and(typp(funi)<>&h40) then 
          if (typa1 and 31)=8 then
            w1+="_sp -16"+cr+"fstp qword [rsp]"+cr+"movupd xmm0,[rsp]"+cr+"_sp 16"+cr
          else
            w1+="_sp -16"+cr+"fstp dword [rsp]"+cr+"movups xmm0,[rsp]"+cr+"_sp 16"+cr
          end if
        end if
      end if
    end if
    '
    pendret:
    '=======
    '
    if ert then goto exitap
    appendt(w1+w2+cr) : goto mainloop
   '
  end if
  '
  '
  '
  '==
  'IF
  '==
  '
  case 13
  '
  n=1 : w1=sp : cnd=1
  '
  '--
  'DO
  '==
  '
  case 21
  '
  n=2 : w1=sp+"._do"
  if iss(ascn)=0 then
    if wordahead(s,i)="while" then i=nwd : n=3 : cnd=1
  end if
  nextinstruct(s,i)
  cbrencah(s,i,n) 'check for '{' ahead
  '
  '
  '-----
  'WHILE
  '=====
  '
  case 23
  '
  nextinstruct(s,i)
  if ascn=123 then
    n=2 : cbrencah(s,i,n)
  else
    n=3 : cnd=1
  end if
  w1=sp+"._do"
  '
  '
  '---
  'FOR
  '===
  '
  case 31
  '
  n=4 : cnd=2 : fro=1 : w1=""
  '
  'strip any outer brackets
  '------------------------
  '
  if ascn=lbr then
    capture(s,m,i,a)
    mid$(s,m)=" " : mid$(s,i-1)=" "
    i=m : skiplspace(s,i)
  end if
  '
  '
  '-----
  'BREAK
  '=====
  '
  case 28
  '
  if cas>1 then appendt("jmp fwd end_sel"+cr)
  goto mainloop
  '
  '
  '---------------
  'SELECT / SWITCH
  '===============
  '
  case 29
  '
  slc(slx)=cas : enu=0 : sle(slx)=enuc : slx+=1
  n=5 : op=1
  if ascn=&h63 then if wordahead(s,i)="case" then i=nwd
  w1=sp+expressions(s,i,cpuw) : typa1=typ : enuc=0
  if mc>0 then if maco(mc,0)=-2 then enuc=mc
  cas=0 : if wr="switch" then cas=2 'C STYLE SWITCH
  '
  '
  '----
  'CASE
  '====
  '
  case 30
  '
  if cas=1 then
    appendt("jmp fwd end_sel"+cr+".end_cas"+cr)
  elseif cas=3 then
    appendt("jmp fwd in_cas"+cr+".end_cas"+cr)
  end if
  '
  if wordahead(s,i)="else" then
    i=nwd : skiplspace(s,i) : cas=0 : goto mainloop 'CASE ELSE
  end if
  '
  if ascn=37 then i+=1 'ignore leading '%'
  enu=enuc : wr=pword(s,i) : if ert then goto exitap
  a=asc(wr)
  if isq(ascw) then wr=str(asc(wr,2)) : typ=cpuw 'ASCII CASE
  w1=wpfx+ins(3,typ,wr)
  w3=" fwd end_cas"+cr
  if wordahead(s,i)="to" then 
    i=nwd
    enu=enuc : wr=pword(s,i) : if ert then goto exitap
    if isq(ascw) then wr=str(asc(wr,2)) : typ=cpuw 'ASCII CASE
    w1+="jl"+w3+cr+wpfx+ins(3,typ,wr)+"jg" 'CASE X TO Y
  else
    w1+="jnz" 'CASE X
  end if
  '
  w1+=w3
  if cas=3 then w1+=".in_cas"+cr
  cas or=1 : enu=0
  goto xcnd
  '
  '
  '
  '--------
  'CONTINUE
  '========
  '
  case 26
  '
  b=iss(ascn)
  if b then
    w1="repeat"
  else
    w1=tword(s,i)
    if w1="while" then w1="do"
    w1="jmp long _"+w1
  end if
  n=-1
  '
  '=============
  end select 'md
  '=============
  '
  '
  '
  '
  '===========
  allcontrols:
  '===========
  '
  if n then
    if len(w1) then appendt(w1+cr)
    if n>0 then 
      if nsl>=99 then ert=300 : ers="too many block nestings "+wr : goto exitap
      ctb(nsl)=n : nsl+=1
    end if
    '
    if cnd=0 then goto mainloop
    '
    if cnd=1 then
      '
      if ctb(nsl-1)=1 then
        w3=" fwd end_con"
      else
        w3=" fwd end_do"
      end if
      '
      w4=""
      '
      '========
      jumpcond: 'w3 jump to 'set cnd sense
      '========
      '
      w1=wordahead(s,i)
      if ascn=&h6e then
        if w1="not" then i=nwd : w1=wordahead(s,i) : cnd=-cnd
      end if
      '
      a=ascl(s,nwd)
      '
      if a=58 then
        if asc(s,nwd+1)<>61 then
          goto onewordcon
        end if
      elseif (isx(a)<>0)or(a=123) then
        goto onewordcon
      elseif a=&h74 then
        b=nwd : if wordahead(s,b)="then" goto onewordcon
      end if 'single word conditional
      '
      op=0 : parx=1 : w1=expressions(s,i,typa1)
      if typg<&h40 then
        a=typg and 31
        if a<cpuw then w1+=cvta(typg,cpuw) 'returning shorts bytes etc
      end if
      '
      'ACTION FOLLOWING CONDITIONAL
      '----------------------------
      '
      '
      '
      if abs(cnd)=1 then
        '
        if cnd<0 then
          w2="jnz"
        else
          w2="jz"
        end if
        '
        if dts(funi)>0 then
          w1+=rtl(deltmpa)+cr 'this must go here before conditional branching
          dts(funi)=-1
        end if
        w1+="or "+qeax+cm+qeax+cr+"._cnd"+cr+w2+w3+cr 'SKIP IF TRUE / IF FALSE
      else
        w1+=w3+cr 'SIMPLIFIED BY USING DIRECT COMPARISON < > <= >= <> =
      end if
      '
      w1+=w4
      '
      if (ascn=sr1)or(ascn=sr2) then i+=1 : skiplspace(s,i) 'statement speparators
      goto xcnd
      '
    end if 'cnd<>0
    '
    '----------
    if fro then
    '----------
    '
    ' ####   ####   #####
    ' #     #    #  #    #
    ' ####  #    #  #####
    ' #     #    #  #    #
    ' #      ####   #    #
    '
    wr=pword(s,i)
    w3=wpfx
    '
    if mp=0 then
      'create it as sys variable
      varsal("sys "+wr,1,0) : if ert then goto exitap
      wr=macso(me-1,1)
    end if
    '
    typa1=typ
    '
    'SKIP EQUALS SIGN
    '
    skiplspace(s,i)
    '
    if ascn=61 then
      i+=1
    else
      ers="Missing '='" : ert=502 : goto exitap
    end if
    '
    'SET INITIAL VALUE OF ITERATOR
    w2=ow
    op=0
    d=0
    w1=expressions(s,i,typa1)+w3+ins(2,typa1,wr)
    if ert then goto exitap
    '
    ow=w2
    '
    w6=ow
    nest()
    w1+=sp+"._for"+cr ' start of loop
    '
    'SET LIMIT VALUE FOR ITERATOR
    '
    w5=tword(s,i) 'TO' or ';'
    e=ascw
    if w5="to" then
      e=44
    elseif ascw=58 then
    elseif ascw=59 then
   else
      ers="missing 'to' or ';' " : ert=503 : goto exitap
    end if
    '
    w3=wordahead(s,i)
    if instr("<>=",w3) then
      inserts(s,w6,i) : d=1
    elseif instr("<>=",chr(asc(s,nwd))) then
      d=1
    else
      e=44 'implicit 'to'
    end if
    '
    op=0 : w1+=expressions(s,i,typa1) : if ert then goto exitap
    '
    'PRESUME INCREMENT
    '
    b=0 : c=0 : cnd=0
    '
    'CHECK FOR STEP (BASIC)
    '
    if (iss(ascn)=0)and(ascn<>123) then
      '
      'TO' MODE
      '
      if e=44 then
        if ascn=44 then i+=1 : skiplspace(s,i) 'comma instead of STEP
        if ascn=45 then b=1
        w2=w6+"+="+tword(s,i)
        if b=1 then w2+=tword(s,i)
        'assume descending 'itr neg vars
        c=1
      end if 
      '
    end if
    '
    w4="jz  fwd end_for"+cr 'DEFAULT EXIT IF FALSE
    '
    if e=44 then
      '
      'INC/DEC
      '
      if c=0 then w2=w6+"++" 'DEFAULT INCREMENT
      '
      if d=0 then
        w1+=ins(3,typa1,wr) 'COMPARE
        if typa1>&h40 then w1+="fstp st0"+cr 'FPU POP & DICARD
        '
        if b=0 then
          w3="jl" 'ASCENDING SIGNED CPU INT (DEFAULT)
          if typa1>=&h20 then w3="jb" 'ASCENDING UNSIGNED CPU/FPU
        else 'b=1
          if typa1< &h20 then w3="jg" 'DESCENDING SIGNED CPU INT
          if typa1>=&h20 then w3="ja" 'DESCENDING UNSIGNED CPU/FPU
        end if
        mid(w4,1)=w3
      end if
      '
    else ':' c style
      '
      if (ascn=58)or(ascn=59) then
        i+=1 : b=i : endline(s,i)
        w2=mid(s,b,i-b)
      else
        w2=w6+"++"
      end if
      '
      d=1
      '
    end if 'to' or ':'
    '
    if d then w1+="or "+qeax+cm+qeax+cr
    w1+=w4 'MAIN CODE
    nxs(nx)=w2 : nx+=1 'STEPPER
    '
    'CHECK AHEAD FOR {
    '
    a=cbrencah(s,i,4)
    '
    'DONE FOR
    '
    fro=0
    goto cleardown
    '
    '----------------------------------
    end if 'FRO: FOR TO NEXT STATEMENTS
    '----------------------------------
    '
    '
    '====================================
    onewordcon: 'single word conditionals
    '====================================
    '
    'if c then ...
    'while c ...
    '
    '
    '
    wr=pword(s,i)
    '
    if ascn=&h74 then
      w1=wordahead(s,i)
      if w1="then" then
        i=nwd
      end if
    end if
    '
    w1=""
    '
    'check for function
    '
    if varf>=8 then
      '
      'functions
      '=========
      '
      b=1 : w1=expressions(ow,b,cpuw)
      if ert then goto exitap
      wr=qeax : psg=""
      '
    else 'not a function
      '
      'check for numeric literal
      '
      if wval(wr)<>0 then
        if cnd<0 then cnd=0 else goto xcnd
      elseif asc(wr)<=48 then
        if cnd<0 then goto xcnd else cnd=0
      end if
      '
    end if
    '
    if cnd then
      w1+=wpfx+ins(&h20,typ,wr)      
      if cnd<0 then w2="jnz" else w2="jz"
    else
      w2="jmp"
    end if
    '
    w1+=w2+w3+cr+w4
    '
    skiplspace(s,i)
    '
    '====
    xcnd:
    '====
    '
    '
    '------------------------------------
    'DETECT IMPLICIT ENDIF AT END OF LINE
    '====================================
    '
    if nsl then
      c=ctb(nsl-1)
      fixrobr(s,i)
      if cbrencah(s,i,c)=0 then
        if c=1 then
          if iss(ascn)=0 then
            m=i : endline(s,i)
            inserts(s,mid(s,m,i-m)+cr+"endif",i) 'INSERT ENDIF AT END OF LINE
          end if
        end if
      end if
    end if
    '
    cnd=0
    '
    goto cleardown
    '
    '
    '
  end if 'all controls



  '
  '=============================
  endcons: 'ENDDO ENDWHILE 'WEND
  '=============================
  '
  n=0 : cnd=0
  '
  'do {...} while ...
  '
  if md=18 then
    b=i
    skipspace(s,i) 'must be continuity (no basic comments etc)
    if (ascw=125)and(wordahead(s,i)="while") then
      i=nwd : skiplspace(s,i)
      w3=" long _do"
      w4=".end_do"+ep
      cnd=-1
      goto jumpcond
    else
      i=b : skiplspace(s,i)
    end if
  end if
  '
  '
  '
  if (md=18)or(md=19)or(md=24) then
    n=2 : w1="jmp long _do"+cr+".end_do"+ep
    if (md=19)or(md=24) then n=3
  end if
  '
  '
  '----
  'NEXT
  '====
  '
  if md=34 then
    n=4 : nx-=1
    if nx<0 then ert=10 : ers="Too many nexts" : goto exitap
    if ascw<>125 then
      if iss(ascn)=0 then w2=tword(s,i) ' swallow iterator name
    end if
    w1=nxs(nx)+cr+"jmp long _for"+cr+".end_for"+ep
    inserts(s,w1,i) : w1=""
  end if
  '
  '
  '--------------------------------
  'ENDSEL / END SELECT / END SWITCH
  '================================
  '
  if md=20 then
    n=5 : slx-=1
    if slx<0 then ert=11 : ers="Too many end selects" : goto exitap
    w1=".end_cas"+cr+".in_cas"+cr+".end_sel"+ep
    enuc=sle(slx) : cas=slc(slx)
  end if
  '
  '
  '----
  'ELSE
  '====
  '
  if md=15 then
    if ise(ascn)=0 then
      w1=wordahead(s,i)
      if w1="if" then
        md=16 : i=nwd : skiplspace(s,i) : goto else_if
      end if
    end if
    '
    b=i : nextinstruct(s,b)
    fixrobr(s,i)
    '
    if ascn=123 then
      cbrk(cbri)=1 : cbri+=1 : i=b+1
    else
      skiplspace(s,i)
    end if
    '
    if mid(t,j-2,2)<>cr then appendt(cr)
    appendt("jmp fwd end_if"+cr+".end_con"+cr )
    goto mainloop
  end if
  '
  '
  '===============
  else_if: 'ELSEIF
  '===============
  '
  if md=16 then
    appendt("jmp fwd end_if"+cr+".end_con"+cr )
    cnd=1 : n=-1 : w1="" : goto allcontrols 'treat as 'if'
  end if
  '
  '
  '------
  'END IF
  '======
  '
  if md=17  then
    n=1  : w1=".end_con"+cr+".end_if"+ep
  end if
  '
  '
  '===================
  'ALL CONTROL ENDINGS
  '===================
  '
  if n then
    if len(w1) then appendt(w1)
    '
    if nsl<1 then
      ert=300 : ers="nesting error " : w1=" (no beginning)" : m=n
    else
      nsl-=1 : m=ctb(nsl)
      if m=n then goto mainloop
      ert=301 : w1=" expected"
    end if
    '
    if m=1 then
      ers+="`end if`"
    elseif m=2 then
      ers+="`end do` "
    elseif m=3 then
      ers+="`end while` or `wend` "
    elseif m=4 then
      ers+="`next`"
    elseif m=5 then
      ers+="`end select`"
    end if
    ers+=w1+cr : goto exitap
  end if
  '
  '
  '==============
  'O2H DIRECTIVES
  '==============
  '
  select case md
  '
  case 44 : ixb=wval(mword(s,i))      : goto mainloop      'INDEXBASE '#INDEXBASE
  case 45 : libr=noquotes(tword(s,i)) : goto mainloop      'LIBRARY
  case 53 : nprec=1                   : goto mainloop      '#NOPREC
  case 54 : noin(funi)=1              : goto mainloop      '#NOINIT FLAG FOR LOCAL VARS
  case 55 : bref=0                    : goto mainloop      '#BYVAL by default
  case 56 : bref=1                    : goto mainloop      '#BYREF by default
  case 57 : readstates(tword(s,i))    : goto mainloop      'READSTATE
  case 59 : typo=17                   : goto declarations2 'DEFF
  '
  case 48  'EXTERN
  '
  atx=1
  if cpuw=4 then ccx=0 else ccx=2 'ms64
  do
    w1=wordahead(s,i)
    a=dic(callco,w1)
    if a then
      i=nwd : ccx=a-&h100 : continue do 'SET DEFAULT CALLING CONVENTION
    elseif w1="lib" then
      i=nwd : libr=noquotes(tword(s,i)) : continue do 'SET DEFAULT LIBRARY
    elseif w1="export" then
      i=nwd : etx=1 : continue do 'SET PROCEDURES / CLASSES FOR EXPORT
    elseif instrword(" virtual com ",w1) then
      i=nwd : atx=3 : continue do 'SET CLASSES / PROCEDURES AS VIRTUAL (AND EXTERNAL)
    end if
    exit do
  loop
  goto mainloop
  '
  case 58  'WRITESTATE
  '
  w1=writestates(me-wval(mword(s,i)),me)+cr
  appendt(w1)
  goto mainloop
  '
  end select
  '
  '
  '=======
  end_o2h:
  '=======
  '
  '
  if mc<>-13 then nl=0 : goto addsrc
  '
  '
  '
  '#######################
  '
  '#######################
  '
  '     #####    ##### 
  '    #     #  #     #
  '    #     #        #
  '    #     #   ##### 
  '    #     #  #
  '    #     #  # 
  '     #####   #####O2
  '
  '######################
  '
  '#######################
  '
  '
  '==========
  oxygenword:
  '==========
  '
  '
  a=ascw
  '
  if mc=-13 then md=maco(mp,5) else md=0
  '
  '
  if md=1 then incli=1 : continue do 'INCL
  '
  '--------
  'INDEXERS
  '========
  '
  if md=3 then
    if nl=1 then
      '
      'AS FIRST WORD IN STATEMENT
      '--------------------------
      '
      b=swd
      '
      if lclv then aoffl=aoff else aoffs=aoff ' retain when switching
      '
      wd=noquotes(tword(s,i))
      '
      if wd="retn" then
        reto(funi)=aoff-retb : maco(mqf,1)=reto(funi) ' PARAMS NBYTES
      elseif wd="local"  then
        regs=regsl : aoff=aoffl : lclv=1 : asce=ascel
      elseif wd="static" then
        regs=regss : aoff=aoffs : lclv=0 : asce=asces
      else
        if (wd="ebp")or(wd="rbp") then 'ALWAYS REGISTER FOR LOCAL ADDRESSING
          lclv=1 : 'regsl=wd
        else
          lclv=0 : regss=wd 
        end if
        regs=wd
      end if
      '
    else
      '
      'NOT AS FIRST WORD
      '
      inserts(s,regs+" ",i)
    end if
    continue do
  end if
  '
  '
  '
  '------
  'OFFSET
  '======
  '
  if md=5 then
    if nl=1 then
      '
      'AS FIRST WORD IN STATEMENT
      '
      b=swd
      wordval(s,i,i) : aoff=dv
      if iss(ascn)=0 then
        wr=tword(s,i) : asce=0
        if wr="ascending" then retb=aoff : asce=1 '''
        if wr="descending" then asce=-1 '''
      end if
      if asce=0 then ers="offset n ascending or descending? "+wr : ert=14 : goto exitap
      if lclv then
        aoffl=aoff : ascel=asce
      else
        aoffs=aoff : asces=asce
      end if
      '
    else
      '
      'NOT AS FIRST WORD
      '
      inserts(s,str(aoff)+" ",i)
    end if
    continue do
  end if
  '
  '
  '----
  'RETN
  '====
  '
  if md=4 then
    if reto(funi) then w1="ret "+str(reto(funi)) else w1="ret"
    appendt(w1+cr) : goto mainloop
  end if
  '
  '
  '========================
  nl=0 ' clear newline flag
  '========================
  '
  '
  '----
  'SKIP
  '====
  '
  if md=6 then
    '
    ' wont be passed to assembler single line or multi line (...)
    '
    capturi(s,m,b,i) : if ert then goto exitap
    skiplspace(s,i) : goto mainloop
  end if
  '
  '
  '----
  'WITH
  '====
  '
  if md=7 then 'WITH
    if isx(ascn) then wth="" else wth=noquotes(tword(s,i))
    wi=len(wth)
    goto mainloop
  end if
  '
  '
  '
  '---------
  'DATASPACE
  '=========
  '
  if md=8 then
    ws=wr+" "+tword(s,i)+cr+asg : asg=""
    appendt(ws) : goto mainloop
  end if
  '
  '
  '----
  'DATA
  '====
  '
  if md=9 then
    ws=captureblock(s,i,wr)
    w1=stodata(ws)+cr
    appendt(w1) : goto mainloop
  end if
  '
  '--------------
  'O2 inline code
  '==============
  '
  if md=10 then
    ws=wr+sp+captureblock(s,i,wr)+ep+asg : asg=""
    appendt(ws) : goto mainloop
  end if
  '
  '
  '
  '----
  'BIND
  '====
  '
  if md=12 then
    wr=mword(s,i)
    if asc(s,i)=44 then i+=1 : skiplspace(s,i) ' swallow comma
    wd=captureblock(s,i,"bind") : nocomments(wd)
    procaddrc(wd,wr)
    bg=j : goto mainloop ' preprocessor loop
  end if ' bind
  '
  '
  '
  '     #####          ######          ######          ######          ######          ######         
  '    ########       #########       #########       #########       #########       #########      
  '   ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
  '   ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
  '  ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
  '  ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
  '  ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
  '  ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
  '   ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
  '   ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
  '   ##      ##########      ##########      ##########      ##########      ##########      ##
  '   #         ######          ######          ######          ######          ######    #### 
  '
  '
  '
  '============
  'DECLARATIONS
  '============
  '
  '
  '
  if md=14 then 'DEFS (bit) aa (n) bb cc
    '
    '
    '-----------------
    defs: 'ENUMERATION
    '=================
    '
    a=swd : i=swd : enums(s,i) : if ert then goto exitap
    goto mainloop
    '
  end if
  '
  '
  if md=17 then 'VAR
    '
    '
    '------
    vardef:
    '======
    '
    varsal(s,i,noin(funi)) : if ert then goto exitap else goto mainloop       
    '
  end if
  '
  '
  '
  '
  '   ######################
  '    MACROS AND STRUCTURES
  '    ######################
  '    ###                  ##
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ##
  '    ######################
  '   ## DEF  ##  TYPE  ## 
  '  ######################
  '
  '
  '
  select case md
  case 11 : typo=2  : un=8  'STRUCT C STYLE
  case 13 : typo=2  : un=16 'CLASS
  case 15 : typo=1          'DEF #DEF
  case 16 : typo=2          'TYPE
  case 21 : pakd=1  : nl=1 : continue do 'packed
  case 22 : typo=19 :       '_DEF (terminator def)
  case 37 : typo=2          'TYPEDEF
  case 38 : typo=2  : un=1  'UNION
  case else
    goto ntypo
  end select
  '
  '=============
  declarations2:
  '=============  
  '
  '
  '  macs 0 name
  '  macs 1 prepared macro / resolved structure for types
  '  macs 2 offset and array spec for vars / array spec for typedefs
  '  macs 3 vf table building code
  '  maco 0 structure flag -3  ( -1 def -2 defs/enum -3 type)
  '  maco 1 length
  '  maco 2 var offset / vtp spec for types
  '  maco 3 number of params in macro (metatype -1)
  '  maco 4 size of associated class vf table / var to be used in signature (1)
  '  maco 5 type code for vars
  '  maco 6 reference tally
  '
  if typo then
    '
    m=swd
    '
    w1=ow 'use the original word as the name `TYPEDEF` etc
    '
    wr=tword(s,i) ' `UNION` `STRUCT` `ENUM` etc
    '
    '-------
    'TYPEDEF
    '=======
    '
    if md=37 then
      '
      '
      'STRUCT?
      '-------
      '
      a=dic(" union 1, struct 8,",wr)
      if a then
        un or=8 'FLAGS
        tdst=1 : nextinstruct(s,i)
        indt=0
        if ascn=123 then
          wr="anon" 'ANON STRUCTURE
        else
          wr=mword(s,i) ' NAMED STRUCTURE
        end if
        nextinstruct(s,i)
        if ascn<>123 then
          inserts(s,"{}",i) 'UNDEFINED STRUCTURE
          ascn=123
        end if
        goto isdefi
      end if 'union/struct
      '
      '
      if wr="enum" then
        i=swd : enums(s,i)
        if ert then goto exitap
        b=me-1 : wn=macso(b,0)
        b+=512
        goto rtypedef
      end if
      '
      'TYPEDEFS
      '--------
      '
      'STRUCT ALREADY DEFINED?
      '
      i=swd : wr=mword(s,i)
      '
      'CHECK WHETHER DEFINING A POINTERED FUNCTION
      '-------------------------------------------
      '
      'THE TYPE COULD BE ANOTHER TYPEDEF TYPE OR A 'C' TYPE
      '
      if (ascn=42)or(ascn=lbr) then
        if (mc=-8)or(mc=-15) then
          a=i
          if ascn=42 then i+=1 : skiplspace(s,i)
          if ascn=lbr then
            macoin me       'NAME LOCATED LATER
            maco(me,0)=-8   'SIGNAL INDIRECT TYPE
            maco(me,1)=cpuw 'LENGTH OF POINTER
            maco(me,3)=0    'INDIRECTION
            maco(me,4)=me+1 'INDEX FUNCTION TO BE DECLARED
            addme
            if ert then goto exitap
            deco=1 : a=1 : goto fundec 'PROCEDURE AS FOR FUNCTION DECLARATION
          else
            i=a 'IT WAS NOT A TYPEDEF PROC AFER ALL SO REVERT TO PRIOR POSITION
          end if
        end if
      end if
      '
      b=identype(wr)

      '
      if b=0 then
        ers="unknown type" : ert=69 : goto exitap
      end if
      '
      wn=wr
      goto rtypedef
      '
    end if
    '
    '-----------------------------------------------------------
    isdefi:  'COMING FROM:  typedef struct or equates % $ 
    '===========================================================
    '
    '#define and macro() are now handled in o2met.bas
    '
    '
    macoin me
    if ert then goto exitap
    set_macro_name(wr)
    lbw=wr
    w5=""
    '
    'CAPTURE NEXT LINE NUMBER FOR POSSIBLE CLASS METHODS BLOCK
    '
    if md=13 then
      b=i : endline(s,b)
      b=instr(b+2,s,chr(39)+chr(lnm))
      if b then
        c=b : endline(s,c) : w5=mid(s,b,c-b+2)
      end if
    end if
    '
    a=o2h : o2h=0
    wr=captureblock(s,i,w1)
    o2h=a 'set o2h 0 prevents suffix stripping
    '
    '=====
    'CLASS
    '=====
    '
    '
    'CHECK FOR EMBEDDED ITEMS IN CLASS
    '=================================
    '
    '
    if md=13 then
      '
      vtp=atx : f=etx
      '
      w3="" : w1=macso(me,0) : w4=w1 : c=0 : d=0 : e=0 : b=1 : nwd=b : a=1
      '
      if vtp then if len(libr) then w3=" lib "+"`"+libr+"`" : c=atx
      '
      '
      do
        w2=wordahead(wr,nwd)
        '
        if w2="," then continue do 'ALLOW COMMA SEPARATORS
        '
        'THE OBJECTS IN THIS CLASS WILL CONTAIN A VIRTUAL TABLE POINTER
        '
        if instrword(" extern external ",w2) then a=nwd : vtp or=1 : continue do
        if instrword(" com virtual ",w2) then a=nwd : vtp or=2 : c=vtp : continue do
        '
        'CASE-SENSITIVE NAME OF IMPORTED/EXPORTED CLASS
        '
        if w2="alias" then w4=noquotes(wordahead(wr,nwd)) : a=nwd :  : continue do
        '
        '
        'THE CLASS IS TO BE IMPORTED FROM A DLL
        '
        if w2="lib" then w3=" lib `"+wordahead(wr,nwd)+"`" : b=nwd : c=1 : continue do
        '
        'THE CLASS IS TO BE EXPORTED AS PART OF A CLASS LIBRARY
        '
        if w2="export" then f=1 : b=nwd : continue do
        exit do
      loop
      '
      '
      'BLANK OUT PROCESSED PARAMS AND GET REST OF CLASS
      '
      if b>a then a=b
      '
      if a>1 then
        mid(wr,1)=space(a-1)
        if a>len(wr) then wr=captureblock(s,i,"class")
      end if
      '
      'EXTERNALITY WAS WAS DETECTED
      '
      '
      'SENDING CLASS LIBRARY TABLE
      '---------------------------
      '
      if f then
        vtp or=1
        w3="sub _setup_"+w1+"(sys p) export"+cr+_
        "copyn p, @"+w1+"_table, "+str(cpuw)+"*spanof ("+w1+"_table"+cr+_
        "end sub"+cr
        inserts(s,w3,i)
        '
        'THEN PROCESS AS NORMAL CLASS
        '
      end if
      '
      if vtp then
        maco(me,2)=vtp '1 client virtual table 3 server virtual table
        if vtp and 2 then
          'c is 3
          goto mclass 'VIRTUAL CLASS WITH NO CLIENT-SIDE VFT
        end if
      end if
      '
      '
      'RECEIVING CLASS LIBRARY TABLE
      '-----------------------------
      '
      'a library was specified for the class
      '
      if c=1 then
        w3="declare sub _setup_"+w1+w3+"(sys p)"+cr+"_setup_"+w1+" @"+w1+"_table"+cr
       inserts(s,w3,i) : vtlcheckmark(wr) : goto mclass 'NOT LOOKING FOR METHODS HERE
      end if
      '
      '
      makeheaders(wr,w4,w3,2) 'mode 2 for class headers
      '
      '
      'COMPOSE VIRTUAL SECTION AND MAIN BODY
      '
      if len(w4) then
        wr=w4+cr+"/\"+cr+wr
      else
        vtlcheckmark(wr)
      end if
      '
      if len(w3)+len(w4) then
        '
        'COMPOSE METHODS BLOCK AND INSERT BACK INTO SOURCE STREAM
        'the methods block is needed even if it is empty
        '
        '
        w1=macso(me,0)
        '
        w3=cr+"methods "+w1+cr+w5+w3+cr+"end methods"+cr+cr
        'itr functions have access to static members only /callback functions
        inserts(s,w3,i)
      end if
      '
      mclass:
      '
      if vtp then if instr(wr,"/\")=0 then wr+="/\"+cr

    end if
    '
    '------
    nclass:
    '------
    '
    nocomments(wr)
    macsi(wr,me,1)
    '
    if (typo=1)or(typo=17)or(typo=19) then
      maco(me,0)=-typo
      addme : if ert then goto exitap
      goto mainloop
    end if
    '
    if typo<>2 then goto ntypo
    '
    types(un) 'RESOLVE TYPE STRUCTURE
    pakd=0
    '
    if ert then goto exitap
    '
    'TYPEDEF STRUCTS (-8)
    '--------------------
    '
    skiplspace(s,i)
    if isx(ascn)=0 then
      '
      b=me-1
      lent=maco(b,1)
      wn=macso(me-1,0)
      b+=512
      indt=0
      if tdst=0 then
        '
        goto typesdone
        '
      end if
      '
      'NAME OF TYPE
      '
      '----------------------------
      rtypedef: 'LOOP FOR EACH TYPE
      '============================
      '
      c=indt 'b carries index to the type
      '
      '
      do
        wr=tword(s,i)
        '
        'IGNORE SELF-DEFINITION (sometimes due to case insensitivity: typedef long LONG)
        '
        if wr=wn then
          if ascn=44 then i+=1 : continue do
          goto typesdone
        end if
        '
        'INDIRECT TYPES
        '
        if ascw=42 then c+=1 : continue do
        exit do
      loop
      '
      'ARRAY TYPES
      'FUNCTION POINTERS
      '
      w2=""
      '
      do
        if (ascn=lbr)or(ascn=91) then
          capture(s,m,i,a) : w2+=mid(s,m,i-m)
          skiplspace(s,i) : continue do
        end if
        exit do
      loop
      '
      macsi(w2,me,2)
      '
      if ascn=95 then
        w1=wordahead(s,i)
        '
        'ATTRIBUTE STUB
        '
        'itr macros
        '
        if w1="__attribute__" then
          i=nwd : capture(s,m,i,a) : skiplspace(s,i)
        end if
      end if
      '
      '
      macoin me : set_macro_name(wr)
      '
     '--------------------------------------------------
      maco(me,0)=-8           'SIGNAL INDIRECT TYPE
      maco(me,1)=lent         '
      maco(me,3)=c            'INDIRECTION
      maco(me,4)=b            'UDT or PRIMITIVE / POINTER
      '--------------------------------------------------
      '
      addme : if ert then goto exitap
      '
      if ascn=44 then i+=1 : goto rtypedef
      '
      'itr semicolons: treat as linebreaks
      'itr #define on next line requiring contin
      '
    end if
    '
    '
    '=========
    typesdone:
    '=========
    '
    'RESUME MAIN PREP LOOP
    '
    tdst=0 : un=0
    '
    '
    'INSERT STRAY #DEFINES
    '---------------------
    '
    if len(defbuf) then
      inserts(s,defbuf,i) : defbuf=""
    end if
    '
    goto mainloop
    '
  end if ' end defs
  '
  '=====
  ntypo:
  '=====
  '
  '
  '  #################
  '  # INCLUDE FILES #
  '  #################
  '  ###
  '  ###
  '  ###
  '  ##############
  '  ##############
  '  ###
  '  ###
  '  ###
  '  ###
  '  ###
  '  ####
  '
  '-----------------
  'INCLUDE '#INCLUDE
  '=================
  '
  '
  if md=18 then
    '
    '
    'CHECK FOR FILES ALREADY INCLUDED
    '--------------------------------
    '
    '
    a=0 : c=0
    do
      wd=noquotec(wword(s,i))
      if wd="once" then a=1 else exit do
    loop
    w1=filename(wd)
    if a then
      b=0
      do
        if b>=fql then exit do
        if w1=ssn(b) then c=1 : d=ssh(b) : exit do
        b+=1
      loop
    end if
    '
    ssn(fql)=w1 'NAME LOG (WITH HASH)
    '
    if len(wd)>0 then
      if fq>63   then ers="Too many nested 'include' files "+wd : ert=40 : goto exitap
      if fql>999 then ers="Too many 'include' files "+wd : ert=40 : goto exitap
      '
      'RESOLVE FILE PATH
      '-----------------
      '
      '
      if len(ipath) then
        wd=ipath+wd
      end if
      '
      #IFDEF HOSTED
      '
      inclpath(wd)
      '
      #ENDIF
      '
      '
      ssf(fq)=wd 'REMEMBER NAME
      '
      'SAVE REMAINING PARENTAL
      '-----------------------
      '
      sst(fq)=mid(s,i) 
      i=1 : bgl=1
      '
      'GET THE INCLUDE
      '---------------
      '
      dim as any ptr ps,pw        
      ps=varptr(s)
      pw=strptr(wd)
      asm
        push [pw]
        call getfiles
        push [ps]
        push eax
        call bstr_to_fstr
      end asm
      '
      '
      'CHECK FOR EMPTY OR NON-EXISTENT FILE
      '------------------------------------
      '
      if s="" then
        ers="Problem with file: "+wd : ert=40
        goto exitap
      end if
      '
      'CHECK IF PRIOR FILE SEEMS IDENTICAL
      '-----------------------------------
      '
      e=hashid(s)
      '
      if c then
        if d=e then
          s=sst(fq) : continue do 'ALREADY SEEN SO REVERT TO PARENT
        end if
      end if
      '
      ssh(fql)=e : stb(fq)=s : fq+=1 : fql+=1
      '
      if linemarkers then linemark(s) 'tag each line with line number
    end if
    '
    appendt("'_"+wd+cr) 'EMBED FILENAME FOR ASSEMBLER
    goto mainloop
      '
  end if
  '
  '
  '==================
  'OTHER o2 KEYWORDS:
  '==================
  '
  '
  '#SEMICOLON
  '
  if md=2 then
    w1=""
    if ise(ascn)=0 then w1=tword(s,i)
    if w1="comment" then sr2=58 : ct2=59 else sr2=59 : ct2=39
    goto mainloop
  end if
  '
  a=0
  if md=19 then o2h=0 : bref=0 : a=1 '#ASM 'ASM
  if md=20 then o2h=1 : bref=1 : a=1 '#O2H 'O2H '#BASIC 'BASIC
  '
  if a then
    goto mainloop
  end if
  '
  '
  'INCLUDEPATH
  '
  if md=30 then
    paths(s,i,ipath)
     goto mainloop
  end if
  '
  '
  'LIBRARYPATH
  '
  if md=31 then
    paths(s,i,lpath)
    goto mainloop
  end if
  '
  '
  if md=42 then leaf=1                : goto mainloop 'LEAF
  '
  '
  'O2PATH
  '
  if md=32 then
    hostdll=noquotes(mword(s,i))
    goto mainloop
  end if
  '
  '
  '#ALERT
  '#ERROR
  '
  if (md=46)or(md=47) then
    ers=captureblock(s,i,wr) : ert=md-45 : ow=""
    goto exitap
  end if
  '
  '#LOOKAHEAD
  '
  if md=43 then
    MakeHeaders(mid(s,i),w1,"",1)
    inserts(s,w1,i)
    if ert then goto exitap
    goto mainloop
  end if
  '
  '
  '#AUTODIM
  '-------
  '
  if md=44 then 
    yesno(s,i,relaxed) : goto mainloop
  end if
  '
  '
  '#UNIQUE
  '-------
  '
  if md=49 then 
    yesno(s,i,uniq) : goto mainloop
  end if
  '
  '
  '#CONSOLE
  '-------
  '
  if md=50 then 
    cnsl=1 : goto mainloop
  end if
  '
  '
  'REM
  '#PRAGMA
  '-------
  '
  if (md=25)or(md=48) then
    endline(s,i) : appendt(cr)
    goto mainloop
  end if
  '
  '#CASE
  '-----
  '
  if md=41 then
    if isx(ascn)=0 then
      wr=lcase(tword(s,i))
      casf=dic(" insensitive 1, sensitive 2, capital 3, capitalsensitive 3, ",wr)
    end if
    goto mainloop
  end if
  '
  '
  '#FILE
  '-----
  '
  if md=35 then
    if isx(ascn)=0 then
      pexn=noquotes(mword(s,i))
      w1=lcase(right(pexn,3))
      pef=dic(" dll 1, exe 2, ",w1)
      if pef=0 then
        ert=5 : ers="#file requires name.exe or name.dll " : goto exitap
      end if
      '
      do
        if isx(ascn) then exit do
        w1=tword(s,i)
        if w1="independent" then independent=1 : continue do
        cpus(w1)
        if cpuw=4 then ccx=0 else ccx=2 'ms64
      loop
    end if
    goto mainloop
  end if
  '
  '
  '
  '------------------------
  'COMPILE TIME DIAGNOSTICS
  '========================
  '
  if md>200 then
    a=swd
    if ise(ascn)=0 then w1=tword(s,i) 'no macro expansion
    endline(s,i) : w2=mid(s,a,i-a) : striplineno(w2)
    w3=""
    select case md
    case 201
      w3=" "+str(brc) '#BLOCKDEPTH
    case 202
      a=lookupm(w1)
      if a then
        w3=cr+noquotes(writestates(a,a))
      else
        w3=" Not found" '#RECORDOF
      end if
    end select
    if len(w3) then qq w3,md
    goto mainloop
  end if
  '
  '
  '-------------------------
  'META COMMANDS: #IFDEF ETC
  '=========================
  '
  if md>=100 then
    metaco(s,i)
    if ert then goto exitap
    goto mainloop
  end if
  '
  '
  '
  '########################

  'ADD ANY UNPROCESSED CODE
  'CHECK FOR OTHER STREAMS

  '########################
  '
  '
  '======
  addsrc:
  '======
  '
  'PASS THRU UNPROCESSED WORDS
  '---------------------------
  '
  'INCLUDE SINGLE CR/LF (NOT MULTIPLE CR)
  '
  a=asc(s,i)
  select case a
  case 10 : w1=cr  : i+=1
  case 13 : w1=cr  : i+=2
  case 44 : w1="," : i+=1
  case else
    w1=" "
  end select
  wsg=wr
  appendt(wsg+w1) ' given spacing, line breaks etc
  '
  nl=0
  '
  'END-OF-LINE CHECKS
  '------------------
  '
  if a<=13 then
    '
    'ANY REMAINING ASSIGNMENT CODE
    '-----------------------------
    '
    if len(asg) then mid(t,j)=asg : j+=len(asg) : asg="" : a=13
    '
    if a=0 then
      '
      'END OF CURRENT SOURCE STREAM
      '----------------------------
      '
      '
      '------------------------------------
      'INSERT NEXT INCLUDED CONTENT, IF ANY
      '------------------------------------
      '
      if fq then
        fq-=1 ' resume previous source string
        i=1 : s=sst(fq) : skiplspace(s,i)
        if fq then wd=ssf(fq-1) else wd="main source"
        appendt("'_"+wd+cr) 'EMBED CURRENT FILENAME FOR ASSEMBLER
        goto mainloop
      end if
      '
      '
      'CHECK FOR REMAINING CODE
      '------------------------        '
      '
      'default termination coding
      '
      if (tmnt=0)and(o2h=1)and(dep=0) then
        if pef=1 then
          wva(19)+=cr+"sub finish() external : terminate : end sub"+cr 'WHEN DLL IS UNLOADED
        else
          wva(19)+=cr+"terminate"+cr 'FOR NON-PERSISTENT PROGS
        end if
        tmnt=1
      end if
      '
      if epi=0 then
        a=lookupm("_epilog")
        if a then wva(19)+=macso(a,1)
        epi=1
      end if
      '
      s=wva(19) : if len(s) then wva(19)="" : i=1 : goto mainloop
      '
      'EXHAUSTED ALL INPUT STREAMS
      '---------------------------
      '
      exit do ' no proc mapping
      '
    end if
    '
    goto mainloop
    '
  end if
  '
  '==========================
  loop 'FOR ANOTHER STATEMENT
  '==========================
  '
  '
  '
  '=============================================
  exitap: 'COMPILE TERMINATION AND ERROR HANDLING
  '==============================================
  '
  if ert=0 then
    if nsl then
      ow="" : lbw=""
      select case ctb(nsl-1)
      case 1 : w1="if..end if"
      case 2 : w1="do .. end do"
      case 3 : w1="while .. end while"
      case 4 : w1="for .. next"
      case 5 : w1="Select .. end select"
      end select
      ers="unterminated block at end of script "+w1 : ert=30
    elseif funi then
      ow="" : lbw=""
      ers="unterminated procedure "+funm(funi) : ert=30
    elseif brc then
      ow="" : lbw=""
      ers="unclosed brackets at end of script ("+str(brc)+")" : ert=29
    end if
  end if
  '
  if ert>0 then
    '
    if ert=101 then ers+="Macro undefined or out of scope"
    if ert=102 then ers+="Macro recursion suspected: "
    if ert=103 then ers+="Method/property element not implemented"
    if ert=104 then ers+="Method pointer must have a size of "+str(cpuw)+" bytes"
    '
    if ert=1 then w1="ALERT:" else w1="ERROR:"
    endline(s,i) :    ers =w1+cr+ers+cr
    '
    if len(ow)   then ers+="WORD: "+htb+ow+cr
    'if len(lbw)  then ers+="BELOW:"+htb+lbw+cr
    ers+="LINE: "+htb+lnmks+cr
    if fq        then ers+="FILE: "+htb+ssf(fq-1)+cr
    '
    if vew>=2 then appendt(ers)
    '
  end if
  '
  '
  '
  'REVERT TO DEFAULT PUNCTUATION
  '
  ct2=59
  sr2=58
  '
  '--------------------------------
  'STRUCTURE CODE READ FOR ASSEMBLY
  '================================
  '
  '
  '
  function=PrepExec(independent,cnsl,eord)
  '
  '
  '
  'cleardown_prep:
  '===============
  '
  s="" : t="" : impo=0 : libe=0 : o2h=0 : lbw="" : ipath="" : lpath="" : opns="" : opnsl=""

  '
end function


